Package: vroom
Title: Read and Write Rectangular Text Data Quickly
Version: 1.7.1
Authors@R: c(
    person("Jim", "Hester", role = "aut",
           comment = c(ORCID = "0000-0002-2739-7082")),
    person("Hadley", "Wickham", , "hadley@posit.co", role = "aut",
           comment = c(ORCID = "0000-0003-4757-117X")),
    person("Jennifer", "Bryan", , "jenny@posit.co", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-6983-2759")),
    person("Shelby", "Bearrows", role = "ctb"),
    person("https://github.com/mandreyel/", role = "cph",
           comment = "mio library"),
    person("Jukka", "Jylänki", role = "cph",
           comment = "grisu3 implementation"),
    person("Mikkel", "Jørgensen", role = "cph",
           comment = "grisu3 implementation"),
    person("Posit Software, PBC", role = c("cph", "fnd"), comment = c(ROR = "03wc8by49"))
  )
Description: The goal of 'vroom' is to read and write data (like 'csv',
    'tsv' and 'fwf') quickly. When reading it uses a quick initial
    indexing step, then reads the values lazily , so only the data you
    actually use needs to be read.  The writer formats the data in
    parallel and writes to disk asynchronously from formatting.
License: MIT + file LICENSE
URL: https://vroom.tidyverse.org, https://github.com/tidyverse/vroom
BugReports: https://github.com/tidyverse/vroom/issues
Depends: R (>= 4.1)
Imports: bit64, cli (>= 3.2.0), crayon, glue, hms, lifecycle (>=
        1.0.3), methods, rlang (>= 1.1.0), stats, tibble (>= 2.0.0),
        tidyselect, tzdb (>= 0.1.1), vctrs (>= 0.2.0), withr
Suggests: archive, bench (>= 1.1.0), covr, curl, dplyr, forcats, fs,
        ggplot2, knitr, patchwork, prettyunits, purrr, rmarkdown,
        rstudioapi, scales, spelling, testthat (>= 2.1.0), tidyr,
        utils, waldo, xml2
LinkingTo: cpp11 (>= 0.2.0), progress (>= 1.2.3), tzdb (>= 0.1.1)
VignetteBuilder: knitr
Config/Needs/website: nycflights13, tidyverse/tidytemplate
Config/testthat/edition: 3
Config/testthat/parallel: false
Config/usethis/last-upkeep: 2025-11-25
Copyright: file COPYRIGHTS
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.3.3
Config/build/compilation-database: true
NeedsCompilation: yes
Packaged: 2026-03-30 20:25:37 UTC; jenny
Author: Jim Hester [aut] (ORCID: <https://orcid.org/0000-0002-2739-7082>),
  Hadley Wickham [aut] (ORCID: <https://orcid.org/0000-0003-4757-117X>),
  Jennifer Bryan [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6983-2759>),
  Shelby Bearrows [ctb],
  https://github.com/mandreyel/ [cph] (mio library),
  Jukka Jylänki [cph] (grisu3 implementation),
  Mikkel Jørgensen [cph] (grisu3 implementation),
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Jennifer Bryan <jenny@posit.co>
Repository: CRAN
Date/Publication: 2026-03-31 05:10:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-26 11:09:05 UTC; unix
Archs: vroom.so.dSYM

NAME

    Vroom - Slide Shows in Vim

SYNOPSIS

        > mkdir MySlides    # Make a Directory for Your Slides
        > cd MySlides       # Go In There
        > vroom new         # Create Example Slides File
        > vim slides.vroom  # Edit the File and Add Your Own Slides
        > vroom vroom       # Show Your Slides
        > vroom html        # Publish Your Slides as HTML

DESCRIPTION

    Ever given a Slide Show and needed to switch over to Vim?

    Now you don't ever have to switch again. You're already there.

    Vroom lets you create your slides in a single file using a Wiki-like
    style, much like Spork and Sporx do. The difference is that your slides
    don't compile to HTML or JavaScript or XUL. They get turned into a set
    of files that begin with '0', like '03' or '07c' or '05b.pl'.

    The slides are named in alphabetic order. That means you can bring them
    all into a Vim session with the command: vim 0*. vroom vroom does
    exactly that.

    You can do things like advance to the next slide with the spacebar.
    Vroom creates a file called ./.vimrc with helpful key mappings for
    navigating a slideshow. See [KEY MAPPINGS] below.

    Vroom takes advantage of Vim's syntax highlighting. It also lets you
    run slides that contain code.

    Since Vim is an editor, you can change your slides during the show.

COMMAND USAGE

    vroom has a few command line options:

    vroom new

      Write an example slides.vroom file. This example contains all the
      config options and also examples of all the Vroom syntax features.

    vroom vroom

      Compile (create) the slides files from the input file and start vim
      show.

    vroom compile

      Just compile the slides.

    vroom html

      Publish the slides to HTML, with embedded JavaScript to navigate with
      the spacebar and backspace keys. Created in the html/ subdirectory.

    vroom text

      Publish the slides to plain text. This action uses all the text
      slides in their unsplit form. Created in the text/ subdirectory.

    vroom clean

      Clean up all the compiled output files.

    vroom ghpublish

      Creates a shell script in the current directory, that is intended to
      publish your slides to the special GitHub branch called gh-pages. See
      [GITHUB NOTES] below.

      This command does NOT run the script. It merely creates it for you.
      It is up to you to review the script and run it (if it makes sense on
      your system).

    vroom <action> --skip=#

      The skip option takes a number as its input and skips that number of
      files during compilation. This is useful when you are polishing your
      slides and are finished with the first 50. You can say:

          vroom vroom --skip=50

      and it will start on slide #51.

    vroom <action> --input=<file_name>

      This option lets you specify an alternate input file name, instead of
      the default one, slides.vroom.

INPUT FORMAT

    Here is an example slides.vroom file:

        ---- config
        # These are YAML settings for Vroom
        title: My Spiffy Slideshow
        # height: 84
        # width: 20
        auto_size: 1  # Determines height/width automatically
        # skip: 12      # Skip 12 slides. Useful when making slides.
        ---- center
        My Presentation
    
        by Ingy
        ----
        == Stuff I care about:
    
        * Foo
        +* Bar
        +* Baz
        ---- perl,i10
        # Perl code indented 10 spaces
        use Vroom;
    
        print "Hello World";
        ---- center
        THE END

    A line that starts with == is a header line. It will be centered.

    Lines that begin with a + cause vroom to split the slide there, causing
    an animation effect.

    Lines that begin with a % are slide titles. Titles are completely
    optional. They are used with notes files, and also for the index page
    if you convert to HTML. You can have only one of these per slide.

    A line consisting of nothing but ==== indicates that what follows are
    notes for this slide. Notes are also optional. They are primarily used
    for notes files, but are also included if you convert your presentation
    to HTML. See [SLIDE NOTES] below.

CONFIGURATION OPTIONS

    each slide can have one or more configuration options. Options are a
    comma separated list that follow the ---- header for a slide. Like
    this:

        ---- config
        ---- center
        ---- perl,i20
        ---- include file-name
        ---- replace
        ---- skip

    config

      The slide is really a yaml configuration. It will not be displayed in
      the presentation, but will tell vroom what to do from that point
      forward.

      Usually, a config slide is the first thing in your input file, but
      you can use more than one config slide.

    center

      Center the contents of the slide.

    i##

      'i' followed by a number means to indent the contents by the number
      of characters.

    i-##

      'i' followed by a negative number means to strip that number of
      leading characters from the contents of the slide. This can be useful
      if you need to have characters special to Vroom at the beginning of
      your lines, for example if the contents of your slide is unified diff
      output.

    perl,ruby,python,php,javascript,haskell,actionscript,html,yaml,xml,json,make,shell,diff

      Specifies that the slide is one of those syntaxen, and that the
      appropriate file extension will be used, thus causing vim to syntax
      highlight the slide.

    .<ext>

      You can specify any extension by putting a period in front of it.
      Like .md for MarkDown.

    include file-path-name

      Replace the line with the contents of the specified file. Useful to
      include long files that would make your slides file unruly.

    replace

      With the replace option, the '+' animations in the slide cause the
      content to replace the previous partial slide, rather than append to
      it.

    skip

      Ignore the following slide completely.

 Config Slide Options

    You can specify the following configuration options in a config slide:

    title: <text>

      The title of your presentation.

    height: <number>

      The number of lines in the terminal you plan to use when presenting
      the show. Used for centering the content.

    width: <number>

      The number of columns in the terminal you plan to use when presenting
      the show. Used for centering the content.

    auto_size: <0|1>

      When set to 1, the height/width options above will be ignored and
      determined each time you start the slideshow.

    indent: <number>

      All slides will be indented by this number of spaces by default.

    list_indent: <number>

      Auto detect slides that have lists in them, and indent them by the
      specified number of columns.

    vim: <name>

      You can specify the name of the vim executable to use. If you set
      this to gvim special gvim support will be provided.

    GVim options

      The following options are available, if your vim option is set to
      gvim.

          fuopt: maxhorz,maxvert
          guioptions: egmLtT
          guicursor: a:blinkon0-ver25-Cursor
          guifont: Bitstream_Vera_Sans_Mono:h18

      These are all documented by gvim's help system. Please see that for
      more information.

SLIDE NOTES

    You can add notes to each slide, if you like. When you create your
    presentation (with vroom compile or vroom vroom), a file called
    notes.txt will be created containing all your notes, along with
    indications of when to proceed to the next slide. If you give any of
    your slides titles, they will also be put into the notes file in order
    to help you keep track of where you are in the presentation.

    You can print out your notes file, or simply bring it up on a separate
    device (such as your smartphone). The notes are not part of the
    presentation; they are just for you.

    However, if you convert your presentation to HTML, the notes will be
    included in a smaller font below each slide. This is useful when
    sharing your slides with others who were not present at the
    presentation.

KEY MAPPINGS

    These are the standard key mappings specified in the local .vimrc.

    <SPACE>

      Advance one slide.

    <BACKSPACE>

      Go back one slide.

    ??

      Bring up the help screen.

    RR (or R -- deprecated)

      If the current slide is declared Perl, Python, Ruby, PHP, Haskell or
      JavaScript, then run it accordingly.

    QQ

      Quit Vroom.

    VV

      Since these vim options apply while editing the slides.vroom file
      (yes, beware), you can use this shortcut to launch Vroom on the
      current contents whilst writing your slides.

    EE

      Edit the file that the cursor is on the filename of.

      You can put file path names in your slides, and then easily bring
      them up during your presentation.

    OO

      On a Mac, run the OS X open command on the argument that your cursor
      is on.

      For instance, if you want to display an image, you could put the file
      path of the image in your slide, then use OO to launch it.

CUSTOM CONFIGURATION

    You can create a file called .vroom/vimrc in your home directory. If
    vroom sees this file, it will append it onto every local .vimrc file it
    creates.

    Use this file to specify your own custom vim settings for all your
    vroom presentations.

    You can also create a file called .vroom/gvimrc for gvim overrides, if
    you are using gvim.

USING MACVIM OR GVIM

    If you have a Mac, you really should try using MacVim for Vroom slide
    shows. You can run it in fullscreen mode, and it looks kinda
    professional.

    To do this, set the vim option in your config section:

        vim: gvim

    NOTE: On my Mac, I have gvim symlinked to mvim, which is a smart
    startup script that ships with MacVim. Ping me, if you have questions
    about this setup.

GITHUB NOTES

    I(ngy) put all my public talks on github. I think it is an excellent
    way to publish your slides and give people a url to review them. Here
    are the things I do to make this work well:

      * I create a repository for every presentation I give. The name of
      the repo is of the form <topic>-<event/time>-talk. You can go to
      http://github.com/ingydotnet/ and look for the repos ending with
      -talk.

      * GitHub has a feature called gh-pages that you can use to create a
      website for each github repo. I use this feature to publish the html
      output of my talk. I do something like this:

          vroom html
          mv html /tmp
          git branch gh-pages
          git checkout gh-pages
          rm -r *.html
          mv /tmp/html/* .
          rmdir /tmp/html
          git add .
          git commit -m 'Publish my slides'
          git push origin gh-pages
          git checkout master

      * Vroom comes with a ghpublish option. If you run:

          > vroom ghpublish

      it will generate a script called ghpublish that contains commands
      like the ones above, to publish your slides to a gh-pages branch.

      * If my repo is called vroom-yapcna2009-talk, then after I publish
      the talk to the gh-pages branch, it will be available as
      http://ingydotnet.github.com/vroom-yapcna2009-talk. I then link this
      url from http://github.com/ingydotnet/vroom-yapcna2009-talk as the
      Homepage url.

    You can see an example of a talk published to HTML and posted via
    gh-pages at http://ingydotnet.github.com/vroom-pm/.

<!-- README.md is generated from README.Rmd. Please edit that file -->

# 🏎💨vroom <a href='https://vroom.tidyverse.org'><img src='man/figures/logo.png' align="right" height="135"  alt="vroom package hex logo"/></a>

<!-- badges: start -->

[![R-CMD-check](https://github.com/tidyverse/vroom/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/tidyverse/vroom/actions/workflows/R-CMD-check.yaml)
[![CRAN
status](https://www.r-pkg.org/badges/version/vroom)](https://cran.r-project.org/package=vroom)
[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![Codecov test
coverage](https://codecov.io/gh/tidyverse/vroom/graph/badge.svg)](https://app.codecov.io/gh/tidyverse/vroom)
<!-- badges: end -->

The fastest delimited reader for R, **1.23 GB/sec**.

<img src="https://raw.githubusercontent.com/tidyverse/vroom/main/img/taylor.gif" align="right" alt="Animated GIF of Taylor Swift in a car" />

But that’s impossible! How can it be [so
fast](https://vroom.tidyverse.org/articles/benchmarks.html)?

vroom doesn’t stop to actually *read* all of your data, it simply
indexes where each record is located so it can be read later. The
vectors returned use the [Altrep
framework](https://svn.r-project.org/R/branches/ALTREP/ALTREP.html) to
lazily load the data on-demand when it is accessed, so you only pay for
what you use. This lazy access is done automatically, so no changes to
your R data-manipulation code are needed.

vroom also uses multiple threads for indexing, materializing
non-character columns, and when writing to further improve performance.

| package    | version | time (sec) | speedup |    throughput |
|:-----------|--------:|-----------:|--------:|--------------:|
| vroom      |   1.5.1 |       1.36 |   53.30 |   1.23 GB/sec |
| data.table |  1.14.0 |       5.83 |   12.40 | 281.65 MB/sec |
| readr      |   1.4.0 |      37.30 |    1.94 |  44.02 MB/sec |
| read.delim |   4.1.0 |      72.31 |    1.00 |  22.71 MB/sec |

## Features

vroom has nearly all of the parsing features of
[readr](https://readr.tidyverse.org) for delimited and fixed width
files, including

- delimiter guessing\*
- custom delimiters (including multi-byte\* and Unicode\* delimiters)
- specification of column types (including type guessing)
  - numeric types (double, integer, big integer\*, number)
  - logical types
  - datetime types (datetime, date, time)
  - categorical types (characters, factors)
- column selection, like `dplyr::select()`\*
- skipping headers, comments and blank lines
- quoted fields
- double and backslashed escapes
- whitespace trimming
- windows newlines
- [reading from multiple files or
  connections\*](#reading-multiple-files)
- embedded newlines in headers and fields\*\*
- writing delimited files with as-needed quoting.
- robust to invalid inputs (vroom has been extensively tested with the
  [afl](https://lcamtuf.coredump.cx/afl/) fuzz tester)\*.

\* *these are additional features not in readr.*

\*\* *requires `num_threads = 1`.*

## Installation

Install vroom from CRAN with:

``` r
install.packages("vroom")
```

Alternatively, if you need the development version from
[GitHub](https://github.com/) install it with:

``` r
# install.packages("pak")
pak::pak("tidyverse/vroom")
```

## Usage

See [getting started](https://vroom.tidyverse.org/articles/vroom.html)
to jump start your use of vroom!

vroom uses the same interface as readr to specify column types.

``` r
vroom::vroom(
  "mtcars.tsv",
  col_types = list(
    cyl = "i",
    gear = "f",
    hp = "i",
    disp = "_",
    drat = "_",
    vs = "l",
    am = "l",
    carb = "i"
  )
)
#> # A tibble: 32 × 10
#>   model           mpg   cyl    hp    wt  qsec vs    am    gear   carb
#>   <chr>         <dbl> <int> <int> <dbl> <dbl> <lgl> <lgl> <fct> <int>
#> 1 Mazda RX4      21       6   110  2.62  16.5 FALSE TRUE  4         4
#> 2 Mazda RX4 Wag  21       6   110  2.88  17.0 FALSE TRUE  4         4
#> 3 Datsun 710     22.8     4    93  2.32  18.6 TRUE  TRUE  4         1
#> # ℹ 29 more rows
```

## Reading multiple files

vroom natively supports reading from multiple files (or even multiple
connections!).

First we generate some files to read by splitting the nycflights dataset
by airline. For the sake of the example, we’ll just take the first 2
lines of each file.

``` r
library(nycflights13)
purrr::iwalk(
  split(flights, flights$carrier),
  \(x, y) {
    x$carrier[[1]]
    vroom::vroom_write(
      head(x, 2),
      glue::glue("flights_{y}.tsv"),
      delim = "\t"
    )
  }
)
```

Then we can efficiently read them into one tibble by passing the
filenames directly to vroom. The `id` argument can be used to request a
column that reveals the filename that each row originated from.

``` r
files <- fs::dir_ls(glob = "flights*tsv")
files
#> flights_9E.tsv flights_AA.tsv flights_AS.tsv flights_B6.tsv flights_DL.tsv 
#> flights_EV.tsv flights_F9.tsv flights_FL.tsv flights_HA.tsv flights_MQ.tsv 
#> flights_OO.tsv flights_UA.tsv flights_US.tsv flights_VX.tsv flights_WN.tsv 
#> flights_YV.tsv
vroom::vroom(files, id = "source")
#> Rows: 32 Columns: 20
#> ── Column specification ────────────────────────────────────────────────────────
#> Delimiter: "\t"
#> chr   (4): carrier, tailnum, origin, dest
#> dbl  (14): year, month, day, dep_time, sched_dep_time, dep_delay, arr_time, ...
#> dttm  (1): time_hour
#> 
#> ℹ Use `spec()` to retrieve the full column specification for this data.
#> ℹ Specify the column types or set `show_col_types = FALSE` to quiet this message.
#> # A tibble: 32 × 20
#>   source          year month   day dep_time sched_dep_time dep_delay arr_time
#>   <chr>          <dbl> <dbl> <dbl>    <dbl>          <dbl>     <dbl>    <dbl>
#> 1 flights_9E.tsv  2013     1     1      810            810         0     1048
#> 2 flights_9E.tsv  2013     1     1     1451           1500        -9     1634
#> 3 flights_AA.tsv  2013     1     1      542            540         2      923
#> # ℹ 29 more rows
#> # ℹ 12 more variables: sched_arr_time <dbl>, arr_delay <dbl>, carrier <chr>,
#> #   flight <dbl>, tailnum <chr>, origin <chr>, dest <chr>, air_time <dbl>,
#> #   distance <dbl>, hour <dbl>, minute <dbl>, time_hour <dttm>
```

## Learning more

- [Getting started with
  vroom](https://vroom.tidyverse.org/articles/vroom.html)
- [📽 vroom: Because Life is too short to read
  slow](https://www.youtube.com/watch?v=RA9AjqZXxMU&t=10s) -
  Presentation at UseR!2019
  ([slides](https://speakerdeck.com/jimhester/vroom))
- [📹 vroom: Read and write rectangular data
  quickly](https://www.youtube.com/watch?v=ZP_y5eaAc60) - a video tour
  of the vroom features.

## Benchmarks

The speed quoted above is from a real 1.53G dataset with 14,388,451 rows
and 11 columns, see the [benchmark
article](https://vroom.tidyverse.org/articles/benchmarks.html) for full
details of the dataset and
[bench/](https://github.com/tidyverse/vroom/tree/main/inst/bench) for
the code used to retrieve the data and perform the benchmarks.

# Environment variables

In addition to the arguments to the `vroom()` function, you can control
the behavior of vroom with a few environment variables. Generally these
will not need to be set by most users.

- `VROOM_TEMP_PATH` - Path to the directory used to store temporary
  files when reading from a R connection. If unset defaults to the R
  session’s temporary directory (`tempdir()`).
- `VROOM_THREADS` - The number of processor threads to use when indexing
  and parsing. If unset defaults to `parallel::detectCores()`.
- `VROOM_SHOW_PROGRESS` - Whether to show the progress bar when
  indexing. Regardless of this setting the progress bar is disabled in
  non-interactive settings, R notebooks, when running tests with
  testthat and when knitting documents.
- `VROOM_CONNECTION_SIZE` - The size (in bytes) of the connection buffer
  when reading from connections (default is 128 KiB).
- `VROOM_WRITE_BUFFER_LINES` - The number of lines to use for each
  buffer when writing files (default: 1000).

There is also a family of variables to control use of the Altrep
framework. These variables can take one of these values: `true`,
`false`, `TRUE`, `FALSE`, `1`, or `0`.

- `VROOM_USE_ALTREP_NUMERICS` - If true, use Altrep for *all* numeric
  types (default `false`).

There are also individual variables for each type. Currently only
`VROOM_USE_ALTREP_CHR` defaults to `true`.

- `VROOM_USE_ALTREP_CHR`
- `VROOM_USE_ALTREP_FCT`
- `VROOM_USE_ALTREP_INT`
- `VROOM_USE_ALTREP_BIG_INT`
- `VROOM_USE_ALTREP_DBL`
- `VROOM_USE_ALTREP_NUM`
- `VROOM_USE_ALTREP_LGL`
- `VROOM_USE_ALTREP_DTTM`
- `VROOM_USE_ALTREP_DATE`
- `VROOM_USE_ALTREP_TIME`

## Thanks

- [Gabe Becker](https://github.com/gmbecker), [Luke
  Tierney](https://homepage.divms.uiowa.edu/~luke/) and [Tomas
  Kalibera](https://github.com/kalibera) for conceiving, Implementing
  and maintaining the [Altrep
  framework](https://svn.r-project.org/R/branches/ALTREP/ALTREP.html)
- [Romain François](https://github.com/romainfrancois), whose
  [Altrepisode](https://web.archive.org/web/20200315075838/https://purrple.cat/blog/2018/10/14/altrep-and-cpp/)
  package and [related
  blog-posts](https://web.archive.org/web/20200315075838/https://purrple.cat/blog/2018/10/14/altrep-and-cpp/)
  were a great guide for creating new Altrep objects in C++.
- [Matt Dowle](https://github.com/mattdowle) and the rest of the
  [Rdatatable](https://github.com/Rdatatable) team,
  `data.table::fread()` is blazing fast and great motivation to see how
  fast we could go faster!

{
  library(vroom)
  data <- vroom(file, col_types = c(pickup_datetime = "c"))
  vroom:::vroom_materialize(data, replace = TRUE)
}

write.table(
  data,
  tempfile(fileext = ".tsv"),
  sep = "\t",
  quote = FALSE,
  row.names = FALSE
)

{
  library(vroom)
  data <- vroom(file, col_types = c(pickup_datetime = "c"))
  vroom:::vroom_materialize(data, replace = TRUE)
}

vroom_write(
  data,
  pipe(sprintf("pigz > %s", tempfile(fileext = ".gz"))),
  delim = "\t"
)

{
  library(vroom)
  data <- vroom(file, col_types = c(pickup_datetime = "c"))
  vroom:::vroom_materialize(data, replace = TRUE)
}

data.table::fwrite(data, tempfile(fileext = ".gz"), sep = "\t", nThread = 1)

({})
x <- read.delim(
  file,
  sep = ",",
  quote = "",
  na.strings = NULL,
  stringsAsFactors = FALSE
)
print(head(x, 10))
a <- head(x)
b <- tail(x)
c <- x[sample(NROW(x), 100), ]
d <- x[x$payment_type == "UNK", ]
e <- tapply(x$tip_amount, x$payment_type, mean)

#!/usr/bin/env Rscript

args <- commandArgs(trailingOnly = TRUE)
source_file <- args[[1]]
out_file <- args[[2]]

file <- args[-c(1:2)]

cat(source_file, "\n")
out <- bench::workout_expressions(as.list(parse(
  source_file,
  keep.source = FALSE
)))

x <- vroom::vroom(file, col_types = list())

out$size <- sum(file.size(file))
out$rows <- nrow(x)
out$cols <- ncol(x)
out$process <- as.numeric(out$process)
out$real <- as.numeric(out$real)
out$max_memory <- as.numeric(bench::bench_process_memory()[["max"]])

vroom::vroom_write(out, out_file)

({
  library(vroom)
  library(dplyr)
})
x <- vroom(
  file,
  trim_ws = FALSE,
  quote = "",
  escape_double = FALSE,
  na = character()
)
print(x)
a <- head(x)
b <- tail(x)
c <- sample_n(x, 100)
d <- filter(x, X1 > 3)
e <- group_by(x, as.integer(X2)) %>% summarise(avg_X1 = mean(X1))

library(vroom)
library(dplyr)
library(fs)
library(purrr)
library(tidyr)

summarise_dir <- function(dir, desc) {
  out_file <- path(path_dir(dir), path_ext_set(path_file(dir), "tsv"))
  col_types <- cols(
    exprs = col_character(),
    process = col_character(),
    real = col_character(),
    size = col_double(),
    rows = col_double(),
    cols = col_double()
  )

  dir_ls(dir, glob = "*tsv") %>%
    discard(~ endsWith(.x, "input.tsv")) %>%
    vroom(id = "path", col_types = col_types) %>%
    mutate(path = path_ext_remove(path_file(path))) %>%
    group_by(path) %>%
    mutate(op = desc) %>%
    separate(path, c("reading_package", "manip_package"), "-") %>%
    pivot_longer(
      .,
      cols = c(process, real),
      names_to = "type",
      values_to = "time"
    ) %>%
    select(
      reading_package,
      manip_package,
      op,
      type,
      time,
      size,
      max_memory,
      rows,
      cols
    ) %>%
    vroom_write(out_file, delim = "\t")
}

summarise_dir(
  here::here("inst/bench/all_numeric-long"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)
summarise_dir(
  here::here("inst/bench/all_numeric-wide"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)
summarise_dir(
  here::here("inst/bench/all_character-long"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)
summarise_dir(
  here::here("inst/bench/all_character-wide"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)
summarise_dir(
  here::here("inst/bench/taxi"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)
summarise_dir(
  here::here("inst/bench/taxi_multiple"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)
summarise_dir(here::here("inst/bench/taxi_writing"), c("setup", "writing"))
summarise_dir(
  here::here("inst/bench/fwf"),
  c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
)

({
  library(vroom)
  library(dplyr)
})
x <- vroom(
  file,
  id = "path",
  col_types = c(pickup_datetime = "c"),
  trim_ws = FALSE,
  quote = "",
  escape_double = FALSE,
  na = character(),
  altrep = FALSE
)
print(x)
a <- head(x)
b <- tail(x)
c <- sample_n(x, 100)
d <- filter(x, payment_type == "UNK")
e <- group_by(x, payment_type) %>% summarise(avg_tip = mean(tip_amount))

library(vroom)
x <- vroom_fwf(file, fields, col_types = types)
print(head(x, 10))
a <- head(x)
b <- tail(x)
c <- x[sample(NROW(x), 100), ]
d <- x[x$PERSONS == "06", ]
e <- tapply(x$TOTPUMA5, x$STATE, mean)

({
  library(readr)
  library(dplyr)
  library(purrr)
})
x <- map_dfr(
  set_names(file),
  .id = "path",
  ~ read_csv(
    .x,
    col_types = c(pickup_datetime = "c"),
    quote = "",
    trim_ws = FALSE,
    na = character()
  )
)
print(x)
a <- head(x)
b <- tail(x)
c <- sample_n(x, 100)
d <- filter(x, payment_type == "UNK")
e <- group_by(x, payment_type) %>% summarise(avg_tip = mean(tip_amount))

library(data.table)
x <- rbindlist(
  idcol = "path",
  lapply(
    stats::setNames(file, file),
    fread,
    sep = ",",
    quote = "",
    strip.white = FALSE,
    na.strings = NULL
  )
)
print(x)
a <- head(x)
b <- tail(x)
c <- x[sample(NROW(x), 100), ]
d <- x[payment_type == "UNK", ]
e <- x[, .(mean(tip_amount)), by = payment_type]

#' Generate individual vectors of the types supported by vroom
#'
#' @param n The size of the vector to generate
#' @param min The minimum range for the vector
#' @param max The maximum range for the vector
#' @param values The explicit values to use.
#' @param f The random function to use.
#' @inheritParams base::sample.int
#' @param ... Additional arguments passed to internal generation functions
#' @name generators
#' @examples
#' # characters
#' gen_character(4)
#'
#' # factors
#' gen_factor(4)
#'
#' # logical
#' gen_logical(4)
#'
#' # numbers
#' gen_double(4)
#' gen_integer(4)
#'
#' # temporal data
#' gen_time(4)
#' gen_date(4)
#' gen_datetime(4)
#' @export
gen_character <- function(
  n,
  min = 5,
  max = 25,
  values = c(letters, LETTERS, 0:9),
  ...
) {
  if (min > max) {
    max <- min
  }

  # The seed for the C++ RNG used is an unsigned 32 bit integer, which is why I
  # multiply int max by 2. Possibly an off by one error here though...
  seeds <- sample.int(2 * .Machine$integer.max, 2)

  gen_character_(
    n,
    min,
    max,
    paste(values, collapse = ""),
    seeds[[1]],
    seeds[[2]]
  )
}

#' @rdname generators
#' @export
gen_double <- function(n, f = stats::rnorm, ...) {
  f(n, ...)
}

#' @rdname generators
#' @export
gen_number <- gen_double

#' @rdname generators
#' @export
gen_integer <- function(
  n,
  min = 1L,
  max = .Machine$integer.max,
  prob = NULL,
  ...
) {
  max <- max - min + 1L
  sample.int(max, size = n, replace = TRUE, prob = prob) + min - 1L
}

#' @rdname generators
#' @param num_levels The number of factor levels to generate
#' @param ordered Should the factors be ordered factors?
#' @param levels The explicit levels to use, if `NULL` random levels are generated using [gen_name()].
#' @export
gen_factor <- function(
  n,
  levels = NULL,
  ordered = FALSE,
  num_levels = gen_integer(1L, 1L, 25L),
  ...
) {
  if (is.null(levels)) {
    levels <- gen_name(num_levels)
  }

  res <- gen_integer(n, max = length(levels), ...)

  attr(res, "levels") <- levels
  if (ordered) {
    class(res) <- c("ordered", "factor")
  } else {
    class(res) <- "factor"
  }
  res
}

#' @rdname generators
#' @param fractional Whether to generate times with fractional seconds
#' @export
gen_time <- function(
  n,
  min = 0,
  max = hms::hms(days = 1),
  fractional = FALSE,
  ...
) {
  res <- hms::hms(seconds = stats::runif(n, min = min, max = max))
  if (!fractional) {
    res <- hms::as_hms(floor(res))
  }
  res
}

#' @rdname generators
#' @export
gen_date <- function(
  n,
  min = as.Date("2001-01-01"),
  max = as.Date("2021-01-01"),
  ...
) {
  structure(as.numeric(gen_integer(n, min = min, max = max)), class = "Date")
}

#' @rdname generators
#' @param tz The timezone to use for dates
#' @export
gen_datetime <- function(
  n,
  min = as.POSIXct("2001-01-01"),
  max = as.POSIXct("2021-01-01"),
  tz = "UTC",
  ...
) {
  structure(
    stats::runif(n, min = min, max = max),
    class = c("POSIXct", "POSIXt"),
    tzone = tz
  )
}

#' @rdname generators
#' @export
gen_logical <- function(n, ...) {
  c(TRUE, FALSE)[sample.int(n = 2, n, replace = TRUE)]
}

all_col_types <- tibble::tribble(
  ~type       , ~class      ,
  "character" , "character" ,
  "factor"    , "character" ,
  "double"    , "numeric"   ,
  "integer"   , "numeric"   ,
  "number"    , "numeric"   ,
  "date"      , "temporal"  ,
  "datetime"  , "temporal"  ,
  "time"      , "temporal"  ,
)

#' Generate a random tibble
#'
#' This is useful for benchmarking, but also for bug reports when you cannot
#' share the real dataset.
#'
#' There is also a family of functions to generate individual vectors of each
#' type.
#'
#' @param rows Number of rows to generate
#' @param cols Number of columns to generate, if `NULL` this is derived from `col_types`.
#' @param missing The percentage (from 0 to 1) of missing data to use
#' @seealso [generators] to generate individual vectors.
#' @inheritParams vroom
#' @examples
#' # random 10 x 5 table with random column types
#' rand_tbl <- gen_tbl(10, 5)
#' rand_tbl
#'
#' # all double 25 x 4 table
#' dbl_tbl <- gen_tbl(25, 4, col_types = "dddd")
#' dbl_tbl
#'
#' # Use the dots in long form column types to change the random function and options
#' types <- rep(times = 4, list(col_double(f = stats::runif, min = -10, max = 25)))
#' types
#' dbl_tbl2 <- gen_tbl(25, 4, col_types = types)
#' dbl_tbl2
#' @export
gen_tbl <- function(
  rows,
  cols = NULL,
  col_types = NULL,
  locale = default_locale(),
  missing = 0
) {
  if (is.null(cols) && is.null(col_types)) {
    cli::cli_abort("One of {.arg cols} or {.arg col_types} must be set.")
  }

  spec <- as.col_spec(col_types)

  if (is.null(cols)) {
    cols <- length(spec$cols)
  }

  nms <- make_names(names(spec$cols), cols)

  specs <- col_types_standardise(
    spec,
    length(nms),
    nms,
    vroom_enquo(quo(NULL)),
    "unique"
  )
  res <- vector("list", cols)
  for (i in seq_len(cols)) {
    type <- sub("collector_", "", class(specs$cols[[i]])[[1]])
    if (type == "guess") {
      type <- sample(all_col_types[["type"]], 1)
      specs$cols[[i]] <- do.call(paste0("col_", type), list())
    }
    fun_nme <- paste0("gen_", type)
    res[[i]] <- do.call(fun_nme, c(rows, specs$cols[[i]]))
  }

  if (missing > 0) {
    res[] <- lapply(res, function(x) {
      x[sample(
        c(TRUE, FALSE),
        size = rows,
        prob = c(missing, 1 - missing),
        replace = TRUE
      )] <- NA
      x
    })
  }
  names(res) <- nms
  attr(res, "spec") <- specs
  tibble::as_tibble(res)
}

# Name and adjective list from https://github.com/rstudio/cranwhales/blob/93349fe1bc790f115a3d56660b6b99ffe258d9a2/random-names.R
#' @rdname generators
#' @export
gen_name <- local({
  # This will run during build / installation, but that is OK
  adjectives <- readLines(system.file(
    "words",
    "adjectives.txt",
    package = "vroom"
  ))
  animals <- readLines(system.file("words", "animals.txt", package = "vroom"))

  function(n) {
    paste0(
      sample(adjectives, n, replace = TRUE),
      "_",
      sample(animals, n, replace = TRUE)
    )
  }
})

## -----------------------------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(ggplot2)
library(forcats)
library(dplyr)
library(tidyr)
library(fs)

pretty_sec <- function(x) {
  x[!is.na(x)] <- prettyunits::pretty_sec(x[!is.na(x)])
  x
}

pretty_lgl <- function(x) {
  case_when(
    x == TRUE ~ "TRUE",
    x == FALSE ~ "FALSE",
    TRUE ~ ""
  )
}

read_benchmark <- function(file, desc) {
  vroom::vroom(file, col_types = c("ccccddddd")) |>
    filter(op != "setup") |>
    mutate(
      altrep = case_when(
        grepl("^vroom_no_altrep", reading_package) ~ FALSE,
        grepl("^vroom", reading_package) ~ TRUE,
        TRUE ~ NA
      ),
      reading_package = case_when(
        grepl("^vroom", reading_package) ~ "vroom",
        TRUE ~ reading_package
      ),
    label = fct_reorder(
      glue::glue("{reading_package}{altrep}\n{manip_package}",
        altrep = ifelse(is.na(altrep), "", glue::glue("(altrep = {altrep})"))
      ),
      case_when(type == "real" ~ time, TRUE ~ 0),
      sum),
    op = factor(op, desc)
  )
}

generate_subtitle <- function(data) {
  rows <- scales::comma(data$rows[[1]])
  cols <- scales::comma(data$cols[[1]])
  size <- fs_bytes(data$size[[1]])
  glue::glue("{rows} x {cols} - {size}B")
}

plot_benchmark <- function(data, title) {

  subtitle <- generate_subtitle(data)
  data <- data |>
    filter(reading_package != "read.delim", type == "real")

  p1 <- data |>
    ggplot() +
    geom_bar(aes(x = label, y = time, fill = op, group = label), stat = "identity") +
    scale_fill_brewer(type = "qual", palette = "Set2") +
    scale_y_continuous(labels = scales::number_format(suffix = "s")) +
    coord_flip() +
    labs(title = title, subtitle = subtitle, x = NULL, y = NULL, fill = NULL) +
    theme(legend.position = "bottom")

  p2 <- data |>
    group_by(label) |>
    summarise(max_memory = max(max_memory)) |>
    ggplot() +
    geom_bar(aes(x = label, y = max_memory / (1024 * 1024)), stat = "identity") +
    scale_y_continuous(labels = scales::number_format(suffix = "Mb")) +
    coord_flip() +
    labs(title = "Maximum memory usage", x = NULL, y = NULL) +
    theme(axis.text.y = element_blank(), axis.ticks.y = element_blank())

  library(patchwork)
  p1 + p2 + plot_layout(widths = c(2, 1))
}

make_table <- function(data) {
  data |>
    filter(type == "real") |>
    select(-label, -size, -type, -rows, -cols) |>
    spread(op, time) |>
    mutate(
      total = read + print + head + tail + sample + filter + aggregate,
      max_memory = as.character(bench::as_bench_bytes(max_memory))
    ) |>
    arrange(desc(total)) |>
    mutate_if(is.numeric, pretty_sec) |>
    mutate_if(is.logical, pretty_lgl) |>
    select(reading_package, manip_package, altrep, max_memory, everything()) |>
    rename(
      "reading\npackage" = reading_package,
      "manipulating\npackage" = manip_package,
      memory = max_memory
    ) |>
    knitr::kable(digits = 2, align = "r", format = "html")
}

desc <- c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")

## -----------------------------------------------------------------------------
taxi <- read_benchmark(path_package("vroom", "bench", "taxi.tsv"), desc)

plot_benchmark(taxi, "Time to analyze taxi trip data")

make_table(taxi)

## -----------------------------------------------------------------------------
all_num <- read_benchmark(path_package("vroom", "bench", "all_numeric-long.tsv"), desc)

plot_benchmark(all_num, "Time to analyze long all numeric data")

make_table(all_num)

## -----------------------------------------------------------------------------
all_num_wide <- read_benchmark(path_package("bench", "all_numeric-wide.tsv", package = "vroom"), desc)

plot_benchmark(all_num_wide, "Time to analyze wide all numeric data")

make_table(all_num_wide)

## -----------------------------------------------------------------------------
all_chr <- read_benchmark(path_package("vroom", "bench", "all_character-long.tsv"), desc)

plot_benchmark(all_chr, "Time to analyze long all character data")

make_table(all_chr)

## -----------------------------------------------------------------------------
all_chr_wide <- read_benchmark(path_package("vroom", "bench", "all_character-wide.tsv"), desc)

plot_benchmark(all_chr_wide, "Time to analyze wide all character data")

make_table(all_chr_wide)

## -----------------------------------------------------------------------------
mult <- read_benchmark(path_package("vroom", "bench", "taxi_multiple.tsv"), desc)

## -----------------------------------------------------------------------------
plot_benchmark(mult, "Time to analyze multiple file data")

make_table(mult)

## -----------------------------------------------------------------------------
fwf <- read_benchmark(path_package("vroom", "bench", "fwf.tsv"), desc)

## -----------------------------------------------------------------------------
plot_benchmark(fwf, "Time to analyze fixed width data")

make_table(fwf)

## -----------------------------------------------------------------------------
taxi_writing <- read_benchmark(path_package("vroom", "bench", "taxi_writing.tsv"), c("setup", "writing")) |>
  rename(
    package = reading_package,
    compression = manip_package
  ) |> mutate(
    package = factor(package, c("base", "readr", "data.table", "vroom")),
    compression = factor(compression, rev(c("gzip", "multithreaded_gzip", "zstandard", "uncompressed")))
  ) |> filter(type == "real")

subtitle <- generate_subtitle(taxi_writing)

taxi_writing |>
  ggplot(aes(x = compression, y = time, fill = package)) +
  geom_bar(stat = "identity", position = position_dodge2(reverse = TRUE, padding = .05)) +
  scale_fill_brewer(type = "qual", palette = "Set2") +
  scale_y_continuous(labels = scales::number_format(suffix = "s")) +
  theme(legend.position = "bottom") +
  coord_flip() +
  labs(title = "Writing taxi trip data", subtitle = subtitle, x = NULL, y = NULL, fill = NULL)

taxi_writing |>
  select(-size, -op, -rows, -cols, -type, -altrep, -label, -max_memory) |>
  mutate_if(is.numeric, pretty_sec) |>
  pivot_wider(names_from = package, values_from = time) |>
  arrange(desc(compression)) |>
  knitr::kable(digits = 2, align = "r", format = "html")

## -----------------------------------------------------------------------------
si <- vroom::vroom(path_package("vroom", "bench", "session_info.tsv"))
class(si) <- c("packages_info", "data.frame")
select(as.data.frame(si), package, version = ondiskversion, date, source) |>
  knitr::kable()

({
  library(readr)
  library(dplyr)
})
x <- read_tsv(file, trim_ws = FALSE, quote = "", na = character())
print(x)
a <- head(x)
b <- tail(x)
c <- sample_n(x, 100)
d <- filter(x, X1 == "helpless_sheep")
e <- group_by(x, X1) %>% summarise(avg_nchar = mean(nchar(X2)))

library(data.table)
x <- fread(file, sep = "\t", quote = "", strip.white = FALSE, na.strings = NULL)
print(x)
a <- head(x)
b <- tail(x)
c <- x[sample(NROW(x), 100), ]
d <- x[X1 == "helpless_sheep", ]
e <- x[, .(mean(nchar(X2))), by = X1]

.onUnload <- function(libpath) {
  library.dynam.unload("vroom", libpath)
}

.onLoad <- function(...) {
  tzdb::tzdb_initialize()

  # only register conflicting S3 methods if readr is not already loaded.
  if (!"readr" %in% loadedNamespaces()) {
    s3_register("base::format", "col_spec")
    s3_register("base::print", "col_spec")
    s3_register("base::print", "collector")
    s3_register("base::print", "date_names")
    s3_register("base::print", "locale")
    s3_register("utils::str", "col_spec")
    s3_register("base::all.equal", "spec_tbl_df")
    s3_register("base::as.data.frame", "spec_tbl_df")
    s3_register("tibble::as_tibble", "spec_tbl_df")
    s3_register("testthat::compare", "spec_tbl_df")
    s3_register("waldo::compare_proxy", "spec_tbl_df")
  }
}

.conflicts.OK <- TRUE

s3_register <- function(generic, class, method = NULL) {
  stopifnot(is.character(generic), length(generic) == 1)
  stopifnot(is.character(class), length(class) == 1)

  pieces <- strsplit(generic, "::")[[1]]
  stopifnot(length(pieces) == 2)
  package <- pieces[[1]]
  generic <- pieces[[2]]

  if (is.null(method)) {
    method <- get(paste0(generic, ".", class), envir = parent.frame())
  }
  stopifnot(is.function(method))

  if (package %in% loadedNamespaces()) {
    registerS3method(generic, class, method, envir = asNamespace(package))
  }

  # Always register hook in case package is later unloaded & reloaded
  setHook(
    packageEvent(package, "onLoad"),
    function(...) {
      registerS3method(generic, class, method, envir = asNamespace(package))
    }
  )
}

library(vroom)
x <- vroom(
  file,
  col_types = c(pickup_datetime = "c"),
  trim_ws = FALSE,
  quote = "",
  escape_double = FALSE,
  na = character()
)
print(x)
a <- head(x)
b <- tail(x)
c <- x[sample(NROW(x), 100), ]
d <- x[x$payment_type == "UNK", ]
e <- tapply(x$tip_amount, x$payment_type, mean)

{
  library(vroom)
  data <- vroom(file, col_types = c(pickup_datetime = "c"))
  vroom:::vroom_materialize(data, replace = TRUE)
}

{
  con <- pipe(sprintf("pigz > %s", tempfile(fileext = ".gz")), "wb")
  write.table(data, con, sep = "\t", quote = FALSE, row.names = FALSE)
  close(con)
}

#' @keywords internal
#' @aliases vroom-package
#' @useDynLib vroom, .registration = TRUE
"_PACKAGE"

## usethis namespace: start
#' @import rlang
#' @importFrom bit64 integer64
#' @importFrom crayon blue
#' @importFrom crayon bold
#' @importFrom crayon cyan
#' @importFrom crayon green
#' @importFrom crayon reset
#' @importFrom crayon silver
#' @importFrom glue glue
#' @importFrom lifecycle deprecate_warn
#' @importFrom lifecycle deprecated
## usethis namespace: end
NULL

release_extra_revdeps <- function() "readr"

({
  library(vroom)
  library(dplyr)
})
x <- vroom(
  file,
  id = "path",
  col_types = c(pickup_datetime = "c"),
  trim_ws = FALSE,
  quote = "",
  escape_double = FALSE,
  na = character(),
  altrep = TRUE
)
print(x)
a <- head(x)
b <- tail(x)
c <- sample_n(x, 100)
d <- filter(x, payment_type == "UNK")
e <- group_by(x, payment_type) %>% summarise(avg_tip = mean(tip_amount))

env_to_logical <- function(var, default = TRUE) {
  res <- Sys.getenv(var, default)
  if (res %in% c("1", "yes", "true")) {
    TRUE
  } else if (res %in% c("0", "no", "false")) {
    FALSE
  } else {
    default
  }
}

is_windows <- function() {
  identical(tolower(Sys.info()[["sysname"]]), "windows")
}

is_loaded <- function(pkg) {
  isTRUE(pkg[[1]] %in% loadedNamespaces())
}

`%||%` <- function(x, y) if (is.null(x)) y else x

collapse_transformer <- function(regex = "[*]$", ...) {
  function(text, envir) {
    if (grepl(regex, text)) {
      text <- sub(regex, "", text)
      res <- eval(parse(text = text, keep.source = FALSE), envir)
      glue::glue_collapse(res, ...)
    } else {
      glue::identity_transformer(text, envir)
    }
  }
}

is_named <- function(x) {
  nms <- names(x)
  if (is.null(nms)) {
    return(FALSE)
  }
  all(nms != "" & !is.na(nms))
}

deparse2 <- function(expr, ..., sep = "\n") {
  paste(deparse(expr, ...), collapse = sep)
}

is_syntactic <- function(x) make.names(x) == x

# Conditionally exported in zzz.R
#' @noRd
# @export
compare.spec_tbl_df <- function(x, y, ...) {
  attr(x, "spec") <- NULL
  attr(x, "problems") <- NULL
  attr(y, "spec") <- NULL
  attr(y, "problems") <- NULL
  class(x) <- setdiff(class(x), "spec_tbl_df")
  class(y) <- setdiff(class(y), "spec_tbl_df")
  NextMethod("compare")
}

# Conditionally exported in zzz.R
#' @noRd
# @export
compare_proxy.spec_tbl_df <- function(x, path) {
  attr(x, "spec") <- NULL
  attr(x, "problems") <- NULL
  class(x) <- setdiff(class(x), "spec_tbl_df")

  if ("path" %in% names(formals(waldo::compare_proxy))) {
    list(object = x, path = path)
  } else {
    x
  }
}

# Conditionally exported in zzz.R
#' @noRd
# @export
as_tibble.spec_tbl_df <- function(x, ...) {
  attr(x, "spec") <- NULL
  attr(x, "problems") <- NULL
  class(x) <- setdiff(class(x), "spec_tbl_df")
  NextMethod("as_tibble")
}

# Conditionally exported in zzz.R
#' @noRd
# @export
all.equal.spec_tbl_df <- function(target, current, ...) {
  attr(target, "spec") <- NULL
  attr(target, "problems") <- NULL
  attr(current, "spec") <- NULL
  attr(current, "problems") <- NULL
  class(target) <- setdiff(class(target), "spec_tbl_df")
  class(current) <- setdiff(class(current), "spec_tbl_df")
  NextMethod("all.equal")
}

# Conditionally exported in zzz.R
#' @noRd
# @export
as.data.frame.spec_tbl_df <- function(x, ...) {
  attr(x, "spec") <- NULL
  attr(x, "problems") <- NULL
  class(x) <- setdiff(class(x), "spec_tbl_df")
  NextMethod("as.data.frame")
}

is_rstudio_console <- function() {
  !(Sys.getenv("RSTUDIO", "") == "" || Sys.getenv("RSTUDIO_TERM", "") != "")
}

is_rstudio_version <- function(min, max = .Machine$integer.max) {
  tryCatch(
    expr = {
      version <- rstudioapi::getVersion()
      version >= min && version < max
    },
    error = function(e) FALSE
  )
}

#' @importFrom methods setOldClass
setOldClass(c("spec_tbl_df", "tbl_df", "tbl", "data.frame"))

utctime <- function(year, month, day, hour, min, sec, psec) {
  utctime_(
    as.integer(year),
    as.integer(month),
    as.integer(day),
    as.integer(hour),
    as.integer(min),
    as.integer(sec),
    as.numeric(psec)
  )
}

check_length <- function(x, n, ..., arg = caller_arg(x), call = caller_env()) {
  if (length(x) != n) {
    cli::cli_abort(
      "{.arg {arg}} must have length {n}, not {length(x)}.",
      ...,
      call = call,
      arg = arg
    )
  }
  invisible(NULL)
}

#' Read a fixed-width file into a tibble
#'
#' @description
#' Fixed-width files store tabular data with each field occupying a specific
#' range of character positions in every line. Once the fields are identified,
#' converting them to the appropriate R types works just like for delimited
#' files. The unique challenge with fixed-width files is describing where each
#' field begins and ends. \pkg{vroom} tries to ease this pain by offering a
#' few different ways to specify the field structure:
#' - `fwf_empty()` - Guesses based on the positions of empty columns. This is
#'   the default. (Note that `fwf_empty()` returns 0-based positions, for
#'   internal use.)
#' - `fwf_widths()` - Supply the widths of the columns.
#' - `fwf_positions()` - Supply paired vectors of start and end positions. These
#'   are interpreted as 1-based positions, so are off-by-one compared to the
#'   output of `fwf_empty()`.
#' - `fwf_cols()` - Supply named arguments of paired start and end positions or
#'    column widths.
#'
#' Note: `fwf_empty()` cannot work with a connection or with any of the input
#' types that involve a connection internally, which includes remote and
#' compressed files. The reason is that this would necessitate reading from the
#' connection twice. In these cases, you'll have to either provide the field
#' structure explicitly with another `fwf_*()` function or download (and
#' decompress, if relevant) the file first.
#'
#' @details
#' Here's a enhanced example using the contents of the file accessed via
#' `vroom_example("fwf-sample.txt")`.
#'
#' ```
#'          1         2         3         4
#' 123456789012345678901234567890123456789012
#' [     name 20      ][state 10][  ssn 12  ]
#' John Smith          WA        418-Y11-4111
#' Mary Hartford       CA        319-Z19-4341
#' Evan Nolan          IL        219-532-c301
#' ```
#'
#' Here are some valid field specifications for the above (they aren't all
#' equivalent! but they are all valid):
#'
#' ```
#' fwf_widths(c(20, 10, 12), c("name", "state", "ssn"))
#' fwf_positions(c(1, 30), c(20, 42), c("name", "ssn"))
#' fwf_cols(state = c(21, 30), last = c(6, 20), first = c(1, 4), ssn = c(31, 42))
#' fwf_cols(name = c(1, 20), ssn = c(30, 42))
#' fwf_cols(name = 20, state = 10, ssn = 12)
#' ```
#'
#' @inheritParams vroom
#' @param col_positions Column positions, as created by [fwf_empty()],
#'   `fwf_widths()`, `fwf_positions()`, or `fwf_cols()`. To read in only
#'   selected fields, use `fwf_positions()`. If the width of the last column
#'   is variable (a ragged fwf file), supply the last end position as `NA`.
#' @param comment A string used to identify comments. Any line that starts
#'   with the comment string at the beginning of the file (before any data
#'   lines) will be ignored. Unlike [vroom()], comment lines in the middle
#'   of the file are not filtered out.
#' @export
#' @examples
#' fwf_sample <- vroom_example("fwf-sample.txt")
#' writeLines(vroom_lines(fwf_sample))
#'
#' # You can specify column positions in several ways:
#' # 1. Guess based on position of empty columns
#' vroom_fwf(fwf_sample, fwf_empty(fwf_sample, col_names = c("first", "last", "state", "ssn")))
#' # 2. A vector of field widths
#' vroom_fwf(fwf_sample, fwf_widths(c(20, 10, 12), c("name", "state", "ssn")))
#' # 3. Paired vectors of start and end positions
#' vroom_fwf(fwf_sample, fwf_positions(c(1, 30), c(20, 42), c("name", "ssn")))
#' # 4. Named arguments with start and end positions
#' vroom_fwf(fwf_sample, fwf_cols(name = c(1, 20), ssn = c(30, 42)))
#' # 5. Named arguments with column widths
#' vroom_fwf(fwf_sample, fwf_cols(name = 20, state = 10, ssn = 12))
vroom_fwf <- function(
  file,
  col_positions = fwf_empty(file, skip, n = guess_max),
  col_types = NULL,
  col_select = NULL,
  id = NULL,
  locale = default_locale(),
  na = c("", "NA"),
  comment = "",
  skip_empty_rows = TRUE,
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = 100,
  altrep = TRUE,
  num_threads = vroom_threads(),
  progress = vroom_progress(),
  show_col_types = NULL,
  .name_repair = "unique"
) {
  check_number_decimal(n_max)
  check_number_decimal(guess_max)

  verify_fwf_positions(col_positions)

  file <- standardise_path(file)

  if (!is_ascii_compatible(locale$encoding)) {
    file <- reencode_file(file, locale$encoding)
    locale$encoding <- "UTF-8"
  }

  if (
    length(file) == 0 ||
      (n_max == 0 & identical(col_positions$col_names, FALSE))
  ) {
    out <- tibble::tibble()
    class(out) <- c("spec_tbl_df", class(out))
    return(out)
  }

  if (n_max < 0 || is.infinite(n_max)) {
    n_max <- -1
  }

  if (guess_max < 0 || is.infinite(guess_max)) {
    guess_max <- -1
  }

  col_select <- vroom_enquo(enquo(col_select))

  has_col_types <- !is.null(col_types)

  col_types <- as.col_spec(col_types)

  out <- vroom_fwf_(
    file,
    as.integer(col_positions$begin),
    as.integer(col_positions$end),
    trim_ws = trim_ws,
    col_names = col_positions$col_names,
    col_types = col_types,
    col_select = col_select,
    name_repair = .name_repair,
    id = id,
    na = na,
    guess_max = guess_max,
    skip = skip,
    comment = comment,
    skip_empty_rows = skip_empty_rows,
    n_max = n_max,
    num_threads = num_threads,
    altrep = vroom_altrep(altrep),
    locale = locale,
    progress = progress
  )

  out <- tibble::as_tibble(out, .name_repair = .name_repair)

  out <- vroom_select(out, col_select, id)
  class(out) <- c("spec_tbl_df", class(out))

  if (should_show_col_types(has_col_types, show_col_types)) {
    show_col_types(out, locale)
  }

  out
}


#' @rdname vroom_fwf
#' @export
#' @param n Number of lines the tokenizer will read to determine file structure. By default
#'      it is set to 100.
fwf_empty <- function(
  file,
  skip = 0,
  col_names = NULL,
  comment = "",
  n = 100L
) {
  file <- connection_or_filepath(standardise_path(file)[[1]])

  if (inherits(file, "connection")) {
    cli::cli_abort("{.arg file} must be a regular file, not a connection.")
  }

  if (n < 0 || is.infinite(n)) {
    n <- -1
  }

  out <- whitespace_columns_(file[[1]], skip, comment = comment, n = n)
  out$end[length(out$end)] <- NA

  col_names <- fwf_col_names(col_names, length(out$begin))
  out$col_names <- col_names
  out
}

#' @rdname vroom_fwf
#' @export
#' @param widths Width of each field. Use `NA` as the width of the last field
#'   when reading a ragged fixed-width file.
#' @param col_names Either NULL, or a character vector column names.
fwf_widths <- function(widths, col_names = NULL) {
  pos <- cumsum(c(1L, abs(widths)))
  fwf_positions(pos[-length(pos)], pos[-1] - 1L, col_names)
}

#' @rdname vroom_fwf
#' @export
#' @param start,end Starting and ending (inclusive) positions of each field.
#'    **Positions are 1-based**: the first character in a line is at position 1.
#'    Use `NA` as the last value of `end` when reading a ragged fixed-width
#'    file.
fwf_positions <- function(start, end = NULL, col_names = NULL) {
  if (length(start) != length(end)) {
    cli::cli_abort(
      c(
        "{.arg start} and {.arg end} must have the same length.",
        "i" = "{.arg start} has length {length(start)}.",
        "i" = "{.arg end} has length {length(end)}."
      )
    )
  }

  if (any(start <= 0, na.rm = TRUE)) {
    cli::cli_abort(
      c(
        "{.arg start} positions must be >= 1, i.e. use 1-based indexing.",
        "i" = "The first character in a line is at position 1, not 0.",
        "i" = "If you got these positions from {.fn fwf_empty}, note that its output uses 0-based indexing."
      )
    )
  }

  col_names <- fwf_col_names(col_names, length(start))

  tibble::tibble(
    begin = start - 1L,
    end = end, # -1 to change to 0 offset, +1 to be exclusive,
    col_names = as.character(col_names)
  )
}


#' @rdname vroom_fwf
#' @export
#' @param ... Named or unnamed arguments, each addressing one column. Each input
#' should be either a single integer (a column width) or a pair of integers
#' (column start and end positions). All arguments must have the same shape,
#' i.e. all widths or all positions.
fwf_cols <- function(...) {
  x <- lapply(list(...), as.integer)

  # Check that all inputs have the same length (1 or 2)
  lengths <- lengths(x)
  unique_lengths <- unique(lengths)

  if (length(unique_lengths) > 1) {
    cli::cli_abort(
      c(
        "All inputs must have the same shape.",
        "x" = "Found inputs with different lengths: {unique_lengths}.",
        "i" = "Provide either single values (widths) or pairs of values (positions)."
      )
    )
  }

  if (!unique_lengths %in% c(1, 2)) {
    cli::cli_abort(
      c(
        "All inputs must be either a single value or a pair of values.",
        "x" = "The provided inputs each have length {unique_lengths}.",
        "i" = "Single values specify column widths: {.code fwf_cols(a = 10, b = 5)}.",
        "i" = "Pairs of values specify start and end positions: {.code fwf_cols(a = c(1, 10), b = c(11, 15))}."
      )
    )
  }

  names(x) <- fwf_col_names(names(x), length(x))
  x <- tibble::as_tibble(x)

  if (nrow(x) == 2) {
    fwf_positions(as.integer(x[1, ]), as.integer(x[2, ]), names(x))
  } else {
    fwf_widths(as.integer(x[1, ]), names(x))
  }
}

fwf_col_names <- function(nm, n) {
  nm <- nm %||% rep("", n)
  nm_empty <- (nm == "")
  nm[nm_empty] <- paste0("X", seq_len(n))[nm_empty]
  nm
}

verify_fwf_positions <- function(col_positions) {
  is_greater <- stats::na.omit(col_positions$begin > col_positions$end)
  if (any(is_greater)) {
    bad_cols <- col_positions$col_names[is_greater]
    cli::cli_abort(
      c(
        "{.arg begin} cannot be greater than {.arg end}.",
        "x" = "Problem with column{?s}: {.val {bad_cols}}."
      )
    )
  }
}

test_that("col_select works", {
  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = 1,
      col_types = list()
    )),
    "model"
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = 1:3,
      col_types = list()
    )),
    c("model", "mpg", "cyl")
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = c(1, 5, 7),
      col_types = list()
    )),
    c("model", "hp", "wt")
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = c("model", "hp", "wt"),
      col_types = list()
    )),
    c("model", "hp", "wt")
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = c(model:cyl),
      col_types = list()
    )),
    c("model", "mpg", "cyl")
  )
})

test_that("col_select with negations works", {
  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = -1,
      col_types = list()
    )),
    c(
      "mpg",
      "cyl",
      "disp",
      "hp",
      "drat",
      "wt",
      "qsec",
      "vs",
      "am",
      "gear",
      "carb"
    )
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = -(1:3),
      col_types = list()
    )),
    c("disp", "hp", "drat", "wt", "qsec", "vs", "am", "gear", "carb")
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = -c(1, 5, 7),
      col_types = list()
    )),
    c("mpg", "cyl", "disp", "drat", "qsec", "vs", "am", "gear", "carb")
  )

  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = -c(model, hp, wt),
      col_types = list()
    )),
    c("mpg", "cyl", "disp", "drat", "qsec", "vs", "am", "gear", "carb")
  )
})

test_that("col_select with renaming", {
  expect_equal(
    colnames(vroom(
      vroom_example("mtcars.csv"),
      col_select = c(car = model, everything()),
      col_types = list()
    )),
    c(
      "car",
      "mpg",
      "cyl",
      "disp",
      "hp",
      "drat",
      "wt",
      "qsec",
      "vs",
      "am",
      "gear",
      "carb"
    )
  )
})

test_that("col_select works with vroom_fwf", {
  spec <- fwf_empty(test_path("fwf-trailing.txt"))

  expect_equal(
    colnames(
      vroom_fwf(
        test_path("fwf-trailing.txt"),
        spec,
        col_select = c(foo = X1, X2),
        col_types = list()
      )
    ),
    c("foo", "X2")
  )
})

test_that("col_select can select the id column", {
  expect_named(
    vroom(
      vroom_example("mtcars.csv"),
      id = "path",
      col_select = c(model, mpg, path),
      col_types = list()
    ),
    c("model", "mpg", "path")
  )

  expect_named(
    vroom(
      vroom_example("mtcars.csv"),
      id = "path",
      col_select = c(path, model, mpg),
      col_types = list()
    ),
    c("path", "model", "mpg")
  )
})

test_that("id column is automatically included in col_select (#416)", {
  expect_named(
    vroom(
      vroom_example("mtcars.csv"),
      id = "path",
      col_select = c(model, mpg),
      show_col_types = FALSE
    ),
    c("path", "model", "mpg")
  )
})

test_that("referencing columns by position in col_select works with id column (#455)", {
  expect_named(
    vroom(
      vroom_example("mtcars.csv"),
      id = "path",
      col_select = c(1:3),
      show_col_types = FALSE
    ),
    c("path", "model", "mpg", "cyl")
  )

  expect_named(
    vroom(
      vroom_example("mtcars.csv"),
      id = "path",
      col_select = c(1:3, 6:8),
      show_col_types = FALSE
    ),
    c("path", "model", "mpg", "cyl", "drat", "wt", "qsec")
  )
})

test_that("col_select works with col_names = FALSE", {
  res <- vroom(
    I("foo\tbar\n1\t2\n"),
    col_names = FALSE,
    col_select = 1,
    col_types = list()
  )
  expect_equal(res[[1]], c("foo", "1"))

  res2 <- vroom(
    I("foo\tbar\n1\t2\n"),
    col_names = FALSE,
    col_select = c(X2),
    col_types = list()
  )
  expect_equal(res2[[1]], c("bar", "2"))
})

test_that("reading from connection is consistent with reading directly from a file", {
  skip_if(is_windows() && on_github_actions())

  expected <- vroom(vroom_example("mtcars.csv"), col_types = list())

  # This needs to be small enough to have a few blocks in the file, but big
  # enough to fit on the first line (until #47 is fixed)
  withr::with_envvar(c("VROOM_CONNECTION_SIZE" = 100), {
    actual <- vroom(
      file(vroom_example("mtcars.csv"), ""),
      delim = ",",
      col_types = list()
    )
  })
  expect_equal(actual, expected)
})

test_that("reading from connection is consistent with reading directly from a file with quoted fields", {
  ir <- iris
  ir$Species <- as.character(ir$Species)

  # add some commas
  locs <- vapply(nchar(ir$Species), sample.int, integer(1), 1)
  substr(ir$Species, locs, locs) <- ","

  out <- tempfile()
  vroom_write(ir, out, delim = ",")

  expected <- vroom(out, col_types = list())

  # This needs to be small enough to have a few blocks in the file, but big
  # enough to fit on the first line (until #47 is fixed)
  withr::with_envvar(c("VROOM_CONNECTION_SIZE" = 100), {
    actual <- vroom(file(out), col_types = list())
  })
  expect_equal(actual, expected)
})

test_that("vroom errors when the connection buffer is too small", {
  withr::local_envvar(c("VROOM_CONNECTION_SIZE" = 32))
  expect_snapshot(error = TRUE, {
    vroom(file(vroom_example("mtcars.csv")), col_types = list())
  })
})

test_that("vroom can read files with only a single line and no newlines", {
  f <- tempfile()
  on.exit(unlink(f))

  writeChar("a,b,c", eos = NULL, f)

  # with a header
  expect_named(vroom(f, delim = ",", col_types = list()), c("a", "b", "c"))
  expect_named(vroom(f, col_types = list()), c("a", "b", "c"))

  # without a header
  expect_equal(
    vroom(f, col_names = FALSE, delim = ",", col_types = list()),
    tibble::tibble(X1 = "a", X2 = "b", X3 = "c")
  )
  expect_equal(
    vroom(f, col_names = FALSE, col_types = list()),
    tibble::tibble(X1 = "a", X2 = "b", X3 = "c")
  )
})

test_that("vroom works with file connections and quoted fields", {
  f <- tempfile()
  on.exit(unlink(f))
  writeLines('a,b,c\n"1","2","3"\n"4","5","6"', f)
  withr::with_envvar(c("VROOM_CONNECTION_SIZE" = 8), {
    x <- vroom(file(f), delim = ",", col_types = list())
  })
  expect_equal(x, tibble::tibble(a = c(1, 4), b = c(2, 5), c = c(3, 6)))
})

test_that("vroom works with windows newlines and a connection size that lies directly on the newline", {
  tf <- tempfile()
  on.exit(unlink(tf))

  writeChar("1,2\r\na,bbb\r\ne,f\r\n", tf, eos = NULL)

  withr::with_envvar(c("VROOM_CONNECTION_SIZE" = 12), {
    x <- vroom(file(tf), col_types = "cc")
  })
  expect_equal(x[[1]], c("a", "e"))
})

# https://github.com/tidyverse/vroom/issues/488
test_that("vroom() doesn't leak a connection when opening fails (bad URL)", {
  skip_if_offline()
  connections_before <- showConnections(all = TRUE)

  # Try to read from a bad URL (should fail with 404)
  bad_url <- "https://cloud.r-project.org/CRAN_mirrorsZ.csv"
  # Not using snapshots, because not our error or warning
  expect_error(
    expect_warning(
      vroom(bad_url, show_col_types = FALSE)
    ),
    "cannot open"
  )

  connections_after <- showConnections(all = TRUE)
  expect_equal(nrow(connections_before), nrow(connections_after))
})

test_that("vroom_fwf() doesn't leak a connection when opening fails (permission denied)", {
  skip_on_os("windows")

  tfile <- withr::local_tempfile(
    lines = c("col1  col2  col3", "val1  val2  val3"),
    pattern = "no-permissions-",
    fileext = ".txt"
  )
  Sys.chmod(tfile, mode = "000") # Remove all permissions
  connections_before <- showConnections(all = TRUE)

  # It is conceivable that this vroom_fwf() will succeed if, for example, tests
  # are being run by root?
  # See https://github.com/tidyverse/vroom/issues/611
  # Therefore, we don't state a hard expectation around error or warning.
  # We just care that connections don't leak.
  try(
    suppressWarnings(
      vroom_fwf(file(tfile), fwf_widths(c(6, 6, 6)), show_col_types = FALSE)
    ),
    silent = TRUE
  )

  connections_after <- showConnections(all = TRUE)
  expect_equal(nrow(connections_before), nrow(connections_after))
})

test_that("reading no data, from a connection", {
  skip_if_offline()
  # inspired by:
  # https://github.com/tidyverse/vroom/issues/539
  # remote compressed file with n_max = 0 and explicit col_names
  expect_equal(
    vroom(
      "https://vroom.tidyverse.org/mtcars.csv.gz",
      col_names = c("a", "b", "c"),
      n_max = 0,
      show_col_types = FALSE
    ),
    tibble::tibble(a = character(), b = character(), c = character())
  )

  # remote file without extension - tests default switch case
  expect_equal(
    vroom(
      "https://vroom.tidyverse.org/mtcars",
      col_names = c("a", "b", "c"),
      n_max = 0,
      show_col_types = FALSE
    ),
    tibble::tibble(a = character(), b = character(), c = character())
  )
})

test_that("trailing spaces omitted", {
  spec <- fwf_empty(test_path("fwf-trailing.txt"))
  expect_equal(spec$begin, c(0, 4))
  expect_equal(spec$end, c(3, NA))

  df <- vroom_fwf(test_path("fwf-trailing.txt"), spec, col_types = list())
  expect_equal(df$X1, df$X2)
})

test_that("dos newlines handles", {
  spec <- fwf_empty(test_path("fwf-trailing.txt"))
  x <- vroom_fwf(test_path("fwf-trailing.txt"), spec, col_types = list())
  y <- vroom_fwf(test_path("fwf-trailing-crlf.txt"), spec, col_types = list())
  expect_equal(x, y)

  z <- vroom_fwf(
    file(test_path("fwf-trailing-crlf.txt")),
    spec,
    col_types = list()
  )
  expect_equal(z, x)
})

test_that("connections and normal files produce identical output", {
  spec <- fwf_empty(test_path("fwf-trailing.txt"))

  y <- vroom_fwf(test_path("fwf-trailing-crlf.txt"), spec, col_types = list())
  x <- vroom_fwf(
    file(test_path("fwf-trailing-crlf.txt")),
    spec,
    col_types = list()
  )

  expect_equal(x, y)
})

test_that("respects the trim_ws argument", {
  x <- I("a11 b22 c33\nd   e   f  ")
  out1 <- vroom_fwf(x, fwf_empty(x), trim_ws = FALSE, col_types = list())
  expect_equal(out1$X1, c("a11", "d  "))
  expect_equal(out1$X2, c("b22", "e  "))
  expect_equal(out1$X3, c("c33", "f  "))

  out2 <- vroom_fwf(x, fwf_empty(x), trim_ws = TRUE, col_types = list())
  expect_equal(out2$X1, c("a11", "d"))
  expect_equal(out2$X2, c("b22", "e"))
  expect_equal(out2$X3, c("c33", "f"))
})

test_that("respects the trim_ws argument with empty fields", {
  x <- I("a11 b22 c33\nd       f  ")
  out1 <- vroom_fwf(x, fwf_empty(x), trim_ws = FALSE, col_types = list())
  expect_equal(out1$X1, c("a11", "d  "))
  expect_equal(out1$X2, c("b22", "   "))
  expect_equal(out1$X3, c("c33", "f  "))

  out1 <- vroom_fwf(
    x,
    fwf_empty(x),
    trim_ws = TRUE,
    na = "NA",
    col_types = list()
  )
})

test_that("skipping column doesn't pad col_names", {
  x <- I("1 2 3\n4 5 6")

  out1 <- vroom_fwf(x, fwf_empty(x), col_types = 'd-d')
  expect_named(out1, c("X1", "X3"))

  names <- c("a", "b", "c")
  out2 <- vroom_fwf(x, fwf_empty(x, col_names = names), col_types = 'd-d')
  expect_named(out2, c("a", "c"))
})

test_that("fwf_empty can skip comments", {
  x <- I("COMMENT\n1 2 3\n4 5 6")

  out1 <- vroom_fwf(
    x,
    fwf_empty(x, comment = "COMMENT"),
    comment = "COMMENT",
    col_types = list()
  )
  expect_equal(dim(out1), c(2, 3))
})

test_that("fwf_empty can skip lines", {
  x <- I("foo\nbar\baz\n1 2 3\n4 5 6\n")

  obj <- fwf_empty(x, skip = 3)

  exp <- list(
    begin = c(0L, 2L, 4L),
    end = c(1L, 3L, NA_integer_),
    col_names = c("X1", "X2", "X3")
  )

  expect_equal(obj, exp)
})

test_that("passing \"\" to vroom_fwf's 'na' option", {
  expect_equal(
    vroom_fwf(
      I("foobar\nfoo   "),
      fwf_widths(c(3, 3)),
      na = "",
      col_types = list()
    )[[2]],
    c("bar", NA)
  )
})

test_that("ragged last column expanded with NA", {
  x <- vroom_fwf(I("1a\n2ab\n3abc"), fwf_widths(c(1, NA)), col_types = list())
  expect_equal(x$X2, c("a", "ab", "abc"))
})

#test_that("ragged last column shrunk with warning", {
#expect_warning(x <- vroom_fwf(I("1a\n2ab\n3abc"), fwf_widths(c(1, 3))))
#expect_equal(x$X2, c("a", "ab", "abc"))
#})

test_that("read all columns with positions, non ragged", {
  col_pos <- fwf_positions(c(1, 3, 6), c(2, 5, 6))
  x <- vroom_fwf(
    I("12345A\n67890BBBBBBBBB\n54321C"),
    col_positions = col_pos,
    col_types = list()
  )
  expect_equal(x$X3, c("A", "B", "C"))
})

test_that("read subset columns with positions", {
  col_pos <- fwf_positions(c(1, 3), c(2, 5))
  x <- vroom_fwf(
    I("12345A\n67890BBBBBBBBB\n54321C"),
    col_positions = col_pos,
    col_types = list()
  )
  expect_equal(x$X1, c(12, 67, 54))
  expect_equal(x$X2, c(345, 890, 321))
})

test_that("read columns with positions, ragged", {
  col_pos <- fwf_positions(c(1, 3, 6), c(2, 5, NA))
  x <- vroom_fwf(
    I("12345A\n67890BBBBBBBBB\n54321C"),
    col_positions = col_pos,
    col_types = list()
  )
  expect_equal(x$X1, c(12, 67, 54))
  expect_equal(x$X2, c(345, 890, 321))
  expect_equal(x$X3, c('A', 'BBBBBBBBB', 'C'))
})

test_that("read columns with width, ragged", {
  col_pos <- fwf_widths(c(2, 3, NA))
  x <- vroom_fwf(
    I("12345A\n67890BBBBBBBBB\n54321C"),
    col_positions = col_pos,
    col_types = list()
  )
  expect_equal(x$X1, c(12, 67, 54))
  expect_equal(x$X2, c(345, 890, 321))
  expect_equal(x$X3, c('A', 'BBBBBBBBB', 'C'))
})

#test_that("vroom_fwf returns an empty data.frame on an empty file", {
##expect_true(all.equal(vroom_fwf(test_path("empty-file")), tibble::data_frame()))
#})

#test_that("check for line breaks in between widths", {
#txt1 <- paste(
#"1 1",
#"2",
#"1 1 ",
#sep = "\n"
#)
#expect_warning(out1 <- vroom_fwf(txt1, fwf_empty(txt1)))
#expect_equal(n_problems(out1), 2)

#txt2 <- paste(
#" 1 1",
#" 2",
#" 1 1 ",
#sep = "\n"
#)
#expect_warning(out2 <- vroom_fwf(txt2, fwf_empty(txt2)))
#expect_equal(n_problems(out2), 2)

#exp <- tibble::tibble(X1 = c(1L, 2L, 1L), X2 = c(1L, NA, 1L))
#expect_true(all.equal(out1, exp))
#expect_true(all.equal(out2, exp))

#})

#test_that("error on empty spec (#511, #519)", {
#txt = "foo\n"
#pos = fwf_positions(start = numeric(0), end = numeric(0))
#expect_error(vroom_fwf(txt, pos), "Zero-length.*specifications not supported")
#})

#test_that("error on negatives in fwf spec", {
#txt = "foo\n"
#pos = fwf_positions(start = c(1, -1), end = c(2, 3))
#expect_error(vroom_fwf(txt, pos), ".*offset.*greater than 0")
#})

test_that("fwf spec can overlap", {
  x <- vroom_fwf(
    I("2015a\n2016b"),
    fwf_positions(c(1, 3, 5), c(4, 4, 5)),
    col_types = list()
  )
  expect_equal(x$X1, c(2015, 2016))
  expect_equal(x$X2, c(15, 16))
  expect_equal(x$X3, c("a", "b"))
})

# fwf_cols
test_that("fwf_cols produces correct fwf_positions object with elements of length 2", {
  expected <- fwf_positions(c(1L, 9L, 4L), c(2L, 12L, 6L), c("a", "b", "d"))
  expect_equal(
    fwf_cols(a = c(1, 2), b = c(9, 12), d = c(4, 6)),
    expected,
    ignore_attr = TRUE
  )
})

test_that("fwf_cols produces correct fwf_positions object with elements of length 1", {
  expected <- fwf_widths(c(2L, 4L, 3L), c("a", "b", "c"))
  expect_equal(fwf_cols(a = 2, b = 4, c = 3), expected, ignore_attr = TRUE)
})


test_that("fwf_cols errors when arguments have different shapes", {
  expect_snapshot(
    fwf_cols(a = 10, b = c(11, 15)),
    error = TRUE
  )

  expect_snapshot(
    fwf_cols(a = 1:3, b = 4:5),
    error = TRUE
  )
})

test_that("fwf_cols errors with invalid number of values", {
  expect_snapshot(
    fwf_cols(a = 1:4, b = 5:8),
    error = TRUE
  )

  expect_snapshot(
    fwf_cols(a = c(), b = c()),
    error = TRUE
  )
})

test_that("fwf_cols works with unnamed columns", {
  expect_equal(
    ignore_attr = TRUE,
    fwf_cols(c(1, 2), c(9, 12), c(4, 6)),
    fwf_positions(c(1L, 9L, 4L), c(2L, 12L, 6L), c("X1", "X2", "X3"))
  )
  expect_equal(
    ignore_attr = TRUE,
    fwf_cols(a = c(1, 2), c(9, 12), c(4, 6)),
    fwf_positions(c(1L, 9L, 4L), c(2L, 12L, 6L), c("a", "X2", "X3"))
  )
})

# fwf_positions ---------------------------------------------------------------

test_that("fwf_positions errors when start and end have different lengths", {
  expect_snapshot(
    fwf_positions(c(1, 5, 10), c(4, 9)),
    error = TRUE
  )
})

test_that("fwf_positions always returns col_names as character (#797)", {
  begin <- c(1, 2, 4, 8)
  end <- c(1, 3, 7, 15)

  # Input a factor, should return a character
  nms <- factor(letters[1:4])

  info <- fwf_positions(begin, end, nms)

  expect_type(info$begin, "double")
  expect_type(info$end, "double")
  expect_type(info$col_names, "character")
})

# https://github.com/tidyverse/readr/issues/1544
test_that("fwf_positions() errors for start position of 0", {
  expect_snapshot(
    fwf_positions(c(0, 4), c(3, 7)),
    error = TRUE
  )
})

# Robustness ----------------------------------------------------------------

test_that("vroom_fwf() is robust to improper inputs", {
  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2\n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2 \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2  \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4\n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4 \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4  \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4   \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4   5\n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4   5 \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4   5  \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4   5   \n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("foo bar baz\n1   2   \n4   5   6\n"), col_types = list())
  )

  expect_error_free(
    vroom_fwf(I("A\n  a\n"), col_types = list())
  )
})

test_that("Errors if begin is greater than end", {
  positions <- fwf_positions(
    start = c(1, 3, 5),
    end = c(3, 1, NA),
    col_names = c("foo", "bar", "baz")
  )

  expect_snapshot(
    vroom_fwf(I("1  2  3\n"), positions, col_types = list()),
    error = TRUE
  )
})

test_that("vroom_fwf respects n_max (#334)", {
  out <- vroom_fwf(
    I("foo 1\nbar 2\nbaz 3\nqux 4"),
    n_max = 0,
    col_types = list()
  )
  expect_named(out, c("X1", "X2"))
  expect_equal(out[[1]], character())
  expect_equal(out[[2]], character())

  out <- vroom_fwf(
    I("foo 1\nbar 2\nbaz 3\nqux 4"),
    n_max = 1,
    col_types = list()
  )
  expect_named(out, c("X1", "X2"))
  expect_equal(out[[1]], c("foo"))
  expect_equal(out[[2]], c(1))

  out <- vroom_fwf(
    I("foo 1\nbar 2\nbaz 3\nqux 4"),
    n_max = 2,
    col_types = list()
  )
  expect_named(out, c("X1", "X2"))
  expect_equal(out[[1]], c("foo", "bar"))
  expect_equal(out[[2]], c(1, 2))
})

test_that("vroom_fwf respects n_max when reading from a connection", {
  f <- tempfile()
  on.exit(unlink(f))
  writeLines(rep("00010002", 1000), f)

  out1 <- vroom_fwf(
    file(f),
    col_positions = fwf_widths(c(4, 4)),
    col_types = "ii"
  )

  expect_equal(dim(out1), c(1000, 2))

  out2 <- vroom_fwf(
    file(f),
    n_max = 900,
    col_positions = fwf_widths(c(4, 4)),
    col_types = "ii"
  )

  expect_equal(dim(out2), c(900, 2))

  out3 <- vroom_fwf(
    file(f),
    n_max = 100,
    col_positions = fwf_widths(c(4, 4)),
    col_types = "ii"
  )

  expect_equal(dim(out3), c(100, 2))

  out4 <- vroom_fwf(
    file(f),
    n_max = 10,
    col_positions = fwf_widths(c(4, 4)),
    col_types = "ii"
  )

  expect_equal(dim(out4), c(10, 2))

  out5 <- vroom_fwf(
    file(f),
    n_max = 1,
    col_positions = fwf_widths(c(4, 4)),
    col_types = "ii"
  )

  expect_equal(dim(out5), c(1, 2))
})

test_that("vroom_fwf(n_max = 0) works with connection", {
  f <- withr::local_tempfile(fileext = ".gz")
  con <- gzfile(f, "w")
  writeLines(c("abcdef", "ghijkl"), con)
  close(con)

  result <- vroom_fwf(
    f,
    col_positions = fwf_widths(c(2, 2, 2), c("a", "b", "c")),
    n_max = 0,
    show_col_types = FALSE
  )

  expect_equal(
    result,
    tibble::tibble(a = character(), b = character(), c = character())
  )
})

test_that("vroom_fwf works when skip_empty_rows is false (https://github.com/tidyverse/readr/issues/1211)", {
  f <- tempfile()
  on.exit(unlink(f))

  writeLines(rep(" ", 10), f)

  out <- vroom_fwf(
    f,
    fwf_cols(A = c(1, NA)),
    col_types = "c",
    na = " ",
    trim_ws = FALSE,
    skip_empty_rows = FALSE
  )

  expect_equal(out[[1]], rep(NA_character_, 10))
})

test_that("vroom_fwf correctly reads files with no trailing newline (https://github.com/tidyverse/readr/issues/1293)", {
  f <- tempfile()
  on.exit(unlink(f))

  writeBin(charToRaw("111222\n333444"), f)

  out <- vroom_fwf(f, fwf_widths(c(3, 3)), col_types = "ii")

  expect_equal(out, tibble::tibble(X1 = c(111, 333), X2 = c(222, 444)))

  out2 <- vroom_fwf(file(f), fwf_widths(c(3, 3)), col_types = "ii")

  expect_equal(out, out2)
})

test_that("vroom_fwf correctly reads DOS files with no trailing newline (https://github.com/tidyverse/readr/issues/1293)", {
  f <- tempfile()
  on.exit(unlink(f))

  writeBin(charToRaw("111222\r\n333444"), f)

  out <- vroom_fwf(f, fwf_widths(c(3, 3)), col_types = "ii")

  expect_equal(out, tibble::tibble(X1 = c(111, 333), X2 = c(222, 444)))

  out2 <- vroom_fwf(file(f), fwf_widths(c(3, 3)), col_types = "ii")

  expect_equal(out, out2)
})

# https://github.com/tidyverse/vroom/issues/554
# https://github.com/tidyverse/vroom/issues/534
test_that("vroom_fwf(col_select =) output has 'spec_tbl_df' class, spec, and problems when readr is attached", {
  # Register readr's [.spec_tbl_df method which drops attributes and the "spec_tbl_df" class
  readr_single_bracket <- function(x, ...) {
    attr(x, "spec") <- NULL
    attr(x, "problems") <- NULL
    class(x) <- setdiff(class(x), "spec_tbl_df")
    NextMethod(`[`)
  }
  registerS3method("[", "spec_tbl_df", readr_single_bracket)

  # Unfortunately you can't just de-register the method and
  # local_mocked_s3_method() only works if method exists to begin with.
  # We'll do next best thing which is to put a pass-through method back.
  withr::defer({
    registerS3method("[", "spec_tbl_df", function(x, ...) NextMethod(`[`))
  })

  expect_warning(
    dat <- vroom_fwf(
      I("a  b  \n1  2  \nz  3  \n4  5  "),
      fwf_widths(c(3, 3)),
      col_types = "dc",
      col_select = c(X1, X2),
      show_col_types = FALSE,
      altrep = FALSE
    ),
    class = "vroom_parse_issue"
  )

  expect_s3_class(dat, "spec_tbl_df")
  expect_equal(
    attr(dat, "spec", exact = TRUE),
    cols(
      X1 = col_double(),
      X2 = col_character(),
      .delim = ""
    )
  )
  expect_no_error(probs <- problems(dat))
  if (exists("probs")) {
    expect_equal(nrow(probs), 2)
    expect_equal(probs$row, c(1, 2))
    expect_equal(probs$col, c(1, 1))
  }
})

#!/usr/bin/env Rscript

vroom::vroom_write(
  sessioninfo::package_info(
    c("vroom", "readr", "dplyr", "data.table", "base"),
    dependencies = FALSE,
    include_base = TRUE
  ),
  here::here("inst", "bench", "session_info.tsv"),
  delim = "\t"
)

#' Retrieve parsing problems
#'
#' vroom will only fail to parse a file if the file is invalid in a way that is
#' unrecoverable. However there are a number of non-fatal problems that you
#' might want to know about. You can retrieve a data frame of these problems
#' with this function.
#'
#' @param x A data frame from `vroom::vroom()`.
#' @param lazy If `TRUE`, just the problems found so far are returned. If
#'   `FALSE` (the default) the lazy data is first read completely and all
#'   problems are returned.
#' @return A data frame with one row for each problem and four columns:
#'   - row,col - Row and column number that caused the problem, referencing the
#'   original input
#'   - expected - What vroom expected to find
#'   - actual - What it actually found
#'   - file - The file with the problem
#' @export
problems <- function(x = .Last.value, lazy = FALSE) {
  if (!inherits(x, "tbl_df")) {
    cli::cli_abort(c(
      "The {.arg x} argument of {.fun vroom::problems} must be a data frame created by vroom:",
      x = "{.arg x} has class {.cls {class(x)}}"
    ))
  }

  if (!isTRUE(lazy)) {
    vroom_materialize(x, replace = FALSE)
  }

  probs <- attr(x, "problems")
  if (typeof(probs) != "externalptr") {
    cli::cli_abort(c(
      "The {.arg x} argument of {.fun vroom::problems} must be a data frame created by vroom:",
      x = "{.arg x} seems to have been created with something else, maybe {.pkg readr}?"
    ))
  }
  probs <- vroom_errors_(probs)
  probs <- probs[!duplicated(probs), ]
  probs <- probs[order(probs$file, probs$row, probs$col), ]

  tibble::as_tibble(probs)
}

vroom_tempfile <- function(fileext = "", pattern = "vroom-") {
  dir <- Sys.getenv("VROOM_TEMP_PATH")
  if (!nzchar(dir)) {
    dir <- tempdir()
  }
  if (nzchar(fileext) && !startsWith(fileext, ".")) {
    fileext <- paste0(".", fileext)
  }
  tempfile(pattern = pattern, tmpdir = dir, fileext = fileext)
}

is_ascii_compatible <- function(encoding) {
  identical(
    iconv(list(charToRaw("\n")), from = "ASCII", to = encoding, toRaw = TRUE)[[
      1
    ]],
    charToRaw("\n")
  )
}

# this is about the encoding of the file (contents), not the filepath
reencode_file <- function(file, encoding, call = caller_env()) {
  if (length(file) > 1) {
    cli::cli_abort(
      c(
        "!" = "Encoding {.val {encoding}} is only supported when reading a single input.",
        "i" = "{.arg file} has length {length(file)}."
      ),
      call = call
    )
  }

  if (inherits(file[[1]], "connection")) {
    in_con <- file[[1]]
  } else {
    in_con <- file(file[[1]])
  }
  out_file <- vroom_tempfile(pattern = "vroom-reencode-file-")
  out_con <- file(out_file)
  convert_connection(in_con, out_con, encoding, "UTF-8")
  withr::defer(unlink(out_file), envir = call)
  return(list(out_file))
}

# These functions adapted from https://github.com/tidyverse/readr/blob/192cb1ca5c445e359f153d2259391e6d324fd0a2/R/source.R
standardise_path <- function(
  path,
  arg = caller_arg(path),
  call = caller_env(),
  user_env = caller_env(2)
) {
  if (is.raw(path)) {
    return(list(rawConnection(path, "rb")))
  }

  if (inherits(path, "connection")) {
    return(list(standardise_connection(path)))
  }

  if (is_list(path)) {
    is_connection <- vapply(
      path,
      function(x) inherits(x, "connection"),
      logical(1)
    )
    if (all(is_connection)) {
      return(lapply(path, standardise_connection))
    }
    if (any(is_connection)) {
      cli::cli_abort(
        "{.arg {arg}} cannot be a mix of connection and non-connection inputs",
        call = call
      )
    }
  }

  if (!is.character(path)) {
    cli::cli_abort(
      c(
        "{.arg {arg}} must be one of the supported input types:",
        "*" = "A filepath or character vector of filepaths",
        "*" = "A connection or list of connections",
        "*" = "Literal or raw input",
        "x" = "{.arg {arg}} is {obj_type_friendly(path)}."
      ),
      call = call
    )
  }

  if (inherits(path, "AsIs")) {
    if (length(path) > 1) {
      path <- paste(path, collapse = "\n")
    }
    return(list(chr_to_file(path, call = call)))
  }

  if (any(grepl("\n", path))) {
    lifecycle::deprecate_warn(
      "1.5.0",
      "vroom(file = 'must use `I()` for literal data')",
      details = c(
        " " = "",
        " " = "# Bad:",
        " " = 'vroom("X,Y\\n1.5,2.3\\n")',
        " " = "",
        " " = "# Good:",
        " " = 'vroom(I("X,Y\\n1.5,2.3\\n"))'
      ),
      user_env = user_env
    )
    return(list(chr_to_file(path, call = call)))
  }

  # Handle remote compressed files from R, before heading to C++, so we can
  # associate cleanup with the desired environment.
  is_remote_compressed <- vapply(
    path,
    function(p) {
      is_url(p) && tolower(tools::file_ext(p)) %in% c("gz", "bz2", "xz", "zip")
    },
    logical(1)
  )
  if (all(is_remote_compressed)) {
    return(lapply(path, function(p) {
      ext <- tolower(tools::file_ext(p))
      local_path <- download_file(p, ext, call = call)
      withr::defer(unlink(local_path), envir = call)
      switch(
        ext,
        gz = gzfile(local_path),
        bz2 = bzfile(local_path),
        xz = xzfile(local_path),
        zip = zipfile(local_path)
      )
    }))
  }

  if (any(is_remote_compressed)) {
    cli::cli_abort(
      "{.arg {arg}} cannot be a mix of remote compressed and other inputs.",
      call = call
    )
  }

  as.list(enc2utf8(path))
}

standardise_connection <- function(con) {
  # If the connection is `stdin()`, change it to `file("stdin")`, as we don't
  # support text mode connections.

  if (con == stdin()) {
    return(file("stdin"))
  }

  con
}

connection_or_filepath <- function(path, write = FALSE, call = caller_env()) {
  if (is.raw(path)) {
    return(rawConnection(path, "rb"))
  }

  if (!is.character(path)) {
    return(path)
  }

  if (is_url(path)) {
    ext <- tolower(tools::file_ext(path))
    if (ext %in% c("gz", "bz2", "xz", "zip")) {
      cli::cli_abort(
        "Remote compressed files must be handled upstream of this function.",
        .internal = TRUE
      )
    }
    if (requireNamespace("curl", quietly = TRUE)) {
      con <- curl::curl(path)
    } else {
      inform("`curl` package not installed, falling back to using `url()`")
      con <- url(path)
    }
    return(con)
  }

  path <- enc2utf8(path)

  if (write) {
    path <- normalizePath_utf8(path, mustWork = FALSE)
  } else {
    path <- check_path(path)
  }

  p <- split_path_ext(basename_utf8(path))
  extension <- p$extension
  formats <- archive_formats(extension)
  while (is.null(formats) && nzchar(extension)) {
    extension <- split_path_ext(extension)$extension
    formats <- archive_formats(extension)
  }
  needs_archive <- !is.null(formats) && (write || extension != "zip")

  if (needs_archive) {
    reason <- glue(
      "to {if (write) 'write' else 'read'} `.{p$extension}` files."
    )
    rlang::check_installed("archive", reason = reason, call = call)

    if (write) {
      if (is.null(formats[[1]])) {
        return(archive::file_write(path, filter = formats[[2]]))
      }
      return(archive::archive_write(
        path,
        p$path,
        format = formats[[1]],
        filter = formats[[2]]
      ))
    }
    if (is.null(formats[[1]])) {
      return(archive::file_read(path, filter = formats[[2]]))
    }
    return(archive::archive_read(
      path,
      format = formats[[1]],
      filter = formats[[2]]
    ))
  }

  if (!write) {
    compression <- detect_compression(path)
  } else {
    compression <- NA
  }

  if (is.na(compression)) {
    compression <- tools::file_ext(path)
  }

  if (write && compression == "zip") {
    cli::cli_abort(
      c(
        "Can only read from, not write to, {.val .zip} files.",
        "i" = "Install the {.pkg archive} package to write {.val .zip} files."
      ),
      call = call
    )
  }

  switch(
    compression,
    gz = gzfile(path),
    bz2 = bzfile(path),
    xz = xzfile(path),
    zip = zipfile(path),
    if (!has_trailing_newline(path)) {
      file(path)
    } else {
      path
    }
  )
}

# Safe wrapper around base::open() that ensures connections are cleaned up
# even when open() fails. We need this especially for opening connections from
# C++. If base::open() fails in that context, R will long jump and there aren't
# good options for arranging the necessary cleanup.
open_safely <- function(con, open_mode = "rb") {
  tryCatch(
    open(con, open_mode),
    error = function(e) {
      # The failed connection is already "closed", so this attempt to close() it
      # is really about removing it from R's connection table.
      try(close(con), silent = TRUE)

      stop(conditionMessage(e), call. = FALSE)
    }
  )
}

split_path_ext <- function(path) {
  regex <- "^([^.]*)[.](.*)"
  res <- regexpr(regex, path, perl = TRUE)
  if (length(res) == 0 || res == -1) {
    return(list(path = path, extension = ""))
  }
  starts <- attr(res, "capture.start")[1, ]
  lengths <- attr(res, "capture.length")[,]
  list(
    path = substr(path, starts[[1]], starts[[1]] + lengths[[1]] - 1),
    extension = substr(path, starts[[2]], starts[[2]] + lengths[[2]] - 1)
  )
}

# Adapted from archive:::format_and_filter_by_extension
# https://github.com/r-lib/archive/blob/125f9930798dc20fa12cda30319ca3e9a134a409/R/archive.R#L73
archive_formats <- function(ext) {
  switch(
    ext,
    "7z" = list("7zip", "none"),

    "cpio" = list("cpio", "none"),

    "iso" = list("iso9660", "none"),

    "mtree" = list("mtree", "none"),

    "tar" = list("tar", "none"),

    "tgz" = list("tar", "gzip"),
    "taz" = list("tar", "gzip"),
    "tar.gz" = list("tar", "gzip"),

    "tbz" = list("tar", "bzip2"),
    "tbz2" = list("tar", "bzip2"),
    "tz2" = list("tar", "bzip2"),
    "tar.bz2" = list("tar", "bzip2"),

    "tlz" = list("tar", "lzma"),
    "tar.lzma" = list("tar", "lzma"),

    "txz" = list("tar", "xz"),
    "tar.xz" = list("tar", "xz"),

    "tzo" = list("tar", "lzop"),

    "taZ" = list("tar", "compress"),
    "tZ" = list("tar", "compress"),

    "tar.zst" = list("tar", "zstd"),

    "warc" = list("warc", "none"),

    "jar" = list("zip", "none"),
    "zip" = list("zip", "none"),

    "Z" = list(NULL, "compress"),

    "zst" = list(NULL, "zst"),

    NULL
  )
}

is_url <- function(path) {
  grepl("^((http|ftp)s?|sftp)://", path)
}

download_file <- function(url, ext, call = caller_env()) {
  local_path <- vroom_tempfile(fileext = ext, pattern = "vroom-download-url-")
  show_progress <- vroom_progress()

  try_fetch(
    if (requireNamespace("curl", quietly = TRUE)) {
      curl::curl_download(url, local_path, quiet = !show_progress)
    } else {
      utils::download.file(url, local_path, mode = "wb", quiet = !show_progress)
    },
    error = function(cnd) {
      unlink(local_path)
      cli::cli_abort(
        c(
          "Failed to download {.url {url}}.",
          "x" = conditionMessage(cnd)
        ),
        parent = NA,
        error = cnd,
        call = call
      )
    }
  )

  local_path
}

check_path <- function(path, call = caller_env()) {
  if (file.exists(path)) {
    return(normalizePath_utf8(path, mustWork = FALSE))
  }

  where <- function(path) {
    if (is_absolute_path(path)) {
      ""
    } else {
      " in current working directory: {.file {getwd()}}"
    }
  }
  msg <- glue(
    "{.file {path}} does not exist<<where(path)>>.",
    .open = "<<",
    .close = ">>"
  )
  cli::cli_abort(msg, call = call)
}

is_absolute_path <- function(path) {
  grepl("^(/|[A-Za-z]:|\\\\|~)", path)
}

zipfile <- function(path, open = "") {
  files <- utils::unzip(path, list = TRUE)
  file <- files$Name[[1]]

  if (nrow(files) > 1) {
    inform(paste0("Multiple files in zip: reading '", file, "'"))
  }

  unz(path, file, open = open)
}

utils::globalVariables("con")

chr_to_file <- function(x, call = caller_env()) {
  out <- vroom_tempfile(pattern = "vroom-chr-to-file-")
  con <- file(out, "wb")
  writeLines(sub("\n$", "", x), con, useBytes = TRUE)
  close(con)

  withr::defer(unlink(out), envir = call)

  normalizePath_utf8(out)
}

detect_compression <- function(path) {
  bytes <- readBin(path, "raw", n = 6)
  if (length(bytes) >= 2 && bytes[[1]] == 0x1f && bytes[[2]] == 0x8b) {
    return("gz")
  }
  if (
    length(bytes) >= 6 &&
      bytes[[1]] == 0xFD &&
      bytes[[2]] == 0x37 &&
      bytes[[3]] == 0x7A &&
      bytes[[4]] == 0x58 &&
      bytes[[5]] == 0x5A &&
      bytes[[6]] == 0x00
  ) {
    return("xz")
  }

  if (
    length(bytes) >= 3 &&
      bytes[[1]] == 0x42 &&
      bytes[[2]] == 0x5a &&
      bytes[[3]] == 0x68
  ) {
    return("bz2")
  }

  # normal zip
  if (
    length(bytes) >= 4 &&
      bytes[[1]] == 0x50 &&
      bytes[[2]] == 0x4B &&
      bytes[[3]] == 0x03 &&
      bytes[[4]] == 0x04
  ) {
    return("zip")
  }

  # empty zip
  if (
    length(bytes) >= 4 &&
      bytes[[1]] == 0x50 &&
      bytes[[2]] == 0x4B &&
      bytes[[3]] == 0x05 &&
      bytes[[4]] == 0x06
  ) {
    return("zip")
  }

  # spanned zip
  if (
    length(bytes) >= 4 &&
      bytes[[1]] == 0x50 &&
      bytes[[2]] == 0x4B &&
      bytes[[3]] == 0x07 &&
      bytes[[4]] == 0x08
  ) {
    return("zip")
  }

  NA_character_
}

basename_utf8 <- function(path) {
  enc2utf8(basename(path))
}

normalizePath_utf8 <- function(path, winslash = "/", mustWork = NA) {
  enc2utf8(normalizePath(path, winslash = winslash, mustWork = mustWork))
}

test_that("vroom errors if the file does not exist", {
  tf <- tempfile()
  wd <- getwd()
  scrubber <- function(x) {
    gsub(
      wd,
      "<workdir>",
      gsub(tf, "<tempfile>", x, fixed = TRUE),
      fixed = TRUE
    )
  }

  # absolute path
  expect_snapshot(
    vroom(tf, col_types = list()),
    error = TRUE,
    transform = scrubber
  )

  # relative path
  expect_snapshot(
    vroom("does-not-exist.csv", col_types = list()),
    error = TRUE,
    transform = scrubber
  )
})

test_that("vroom works with compressed files", {
  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  expect_equal(vroom(vroom_example("mtcars.csv.gz"), col_types = list()), mt)
  expect_equal(vroom(vroom_example("mtcars.csv.bz2"), col_types = list()), mt)
  expect_equal(vroom(vroom_example("mtcars.csv.xz"), col_types = list()), mt)
  expect_equal(vroom(vroom_example("mtcars.csv.zip"), col_types = list()), mt)
})

test_that("read_file works via https", {
  skip_on_cran()

  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  url <- "https://raw.githubusercontent.com/tidyverse/vroom/HEAD/inst/extdata/mtcars.csv"
  expect_equal(vroom(url, col_types = list()), mt)
})

test_that("vroom works via https on gz file", {
  skip_on_cran()

  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  url <- "https://raw.githubusercontent.com/tidyverse/vroom/HEAD/inst/extdata/mtcars.csv.gz"
  expect_equal(vroom(url, col_types = list()), mt)
})

test_that("vroom works via https on bz2 file", {
  skip_on_cran()

  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  url <- "https://raw.githubusercontent.com/tidyverse/vroom/HEAD/inst/extdata/mtcars.csv.bz2"
  expect_equal(vroom(url, col_types = list()), mt)
})

test_that("vroom works via https on xz file", {
  skip_on_cran()

  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  url <- "https://raw.githubusercontent.com/tidyverse/vroom/HEAD/inst/extdata/mtcars.csv.xz"
  expect_equal(vroom(url, col_types = list()), mt)
})

test_that("vroom works via https on zip file", {
  skip_on_cran()

  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  url <- "https://raw.githubusercontent.com/tidyverse/vroom/HEAD/inst/extdata/mtcars.csv.zip"
  expect_equal(vroom(url, col_types = list()), mt)
})

# https://github.com/tidyverse/vroom/issues/400
test_that("vroom works via https on concatenated gz file", {
  skip_on_cran()

  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())
  url <- "https://raw.githubusercontent.com/tidyverse/vroom/HEAD/inst/extdata/mtcars-concatenated.csv.gz"
  expect_equal(vroom(url, comment = "#", col_types = list()), mt)
})

test_that("split_path_ext works", {
  expect_equal(
    split_path_ext(character()),
    list(path = character(), extension = "")
  )

  expect_equal(
    split_path_ext(""),
    list(path = "", extension = "")
  )

  expect_equal(
    split_path_ext("foo"),
    list(path = "foo", extension = "")
  )

  expect_equal(
    split_path_ext("foo/bar.baz"),
    list(path = "foo/bar", extension = "baz")
  )

  expect_equal(
    split_path_ext("foo/bar.tar.gz"),
    list(path = "foo/bar", extension = "tar.gz")
  )
})

test_that("vroom() informs user to use I() for literal data (or not)", {
  expect_snapshot(
    x <- vroom("a,b,c,d\n1,2,3,4", show_col_types = FALSE)
  )
})

test_that("can write to a zip file if the archive package is available", {
  skip_on_cran()
  skip_if_not_installed("archive")

  tempfile <- file.path(tempdir(), "mtcars.zip")
  on.exit(unlink(tempfile))
  vroom_write(mtcars, tempfile)

  # PK is the zip magic number
  expect_equal(
    readBin(tempfile, raw(), n = 2),
    as.raw(c(0x50, 0x4b))
  )
})

test_that("can write to a tar.gz file if the archive package is available", {
  skip_on_cran()
  skip_if_not_installed("archive")

  tempfile <- file.path(tempdir(), "mtcars.tar.gz")
  on.exit(unlink(tempfile))
  vroom_write(mtcars, tempfile)

  # 1F 8B is the gz magic number
  expect_equal(
    readBin(tempfile, raw(), n = 2),
    as.raw(c(0x1f, 0x8b))
  )

  res <- archive::archive(tempfile)
  expect_equal(res$path, "mtcars")
  expect_equal(res$size, 1281)
})

# https://github.com/tidyverse/vroom/issues/394
test_that("can read file w/o final newline, w/ multi-byte characters in path", {
  pattern <- "no-trailing-n\u00e8wline-m\u00fblti-byt\u00e9-path-"
  tfile <- withr::local_tempfile(pattern = pattern, fileext = ".csv")
  writeChar("a,b\nA,B", con = tfile, eos = NULL)

  expect_equal(
    vroom(tfile, show_col_types = FALSE),
    tibble::tibble(a = "A", b = "B")
  )
})

# for completeness, w.r.t. test above
test_that("can read file w/ final newline, w/ multi-byte characters in path", {
  pattern <- "yes-trailing-n\u00e8wline-m\u00fblti-byt\u00e9-path-"
  tfile <- withr::local_tempfile(pattern = pattern, fileext = ".csv")
  writeLines(c("a,b", "A,B"), tfile)

  expect_equal(
    vroom(tfile, show_col_types = FALSE),
    tibble::tibble(a = "A", b = "B")
  )
})

test_that("can write to path with non-ascii characters", {
  pattern <- "cr\u00E8me-br\u00FBl\u00E9e-"
  tfile <- withr::local_tempfile(pattern = pattern, fileext = ".csv")
  dat <- tibble::tibble(a = "A", b = "B")
  vroom_write(dat, tfile, delim = ",")
  expect_equal(readLines(tfile), c("a,b", "A,B"))
})

test_that("can read/write a compressed file with non-ascii characters in path", {
  skip_on_cran()
  skip_if_not_installed("archive")
  # https://github.com/r-lib/archive/issues/75
  skip_if(l10n_info()$`Latin-1`)

  make_temp_path <- function(ext) file.path(tempdir(), paste0("d\u00E4t", ext))

  gzfile <- withr::local_file(make_temp_path(".tar.gz"))
  bz2file <- withr::local_file(make_temp_path(".tar.bz2"))
  xzfile <- withr::local_file(make_temp_path(".tar.xz"))
  zipfile <- withr::local_file(make_temp_path(".zip"))

  dat <- tibble::tibble(a = "A", b = "B")

  vroom_write(dat, gzfile)
  vroom_write(dat, bz2file)
  vroom_write(dat, xzfile)
  vroom_write(dat, zipfile)

  expect_equal(detect_compression(gzfile), "gz")
  expect_equal(detect_compression(bz2file), "bz2")
  expect_equal(detect_compression(xzfile), "xz")
  expect_equal(detect_compression(zipfile), "zip")

  expect_equal(vroom(gzfile, show_col_types = FALSE), dat)
  expect_equal(vroom(bz2file, show_col_types = FALSE), dat)
  expect_equal(vroom(xzfile, show_col_types = FALSE), dat)
  expect_equal(vroom(zipfile, show_col_types = FALSE), dat)
})

test_that("can read fwf file w/ non-ascii characters in path", {
  tfile <- withr::local_tempfile(pattern = "fwf-y\u00F6-", fileext = ".txt")
  writeLines(c("A B", "C D"), tfile)

  expect_equal(
    spec <- fwf_empty(tfile, col_names = c("a", "b")),
    list(begin = c(0L, 2L), end = c(1L, NA), col_names = c("a", "b"))
  )

  expect_equal(
    vroom_fwf(tfile, spec, show_col_types = FALSE),
    tibble::tibble(a = c("A", "C"), b = c("B", "D"))
  )
})

test_that("standardise_path() errors for a mix of connection and not connection", {
  file <- test_path("multi-file", "foo")
  conn <- file(test_path("multi-file", "bar"))
  on.exit(close(conn))

  # wrap it, so we can check the caller is displayed correctly
  f <- function(some_arg_name) {
    standardise_path(some_arg_name)
  }

  expect_snapshot(
    error = TRUE,
    f(list(file, conn))
  )
})

test_that("standardise_path() errors for invalid input", {
  files <- test_path("multi-file", c("foo", "baz"))
  # wrap it, so we can check the caller is displayed correctly
  f <- function(some_arg_name) {
    standardise_path(some_arg_name)
  }

  expect_snapshot(
    error = TRUE,
    f(as.list(files))
  )
})

test_that("multiple files with non-ASCII encoding fails informatively", {
  input <- vroom_example("mtcars.csv")
  expect_snapshot(
    vroom(c(input, input), locale = locale(encoding = "UTF-16")),
    error = TRUE
  )
})

test_that("writing to .zip without archive package fails informatively", {
  skip_if(is_installed("archive"))

  expect_snapshot(
    vroom_write(mtcars, tempfile(fileext = ".zip")),
    error = TRUE
  )
})

test_that("reading archive-only formats without archive package fails informatively", {
  skip_if(is_installed("archive"))

  expect_snapshot(
    vroom(vroom_example("mtcars.csv.tar.gz"), col_types = list()),
    error = TRUE
  )
})

#' Structure of objects
#'
#' Similar to `str()` but with more information for Altrep objects.
#'
#' @param x a vector
#' @examples
#' # when used on non-altrep objects altrep will always be false
#' vroom_str(mtcars)
#'
#' mt <- vroom(vroom_example("mtcars.csv"), ",", altrep = c("chr", "dbl"))
#' vroom_str(mt)
#' @export
vroom_str <- function(x) {
  UseMethod("vroom_str")
}

#' @export
vroom_str.data.frame <- function(x) {
  classes <- glue::glue_collapse(
    glue::single_quote(class(x)),
    ", ",
    last = ", and "
  )
  rows <- nrow(x)
  cols <- ncol(x)

  cat(glue::glue("{classes}: {rows} obs., {cols} vars.:\n\n"), sep = "")
  nms <- names(x)
  for (i in seq_along(x)) {
    cat("$", nms[[i]], ":\t", sep = "")
    vroom_str(x[[i]])
  }
}

#' @export
vroom_str.default <- function(x) {
  cat(vroom_str_(x))
}

#' Read lines from a file
#'
#' `vroom_lines()` is similar to `readLines()`, however it reads the lines
#' lazily like [vroom()], so operations like `length()`, `head()`, `tail()` and `sample()`
#' can be done much more efficiently without reading all the data into R.
#' @inheritParams vroom
#' @examples
#' lines <- vroom_lines(vroom_example("mtcars.csv"))
#'
#' length(lines)
#' head(lines, n = 2)
#' tail(lines, n = 2)
#' sample(lines, size = 2)
#' @export
vroom_lines <- function(
  file,
  n_max = Inf,
  skip = 0,
  na = character(),
  skip_empty_rows = FALSE,
  locale = default_locale(),
  altrep = TRUE,
  num_threads = vroom_threads(),
  progress = vroom_progress()
) {
  check_number_decimal(n_max)

  file <- standardise_path(file)

  if (!is_ascii_compatible(locale$encoding)) {
    file <- reencode_file(file, locale$encoding)
    locale$encoding <- "UTF-8"
  }

  if (n_max < 0 || is.infinite(n_max)) {
    n_max <- -1
  }

  if (length(file) == 0 || n_max == 0) {
    return(character())
  }

  col_select <- quo(NULL)

  # delim = "\1" sets the delimiter to be start of header, which should never
  # appear in modern text. This essentially means the only record breaks will
  # be newlines. Ideally this would be "\0", but R doesn't let you have nulls
  # in character vectors.
  out <- vroom_(
    file,
    delim = "\1",
    col_names = "V1",
    col_types = cols(col_character()),
    id = NULL,
    skip = skip,
    col_select = col_select,
    name_repair = "minimal",
    na = na,
    quote = "",
    trim_ws = FALSE,
    escape_double = FALSE,
    escape_backslash = FALSE,
    comment = "",
    skip_empty_rows = skip_empty_rows,
    locale = locale,
    guess_max = 0,
    n_max = n_max,
    altrep = vroom_altrep(altrep),
    num_threads = num_threads,
    progress = progress
  )
  if (length(out) == 0) {
    return(character())
  }

  out[[1]]
}

test_that("vroom_lines works with normal files", {
  infile <- vroom_example("mtcars.csv")

  expected <- readLines(infile)

  actual <- vroom_lines(infile)

  expect_equal(length(actual), length(expected))

  expect_equal(head(actual), head(expected))

  expect_equal(tail(actual), tail(expected))

  expect_equal(actual, expected)
})

test_that("vroom_lines works with connections files", {
  infile <- vroom_example("mtcars.csv")

  con <- file(infile)
  expected <- readLines(con)
  close(con)

  actual <- vroom_lines(file(infile))

  expect_equal(length(actual), length(expected))

  expect_equal(head(actual), head(expected))

  expect_equal(tail(actual), tail(expected))

  expect_equal(actual, expected)
})


test_that("vroom_lines works with files with no trailing newline", {
  f <- tempfile()
  on.exit(unlink(f))

  writeBin(charToRaw("foo"), f)
  expect_equal(vroom_lines(f), "foo")

  f2 <- tempfile()
  on.exit(unlink(f2), add = TRUE)

  writeBin(charToRaw("foo\nbar"), f2)
  expect_equal(vroom_lines(f2), c("foo", "bar"))
})

test_that("vroom_lines respects n_max", {
  infile <- vroom_example("mtcars.csv")
  expect_equal(vroom_lines(infile, n_max = 2), readLines(infile, n = 2))
})

test_that("vroom_lines works with empty files", {
  f <- tempfile()
  file.create(f)
  on.exit(unlink(f))

  expect_equal(vroom_lines(f), character())
})

test_that("vroom_lines uses na argument", {
  expect_equal(vroom_lines(I("abc\n123"), progress = FALSE), c("abc", "123"))
  expect_equal(
    vroom_lines(I("abc\n123"), na = "abc", progress = FALSE),
    c(NA_character_, "123")
  )
  expect_equal(
    vroom_lines(I("abc\n123"), na = "123", progress = FALSE),
    c("abc", NA_character_)
  )
  expect_equal(
    vroom_lines(I("abc\n123"), na = c("abc", "123"), progress = FALSE),
    c(NA_character_, NA_character_)
  )
})

test_that("vroom_lines works with files with mixed line endings", {
  expect_equal(
    vroom_lines(I("foo\r\n\nbar\n\r\nbaz\r\n")),
    c("foo", "", "bar", "", "baz")
  )
})

#' Get path to vroom examples
#'
#' vroom comes bundled with a number of sample files in
#' its 'inst/extdata' directory. Use `vroom_examples()` to list all the
#' available examples and `vroom_example()` to retrieve the path to one
#' example.
#' @param path Name of file.
#' @param pattern A regular expression of filenames to match. If `NULL`, all
#'   available files are returned.
#' @export
#' @examples
#' # List all available examples
#' vroom_examples()
#'
#' # Get path to one example
#' vroom_example("mtcars.csv")
vroom_example <- function(path) {
  system.file("extdata", path, package = "vroom", mustWork = TRUE)
}

#' @rdname vroom_example
#' @export
vroom_examples <- function(pattern = NULL) {
  list.files(system.file("extdata", package = "vroom"), pattern = pattern)
}

#' Read a delimited file into a tibble
#'
#' @param file Either a path to a file, a connection, or literal data (either a
#'   single string or a raw vector). `file` can also be a character vector
#'   containing multiple filepaths or a list containing multiple connections.
#'
#'   Files ending in `.gz`, `.bz2`, `.xz`, or `.zip` will be automatically
#'   decompressed. Files starting with `http://`, `https://`, `ftp://`, or
#'   `ftps://` will be automatically downloaded. Remote compressed files
#'   (`.gz`, `.bz2`, `.xz`, `.zip`) will be automatically downloaded and
#'   decompressed.
#'
#'   Literal data is most useful for examples and tests. To be recognised as
#'   literal data, wrap the input with `I()`.
#' @param delim One or more characters used to delimit fields within a
#'   file. If `NULL` the delimiter is guessed from the set of `c(",", "\t", " ",
#'   "|", ":", ";")`.
#' @param col_names Either `TRUE`, `FALSE` or a character vector
#'   of column names.
#'
#'   If `TRUE`, the first row of the input will be used as the column
#'   names, and will not be included in the data frame. If `FALSE`, column
#'   names will be generated automatically: X1, X2, X3 etc.
#'
#'   If `col_names` is a character vector, the values will be used as the
#'   names of the columns, and the first row of the input will be read into
#'   the first row of the output data frame.
#'
#'   Missing (`NA`) column names will generate a warning, and be filled
#'   in with dummy names `...1`, `...2` etc. Duplicate column names
#'   will generate a warning and be made unique, see `name_repair` to control
#'   how this is done.
#' @param col_types One of `NULL`, a [cols()] specification, or
#'   a string.
#'
#'   If `NULL`, all column types will be inferred from `guess_max` rows
#'   of the input, interspersed throughout the file. This is convenient (and
#'   fast), but not robust. If the guessed types are wrong, you'll need to
#'   increase `guess_max` or supply the correct types yourself.
#'
#'   Column specifications created by [list()] or [cols()] must contain
#'   one column specification for each column. If you only want to read a
#'   subset of the columns, use [cols_only()].
#'
#'   Alternatively, you can use a compact string representation where each
#'   character represents one column:
#' - c = character
#' - i = integer
#' - I = big integer
#' - n = number
#' - d = double
#' - l = logical
#' - f = factor
#' - D = date
#' - T = date time
#' - t = time
#' - ? = guess
#' - _ or - = skip
#'
#' By default, reading a file without a column specification will print a
#' message showing the guessed types. To suppress this message, set
#' `show_col_types = FALSE`.
#' @param id Either a string or 'NULL'. If a string, the output will contain a
#'   column with that name with the filename(s) as the value, i.e. this column
#'   effectively tells you the source of each row. If 'NULL' (the default), no
#'   such column will be created.
#' @param skip Number of lines to skip before reading data. If `comment` is
#'   supplied any commented lines are ignored _after_ skipping.
#' @param n_max Maximum number of lines to read.
#' @param na Character vector of strings to interpret as missing values. Set this
#'   option to `character()` to indicate no missing values.
#' @param quote Single character used to quote strings.
#' @param comment A string used to identify comments. Any text after the
#'   comment characters will be silently ignored.
#' @param skip_empty_rows Should blank rows be ignored altogether? i.e. If this
#'   option is `TRUE` then blank rows will not be represented at all.  If it is
#'   `FALSE` then they will be represented by `NA` values in all the columns.
#' @param trim_ws Should leading and trailing whitespace (ASCII spaces and tabs) be trimmed from
#'     each field before parsing it?
#' @param escape_double Does the file escape quotes by doubling them?
#'   i.e. If this option is `TRUE`, the value '""' represents
#'   a single quote, '"'.
#' @param escape_backslash Does the file use backslashes to escape special
#'   characters? This is more general than `escape_double` as backslashes
#'   can be used to escape the delimiter character, the quote character, or
#'   to add special characters like `\\n`.
#' @param locale The locale controls defaults that vary from place to place.
#'   The default locale is US-centric (like R), but you can use
#'   [locale()] to create your own locale that controls things like
#'   the default time zone, encoding, decimal mark, big mark, and day/month
#'   names.
#' @param guess_max Maximum number of lines to use for guessing column types.
#'   See `vignette("column-types", package = "readr")` for more details.
#' @param altrep Control which column types use Altrep representations,
#'   either a character vector of types, `TRUE` or `FALSE`. See
#'   [vroom_altrep()] for for full details.
#' @param col_select Columns to include in the results. You can use the same
#'   mini-language as `dplyr::select()` to refer to the columns by name. Use
#'   `c()` to use more than one selection expression. Although this
#'   usage is less common, `col_select` also accepts a numeric column index. See
#'   [`?tidyselect::language`][tidyselect::language] for full details on the
#'   selection language.
#' @param num_threads Number of threads to use when reading and materializing
#'   vectors. If your data contains newlines within fields the parser will
#'   automatically be forced to use a single thread only.
#' @param progress Display a progress bar? By default it will only display
#'   in an interactive session and not while executing in an RStudio notebook
#'   chunk. The display of the progress bar can be disabled by setting the
#'   environment variable `VROOM_SHOW_PROGRESS` to `"false"`.
#' @param show_col_types Control showing the column specifications. If `TRUE`
#'   column specifications are always shown, if `FALSE` they are never shown. If
#'   `NULL` (the default), they are shown only if an explicit specification is
#'   not given in `col_types`, i.e. if the types have been guessed.
#' @param .name_repair Handling of column names. The default behaviour is to
#'   ensure column names are `"unique"`. Various repair strategies are
#'   supported:
#'   * `"minimal"`: No name repair or checks, beyond basic existence of names.
#'   * `"unique"` (default value): Make sure names are unique and not empty.
#'   * `"check_unique"`: No name repair, but check they are `unique`.
#'   * `"unique_quiet"`: Repair with the `unique` strategy, quietly.
#'   * `"universal"`: Make the names `unique` and syntactic.
#'   * `"universal_quiet"`: Repair with the `universal` strategy, quietly.
#'   * A function: Apply custom name repair (e.g., `name_repair = make.names`
#'     for names in the style of base R).
#'   * A purrr-style anonymous function, see [rlang::as_function()].
#'
#'   This argument is passed on as `repair` to [vctrs::vec_as_names()].
#'   See there for more details on these terms and the strategies used
#'   to enforce them.
#' @export
#' @examples
#' # get path to example file
#' input_file <- vroom_example("mtcars.csv")
#' input_file
#'
#' # Read from a path
#'
#' # Input sources -------------------------------------------------------------
#' # Read from a path
#' vroom(input_file)
#' # You can also use paths directly
#' # vroom("mtcars.csv")
#'
#' \dontrun{
#' # Including remote paths
#' vroom("https://github.com/tidyverse/vroom/raw/main/inst/extdata/mtcars.csv")
#' }
#'
#' # Or directly from a string with `I()`
#' vroom(I("x,y\n1,2\n3,4\n"))
#'
#' # Column selection ----------------------------------------------------------
#' # Pass column names or indexes directly to select them
#' vroom(input_file, col_select = c(model, cyl, gear))
#' vroom(input_file, col_select = c(1, 3, 11))
#'
#' # Or use the selection helpers
#' vroom(input_file, col_select = starts_with("d"))
#'
#' # You can also rename specific columns
#' vroom(input_file, col_select = c(car = model, everything()))
#'
#' # Column types --------------------------------------------------------------
#' # By default, vroom guesses the columns types, looking at 1000 rows
#' # throughout the dataset.
#' # You can specify them explicitly with a compact specification:
#' vroom(I("x,y\n1,2\n3,4\n"), col_types = "dc")
#'
#' # Or with a list of column types:
#' vroom(I("x,y\n1,2\n3,4\n"), col_types = list(col_double(), col_character()))
#'
#' # File types ----------------------------------------------------------------
#' # csv
#' vroom(I("a,b\n1.0,2.0\n"), delim = ",")
#' # tsv
#' vroom(I("a\tb\n1.0\t2.0\n"))
#' # Other delimiters
#' vroom(I("a|b\n1.0|2.0\n"), delim = "|")
#'
#' # Read datasets across multiple files ---------------------------------------
#' mtcars_by_cyl <- vroom_example(vroom_examples("mtcars-[468]"))
#' mtcars_by_cyl
#'
#' # Pass the filenames directly to vroom, they are efficiently combined
#' vroom(mtcars_by_cyl)
#'
#' # If you need to extract data from the filenames, use `id` to request a
#' # column that reveals the underlying file path
#' dat <- vroom(mtcars_by_cyl, id = "source")
#' dat$source <- basename(dat$source)
#' dat
vroom <- function(
  file,
  delim = NULL,
  col_names = TRUE,
  col_types = NULL,
  col_select = NULL,
  id = NULL,
  skip = 0,
  n_max = Inf,
  na = c("", "NA"),
  quote = '"',
  comment = "",
  skip_empty_rows = TRUE,
  trim_ws = TRUE,
  escape_double = TRUE,
  escape_backslash = FALSE,
  locale = default_locale(),
  guess_max = 100,
  altrep = TRUE,
  num_threads = vroom_threads(),
  progress = vroom_progress(),
  show_col_types = NULL,
  .name_repair = "unique"
) {
  check_number_decimal(n_max)
  check_number_decimal(guess_max)

  # vroom does not support newlines as the delimiter, just as the EOL, so just
  # assign a value that should never appear in CSV text as the delimiter,
  # 001, start of heading.
  if (identical(delim, "\n")) {
    delim <- "\x01"
  }

  file <- standardise_path(file)

  if (!is_ascii_compatible(locale$encoding)) {
    file <- reencode_file(file, locale$encoding)
    locale$encoding <- "UTF-8"
  }

  if (length(file) == 0 || (n_max == 0 & identical(col_names, FALSE))) {
    return(tibble::tibble())
  }

  if (n_max < 0 || is.infinite(n_max)) {
    n_max <- -1
  }

  if (guess_max < 0 || is.infinite(guess_max)) {
    guess_max <- -1
  }

  # Workaround weird RStudio / Progress bug: https://github.com/r-lib/progress/issues/56#issuecomment-384232184
  if (
    isTRUE(progress) &&
      is_windows() &&
      identical(Sys.getenv("RSTUDIO"), "1")
  ) {
    Sys.setenv("RSTUDIO" = "1")
  }

  col_select <- vroom_enquo(enquo(col_select))

  has_col_types <- !is.null(col_types)

  col_types <- as.col_spec(col_types)

  na <- enc2utf8(na)

  out <- vroom_(
    file,
    delim = delim %||% col_types$delim,
    col_names = col_names,
    col_types = col_types,
    id = id,
    skip = skip,
    col_select = col_select,
    name_repair = .name_repair,
    na = na,
    quote = quote,
    trim_ws = trim_ws,
    escape_double = escape_double,
    escape_backslash = escape_backslash,
    comment = comment,
    skip_empty_rows = skip_empty_rows,
    locale = locale,
    guess_max = guess_max,
    n_max = n_max,
    altrep = vroom_altrep(altrep),
    num_threads = num_threads,
    progress = progress
  )

  # If no rows, expand columns to be the same length and names as the spec
  # Skipped columns present a bit of a wrinkle: they appear in the spec,
  # but not in the result
  if (NROW(out) == 0) {
    cols <- attr(out, "spec")[["cols"]]
    nms <- names(cols)

    out_i <- 1
    for (cols_i in seq_along(cols)) {
      value <- collector_value(cols[[cols_i]])
      if (is.null(value)) {
        # this is a skipped column
        next
      }
      out[[out_i]] <- value
      names(out)[out_i] <- nms[cols_i]
      out_i <- out_i + 1
    }
  }

  out <- tibble::as_tibble(out, .name_repair = identity)

  out <- vroom_select(out, col_select, id)
  class(out) <- c("spec_tbl_df", class(out))

  if (should_show_col_types(has_col_types, show_col_types)) {
    show_col_types(out, locale)
  }

  out
}

should_show_col_types <- function(has_col_types, show_col_types) {
  if (is.null(show_col_types)) {
    return(isTRUE(!has_col_types))
  }
  isTRUE(show_col_types)
}

make_names <- function(x, len) {
  if (len == 0) {
    return(character())
  }

  if (length(x) == len) {
    return(x)
  }

  if (length(x) > len) {
    return(x[seq_len(len)])
  }

  nms <- make.names(seq_len(len))
  nms[seq_along(x)] <- x
  nms
}

#' Determine whether progress bars should be shown
#'
#' By default, vroom shows progress bars. However, progress reporting is
#' suppressed if any of the following conditions hold:
#' - The bar is explicitly disabled by setting the environment variable
#'   `VROOM_SHOW_PROGRESS` to `"false"`.
#' - The code is run in a non-interactive session, as determined by
#'   [rlang::is_interactive()].
#' - The code is run in an RStudio notebook chunk, as determined by
#'   `getOption("rstudio.notebook.executing")`.
#' @export
#' @examples
#' vroom_progress()
vroom_progress <- function() {
  env_to_logical("VROOM_SHOW_PROGRESS", TRUE) &&
    is_interactive() &&
    # some analysis re: rstudio.notebook.executing can be found in:
    # https://github.com/r-lib/rlang/issues/1031
    # TL;DR it's not consulted by is_interactive(), but probably should be
    # consulted for progress reporting specifically
    !isTRUE(getOption("rstudio.notebook.executing"))
}

pb_file_format <- function(filename) {
  # Workaround RStudio bug https://github.com/rstudio/rstudio/issues/4777
  withr::with_options(
    list(
      crayon.enabled = (!is_rstudio_console() ||
        is_rstudio_version("1.2.1578")) &&
        getOption("crayon.enabled", TRUE)
    ),
    glue::glue_col(
      "{bold}indexing{reset} {blue}{basename(filename)}{reset} [:bar] {green}:rate{reset}, eta: {cyan}:eta{reset}"
    )
  )
}

pb_width <- function(format) {
  ansii_chars <- nchar(format) - crayon::col_nchar(format)
  getOption("width", 80L) + ansii_chars
}

pb_connection_format <- function(unused) {
  withr::with_options(
    list(
      crayon.enabled = (!is_rstudio_console() ||
        is_rstudio_version("1.2.1578")) &&
        getOption("crayon.enabled", TRUE)
    ),
    glue::glue_col(
      "{bold}indexed{reset} {green}:bytes{reset} in {cyan}:elapsed{reset}, {green}:rate{reset}"
    )
  )
}

pb_write_format <- function(unused) {
  withr::with_options(
    list(
      crayon.enabled = (!is_rstudio_console() ||
        is_rstudio_version("1.2.1578")) &&
        getOption("crayon.enabled", TRUE)
    ),
    glue::glue_col(
      "{bold}wrote{reset} {green}:bytes{reset} in {cyan}:elapsed{reset}, {green}:rate{reset}"
    )
  )
}

# Guess delimiter by splitting every line by each delimiter and choosing the
# delimiter which splits the lines into the highest number of consistent fields.
# This looks like dead code on the R side, but it's called from C++.
guess_delim <- function(lines, delims = c(",", "\t", " ", "|", ":", ";")) {
  if (length(lines) == 0) {
    return("")
  }

  # blank text within quotes
  lines <- gsub('"[^"]*"', "", lines)

  splits <- lapply(delims, strsplit, x = lines, useBytes = TRUE, fixed = TRUE)

  counts <- lapply(splits, function(x) table(lengths(x)))

  num_fields <- vapply(
    counts,
    function(x) as.integer(names(x)[[1]]),
    integer(1)
  )

  num_lines <- vapply(counts, function(x) (x)[[1]], integer(1))

  top_lines <- 0
  top_idx <- 0
  for (i in seq_along(delims)) {
    if (
      num_fields[[i]] >= 2 &&
        num_lines[[i]] > top_lines ||
        (top_lines == num_lines[[i]] &&
          (top_idx <= 0 || num_fields[[top_idx]] < num_fields[[i]]))
    ) {
      top_lines <- num_lines[[i]]
      top_idx <- i
    }
  }
  if (top_idx == 0) {
    cli::cli_abort(c(
      "Could not guess the delimiter.",
      "i" = "Use {.code vroom(delim =)} to explicitly specify the delimiter."
    ))
  }

  delims[[top_idx]]
}

cached <- new.env(parent = emptyenv())

vroom_threads <- function() {
  res <- as.integer(
    Sys.getenv(
      "VROOM_THREADS",
      cached$num_threads <- cached$num_threads %||% parallel::detectCores()
    )
  )
  if (is.na(res) || res <= 0) {
    res <- 1
  }
  res
}

#' Show which column types are using Altrep
#'
#' `vroom_altrep()` can be used directly as input to the `altrep`
#' argument of [vroom()].
#'
#' Alternatively there is also a family of environment variables to control use of
#' the Altrep framework. These can then be set in your `.Renviron` file, e.g.
#' with `usethis::edit_r_environ()`. The variables can take one of `true`, `false`,
#' `TRUE`, `FALSE`, `1`, or `0`.
#'
#' - `VROOM_USE_ALTREP_NUMERICS` - If set use Altrep for _all_ numeric types
#'   (default `false`).
#'
#' There are also individual variables for each type. Currently only
#' `VROOM_USE_ALTREP_CHR` defaults to `true`.
#'
#' - `VROOM_USE_ALTREP_CHR`
#' - `VROOM_USE_ALTREP_FCT`
#' - `VROOM_USE_ALTREP_INT`
#' - `VROOM_USE_ALTREP_BIG_INT`
#' - `VROOM_USE_ALTREP_DBL`
#' - `VROOM_USE_ALTREP_NUM`
#' - `VROOM_USE_ALTREP_LGL`
#' - `VROOM_USE_ALTREP_DTTM`
#' - `VROOM_USE_ALTREP_DATE`
#' - `VROOM_USE_ALTREP_TIME`
#'
#' @param which A character vector of column types to use Altrep for. Can also
#'   take `TRUE` or `FALSE` to use Altrep for all possible or none of the
#'   types
#' @examples
#' vroom_altrep()
#' vroom_altrep(c("chr", "fct", "int"))
#' vroom_altrep(TRUE)
#' vroom_altrep(FALSE)
#' @export
vroom_altrep <- function(which = NULL) {
  if (!is.null(which)) {
    if (is.logical(which)) {
      types <- names(altrep_vals())
      if (isTRUE(which)) {
        which <- as.list(stats::setNames(rep(TRUE, length(types)), types))
      } else {
        which <- as.list(stats::setNames(rep(FALSE, length(types)), types))
      }
    } else {
      which <- match.arg(which, names(altrep_vals()), several.ok = TRUE)
      which <- as.list(stats::setNames(rep(TRUE, length(which)), which))
    }
  }

  args <- list(
    which$chr %||% vroom_use_altrep_chr(),
    which$fct %||% vroom_use_altrep_fct(),
    which$int %||% vroom_use_altrep_int(),
    which$dbl %||% vroom_use_altrep_dbl(),
    which$num %||% vroom_use_altrep_num(),
    which$lgl %||% vroom_use_altrep_lgl(),
    which$dttm %||% vroom_use_altrep_dttm(),
    which$date %||% vroom_use_altrep_date(),
    which$time %||% vroom_use_altrep_time(),
    which$big_int %||% vroom_use_altrep_big_int()
  )

  out <- 0L
  for (i in seq_along(args)) {
    out <- bitwOr(out, bitwShiftL(as.integer(args[[i]]), i - 1L))
  }
  structure(out, class = "vroom_altrep")
}

altrep_vals <- function() {
  c(
    "none" = 0L,
    "chr" = 1L,
    "fct" = 2L,
    "int" = 4L,
    "dbl" = 8L,
    "num" = 16L,
    "lgl" = 32L,
    "dttm" = 64L,
    "date" = 128L,
    "time" = 256L,
    "big_int" = 512L,
    "skip" = 1024L
  )
}

#' @export
print.vroom_altrep <- function(x, ...) {
  vals <- altrep_vals()
  reps <- names(vals)[bitwAnd(vals, x) > 0]

  cat(
    "Using Altrep representations for:\n",
    glue::glue(
      "
        * {reps}
       ",
      reps = glue::glue_collapse(reps, "\n * ")
    ),
    "\n",
    sep = ""
  )
}

vroom_use_altrep_chr <- function() {
  env_to_logical("VROOM_USE_ALTREP_CHR", TRUE)
}

vroom_use_altrep_fct <- function() {
  # fct is a numeric internally
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_FCT", FALSE)
}

vroom_use_altrep_int <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_INT", FALSE)
}

vroom_use_altrep_big_int <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_BIG_INT", FALSE)
}

vroom_use_altrep_dbl <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_DBL", FALSE)
}

vroom_use_altrep_num <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_NUM", FALSE)
}

vroom_use_altrep_lgl <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_LGL", FALSE)
}

vroom_use_altrep_dttm <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_DTTM", FALSE)
}

vroom_use_altrep_date <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_DATE", FALSE)
}

vroom_use_altrep_time <- function() {
  env_to_logical("VROOM_USE_ALTREP_NUMERICS", FALSE) ||
    env_to_logical("VROOM_USE_ALTREP_TIME", FALSE)
}

# Encoding ----------------------------------------------------------------

test_that("locale encoding affects parsing", {
  x <- c("ao\u00FBt", "\u00E9l\u00E8ve", "\u00E7a va")
  #expect_equal(Encoding(x), rep("UTF-8", 3))

  y <- iconv(paste0(x, collapse = "\n"), "UTF-8", "latin1")
  #expect_equal(Encoding(y), "latin1")

  fr <- locale("fr", encoding = "latin1")
  z <- vroom(
    I(y),
    delim = ",",
    locale = fr,
    col_names = FALSE,
    col_types = list()
  )
  # expect_equal(Encoding(z[[1]]), rep("UTF-8", 3))

  # identical coerces encodings to match, so need to compare raw values
  as_raw <- function(x) lapply(x, charToRaw)
  expect_identical(as_raw(x), as_raw(z[[1]]))
})

test_that("encodings are respected", {
  loc <- locale(encoding = "ISO-8859-1")
  expected <- c("fran\u00e7ais", "\u00e9l\u00e8ve")

  x <- vroom(
    test_path("enc-iso-8859-1.txt"),
    delim = "\n",
    locale = loc,
    col_names = FALSE,
    col_types = list()
  )
  expect_equal(x[[1]], expected)
})

test_that("Large exponents can parse", {
  res <- vroom(
    I("1e-63,1e-64\n"),
    delim = ",",
    col_types = "dd",
    col_names = FALSE
  )
  expect_equal(res[[1]], 1e-63)
  expect_equal(res[[2]], 1e-64)
})

test_that("Doubles parse correctly with comma as decimal separator", {
  res <- vroom(
    I("23,4\n"),
    delim = '\t',
    altrep = FALSE,
    locale = locale(decimal_mark = ','),
    col_types = 'd',
    col_names = FALSE
  )
  expect_equal(res[[1]], 23.4)
  res2 <- vroom(
    I("23,4\n"),
    delim = '\t',
    altrep = TRUE,
    locale = locale(decimal_mark = ','),
    col_types = 'd',
    col_names = FALSE
  )
  expect_equal(res2[[1]], 23.4)
})

test_that("NA can be a double value", {
  test_vroom(
    I("x\n1\n2\n"),
    delim = ",",
    col_types = "d",
    na = "1",
    equals = tibble::tibble(x = c(NA_real_, 2))
  )
})

test_that("NaN values are guessed and parsed as doubles (https://github.com/tidyverse/readr/issues/1277)", {
  test_vroom(
    I("x\nNaN\n"),
    delim = ",",
    col_types = "?",
    equals = tibble::tibble(x = c(NaN))
  )
})

test_that("Test that values with only a NaN prefix are _not_ parsed as doubles", {
  test_vroom(
    I("x\nNaNa\n"),
    delim = ",",
    col_types = "?",
    equals = tibble::tibble(x = c("NaNa"))
  )
})

test_that("Inf and -Inf values are guessed and parsed as doubles (https://github.com/tidyverse/readr/issues/1283)", {
  test_vroom(
    I("x\nInf\n-Inf\n+Inf"),
    delim = ",",
    col_types = "?",
    equals = tibble::tibble(x = c(Inf, -Inf, Inf))
  )
})

test_that("Test that values with only a Inf prefix are _not_ parsed as doubles", {
  test_vroom(
    I("x\nInfa\n-Infb\n+Infc"),
    delim = ",",
    col_types = "?",
    equals = tibble::tibble(x = c("Infa", "-Infb", "+Infc"))
  )
})

#' Write a data frame to a delimited file
#'
#' @inheritParams vroom
#' @param x A data frame or tibble to write to disk.
#' @param file File or connection to write to.
#' @param escape The type of escape to use when quotes are in the data.
#'   - `double` - quotes are escaped by doubling them.
#'   - `backslash` - quotes are escaped by a preceding backslash.
#'   - `none` - quotes are not escaped.
#' @param quote How to handle fields which contain characters that need to be
#'   quoted.
#'   - `needed` - Values are only quoted if needed: if they contain a delimiter,
#'     quote, or newline.
#'   - `all` - Quote all fields.
#'   - `none` - Never quote fields.
#' @param bom If `TRUE` add a UTF-8 BOM at the beginning of the file. This is
#'   recommended when saving data for consumption by excel, as it will force
#'   excel to read the data with the correct encoding (UTF-8)
#' @param delim Delimiter used to separate values. Defaults to `\t` to write
#'   tab separated value (TSV) files.
#' @param eol The end of line character to use. Most commonly either `"\n"` for
#'   Unix style newlines, or `"\r\n"` for Windows style newlines.
#' @param na String used for missing values. Defaults to 'NA'.
#' @param col_names If `FALSE`, column names will not be included at the top of
#'   the file. If `TRUE`, column names will be included. If not specified,
#'   `col_names` will take the opposite value given to `append`.
#' @param append If `FALSE`, will overwrite existing file. If `TRUE`,
#'   will append to existing file. In both cases, if the file does not exist, a
#'   new file is created.
#' @export
#' @examples
#' # If you only specify a file name, vroom_write() will write
#' # the file to your current working directory.
#' out_file <- tempfile(fileext = "csv")
#' vroom_write(mtcars, out_file, ",")
#'
#' # You can also use a literal filename
#' # vroom_write(mtcars, "mtcars.tsv")
#'
#' # If you add an extension to the file name, write_()* will
#' # automatically compress the output.
#' # vroom_write(mtcars, "mtcars.tsv.gz")
#' # vroom_write(mtcars, "mtcars.tsv.bz2")
#' # vroom_write(mtcars, "mtcars.tsv.xz")
vroom_write <- function(
  x,
  file,
  delim = '\t',
  eol = "\n",
  na = "NA",
  col_names = !append,
  append = FALSE,
  quote = c("needed", "all", "none"),
  escape = c("double", "backslash", "none"),
  bom = FALSE,
  num_threads = vroom_threads(),
  progress = vroom_progress()
) {
  input <- x

  quote <- arg_match(quote)
  escape <- arg_match(escape)

  opts <- get_vroom_write_opts(quote, escape, bom)

  file <- connection_or_filepath(file, write = TRUE)

  if (NCOL(x) == 0) {
    if (!append && !inherits(file, "connection")) {
      # if file already exists, it is overwritten with an empty file!
      file.create(file)
    }
    return(invisible(input))
  }

  # This seems to work ok in practice
  buf_lines <- max(
    as.integer(Sys.getenv(
      "VROOM_WRITE_BUFFER_LINES",
      nrow(x) / 100 / num_threads
    )),
    1
  )

  # Run `output_column()` before `vroom_convert()` to ensure that any ALTREP
  # vectors created by `output_column()` will be fully materialized (#389)
  x[] <- lapply(x, output_column)

  # We need to convert any altrep vectors to normal vectors otherwise we can't fill the
  # write buffers from other threads. This should be the last manipulation done
  # to `x` before writing to ensure that no new altrep vectors are created.
  x <- vroom_convert(x)

  if (inherits(file, "connection")) {
    vroom_write_connection_(
      x,
      file,
      delim,
      eol,
      na_str = na,
      col_names = col_names,
      options = opts,
      num_threads = num_threads,
      progress = progress,
      buf_lines = buf_lines,
      is_stdout = file == stdout(),
      append = append
    )
  } else {
    vroom_write_(
      x,
      file,
      delim,
      eol,
      na_str = na,
      col_names = col_names,
      append = append,
      options = opts,
      num_threads = num_threads,
      progress = progress,
      buf_lines = buf_lines
    )
  }

  invisible(input)
}


get_vroom_write_opts <- function(quote, escape, bom) {
  v_opts <- vroom_write_opts()
  bitwOr(
    v_opts[paste0("quote_", quote)],
    bitwOr(
      v_opts[paste0("escape_", escape)],
      if (bom) v_opts["bom"] else 0
    )
  )
}

vroom_write_opts <- function() {
  c(
    "quote_none" = 0L,
    "escape_none" = 0L,
    "quote_needed" = 1L,
    "quote_all" = 2L,
    "escape_double" = 4L,
    "escape_backslash" = 8L,
    "bom" = 16L
  )
}

#' Convert a data frame to a delimited string
#'
#' This is equivalent to [vroom_write()], but instead of writing to
#' disk, it returns a string. It is primarily useful for examples and for
#' testing.
#'
#' @inheritParams vroom_write
#' @export
vroom_format <- function(
  x,
  delim = "\t",
  eol = "\n",
  na = "NA",
  col_names = TRUE,
  escape = c("double", "backslash", "none"),
  quote = c("needed", "all", "none"),
  bom = FALSE,
  num_threads = vroom_threads()
) {
  check_data_frame(x)

  if (NCOL(x) == 0) {
    return("")
  }

  quote <- arg_match(quote)
  escape <- arg_match(escape)

  opts <- get_vroom_write_opts(quote, escape, bom)

  # This seems to work ok in practice
  buf_lines <- max(
    as.integer(Sys.getenv(
      "VROOM_WRITE_BUFFER_LINES",
      nrow(x) / 100 / num_threads
    )),
    1
  )

  x[] <- lapply(x, output_column)
  vroom_format_(
    x,
    delim = delim,
    eol = eol,
    na_str = na,
    col_names = col_names,
    append = FALSE,
    options = opts,
    num_threads = vroom_threads(),
    progress = vroom_progress(),
    buf_lines = buf_lines
  )
}

#' Write lines to a file
#'
#' @param x A character vector.
#' @inheritParams vroom_write
#' @export
vroom_write_lines <- function(
  x,
  file,
  eol = "\n",
  na = "NA",
  append = FALSE,
  num_threads = vroom_threads()
) {
  check_character(x)

  x <- list(X1 = x)
  class(x) <- "data.frame"
  attr(x, "row.names") <- c(NA_integer_, -length(x[[1]]))

  vroom_write(
    x,
    file = file,
    delim = "",
    col_names = FALSE,
    eol = eol,
    na = na,
    append = append,
    quote = "none",
    escape = "none",
    num_threads = num_threads
  )
}

#' Preprocess column for output
#'
#' This is a generic function that applied to each column before it is saved
#' to disk. It provides a hook for S3 classes that need special handling.
#'
#' @keywords internal
#' @param x A vector
#' @examples
#' # Most types are returned unchanged
#' output_column(1)
#' output_column("x")
#'
#' # datetimes are formatted in ISO 8601
#' output_column(Sys.Date())
#' output_column(Sys.time())
#' @export
output_column <- function(x) {
  UseMethod("output_column")
}

#' @export
output_column.default <- function(x) {
  if (!is.object(x)) {
    return(x)
  }
  as.character(x)
}

#' @export
output_column.double <- function(x) {
  x
}

#' @export
output_column.POSIXt <- function(x) {
  format(x, "%Y-%m-%dT%H:%M:%OSZ", tz = "UTC", justify = "none")
}

#' @export
output_column.character <- function(x) {
  x
}

#' @export
output_column.factor <- function(x) {
  # TODO: look into doing writing directly in C++
  as.character(x)
}

test_that("empty columns create an empty file", {
  out <- tempfile()

  no_cols <- mtcars[, FALSE]
  no_rows_or_cols <- mtcars[FALSE, FALSE]

  expect_equal(vroom_write(no_cols, out), no_cols)
  expect_true(file.exists(out))
  unlink(out)

  expect_equal(vroom_write(no_rows_or_cols, out), no_rows_or_cols)
  expect_true(file.exists(out))
})

test_that("empty rows print the headers", {
  out <- tempfile()
  on.exit(unlink(out))

  no_rows <- mtcars[FALSE, ]

  expect_equal(vroom_write(no_rows, out), no_rows)

  expect_equal(strsplit(readLines(out), "\t")[[1]], colnames(mtcars))
})

test_that("strings are only quoted if needed", {
  x <- c("a", ',')

  csv <- vroom_format(data.frame(x), delim = ",", col_names = FALSE)
  expect_equal(csv, 'a\n\",\"\n')
  ssv <- vroom_format(data.frame(x), delim = " ", col_names = FALSE)
  expect_equal(ssv, 'a\n,\n')
})

test_that("read_delim/csv/tsv and write_delim round trip special chars", {
  x <- stats::setNames(
    list("a", '"', ",", "\n", "at\t"),
    paste0("V", seq_len(5))
  )

  output <- tibble::as_tibble(x)
  output_space <- vroom(
    I(vroom_format(output, delim = " ")),
    trim_ws = FALSE,
    progress = FALSE,
    col_types = list()
  )
  output_csv <- vroom(
    I(vroom_format(output, delim = ",")),
    trim_ws = FALSE,
    progress = FALSE,
    col_types = list()
  )
  output_tsv <- vroom(
    I(vroom_format(output, delim = "\t")),
    trim_ws = FALSE,
    progress = FALSE,
    col_types = list()
  )
  expect_equal(output_space, output)
  expect_equal(output_csv, output)
  expect_equal(output_tsv, output)
})

test_that("special floating point values translated to text", {
  df <- data.frame(x = c(NaN, NA, Inf, -Inf))
  expect_equal(vroom_format(df), "x\nNA\nNA\nInf\n-Inf\n")
})

test_that("NA integer values translated to text", {
  df <- data.frame(x = c(NA, 1L, 5L, 1234567890L))
  expect_equal(vroom_format(df), "x\nNA\n1\n5\n1234567890\n")
})

test_that("logical values give long names", {
  df <- data.frame(x = c(NA, FALSE, TRUE))
  expect_equal(vroom_format(df), "x\nNA\nFALSE\nTRUE\n")
})

test_that("roundtrip preserved floating point numbers", {
  input <- data.frame(x = runif(100))
  output <- vroom(
    I(vroom_format(input, delim = " ")),
    delim = " ",
    col_types = list()
  )

  expect_equal(input$x, output$x)
})

test_that("roundtrip preserves dates and datetimes", {
  x <- as.Date("2010-01-01") + 1:10
  y <- as.POSIXct(x)
  attr(y, "tzone") <- "UTC"

  input <- data.frame(x, y)
  output <- vroom(
    I(vroom_format(input, delim = " ")),
    delim = " ",
    col_types = list()
  )

  expect_equal(output$x, x)
  expect_equal(output$y, y)
})

test_that("fails to create file in non-existent directory", {
  expect_snapshot(
    vroom_write(mtcars, file.path(tempdir(), "x", "y"), "\t"),
    error = TRUE,
    transform = function(x) {
      # Scrub any path before x/y (works on all platforms)
      x <- gsub("\\\\", "/", x) # Normalize backslashes first
      x <- gsub("'[^']+/(?=x/y)", "'<temp>/", x, perl = TRUE)
      x
    }
  )
})

test_that("includes a byte order mark if desired", {
  tmp <- tempfile()
  on.exit(unlink(tmp))

  vroom_write(mtcars, tmp, bom = TRUE)

  output <- readBin(tmp, "raw", file.info(tmp)$size)

  # BOM is there
  expect_equal(output[1:3], charToRaw("\xEF\xBB\xBF"))

  # Rest of file also there
  expect_equal(output[4:6], charToRaw("mpg"))
})


test_that("does not writes a trailing .0 for whole number doubles", {
  expect_equal(vroom_format(tibble::tibble(x = 1)), "x\n1\n")

  expect_equal(vroom_format(tibble::tibble(x = 0)), "x\n0\n")

  expect_equal(vroom_format(tibble::tibble(x = -1)), "x\n-1\n")

  expect_equal(vroom_format(tibble::tibble(x = 999)), "x\n999\n")

  expect_equal(vroom_format(tibble::tibble(x = -999)), "x\n-999\n")

  expect_equal(vroom_format(tibble::tibble(x = 123456789)), "x\n123456789\n")

  expect_equal(vroom_format(tibble::tibble(x = -123456789)), "x\n-123456789\n")
})

test_that("can write windows eol characters if desired (#263)", {
  expect_equal(vroom_format(tibble::tibble(x = 1), eol = "\r\n"), "x\r\n1\r\n")
})

test_that("write_csv can write to compressed files", {
  mt <- vroom(vroom_example("mtcars.csv"), col_types = list())

  filename <- file.path(tempdir(), "mtcars.csv.bz2")
  on.exit(unlink(filename))
  vroom_write(mt, filename)

  is_bz2_file <- function(x) {
    # Magic number for bz2 is "BZh" in ASCII
    # https://en.wikipedia.org/wiki/Bzip2#File_format
    identical(charToRaw("BZh"), readBin(x, n = 3, what = "raw"))
  }

  expect_true(is_bz2_file(filename))

  expect_equal(vroom(filename, col_types = list()), mt)
})

test_that("write_csv writes large integers without scientific notation #671", {
  x <- data.frame(a = c(60150001022000, 60150001022001))
  expect_equal(vroom_format(x), "a\n60150001022000\n60150001022001\n")
})

test_that("write_csv writes large integers without scientific notation up to 1E15 #671", {
  x <- data.frame(a = c(1E13, 1E14, 1E15, 1E16))
  expect_equal(
    vroom_format(x),
    "a\n10000000000000\n100000000000000\n1e15\n1e16\n"
  )
})

#test_that("write_csv2 and format_csv2 writes ; sep and , decimal mark", {
#df <- tibble::tibble(x = c(0.5, 2, 1.2), y = c("a", "b", "c"))
#expect_equal(format_csv2(df), "x;y\n0,5;a\n2,0;b\n1,2;c\n")

#filename <- tempfile(pattern = "readr", fileext = ".csv")
#on.exit(unlink(filename))
#write_csv2(df, filename)

#expect_equivalent(df, suppressMessages(read_csv2(filename)))
#})

#test_that("write_csv2 and format_csv2 writes NA appropriately", {
#df <- tibble::tibble(x = c(0.5, NA, 1.2), y = c("a", "b", NA))
#expect_equal(format_csv2(df), "x;y\n0,5;a\nNA;b\n1,2;NA\n")
#})

test_that("Can change the escape behavior for quotes", {
  df <- data.frame(x = c("a", '"', ",", "\n"))

  expect_snapshot(error = TRUE, {
    vroom_format(df, "\t", escape = "invalid")
  })

  expect_equal(vroom_format(df, "\t"), 'x\na\n""""\n,\n"\n"\n')
  expect_equal(
    vroom_format(df, "\t", escape = "double"),
    "x\na\n\"\"\"\"\n,\n\"\n\"\n"
  )
  expect_equal(
    vroom_format(df, "\t", escape = "backslash"),
    "x\na\n\"\\\"\"\n,\n\"\n\"\n"
  )
  expect_equal(
    vroom_format(df, "\t", escape = "none"),
    "x\na\n\"\"\"\n,\n\"\n\"\n"
  )
})

test_that("hms NAs are written without padding (#930)", {
  df <- data.frame(x = hms::as_hms(c(NA, 34.234)))
  expect_equal(vroom_format(df), "x\nNA\n00:00:34.234\n")
})

test_that("vroom_write equals the same thing as vroom_format", {
  df <- gen_tbl(100, 8, col_types = c("dilfcDtT"), missing = .1)
  tf <- tempfile()
  on.exit(unlink(tf))

  # Temporarily run with 2 lines per buffer, to test the multithreading
  withr::with_envvar(
    c("VROOM_WRITE_BUFFER_LINES" = "2"),
    vroom_write(df, tf, "\t")
  )

  expect_equal(readChar(tf, file.info(tf)$size), vroom_format(df))
})

test_that("vroom_format handles empty data frames", {
  df <- data.frame()
  expect_equal(vroom_format(df), "")

  df <- data.frame(a = 1:2, b = 2:3)
  df <- df[0, ]
  expect_equal(vroom_format(df), "a\tb\n")
})

test_that("vroom_write() / vroom_read() roundtrips an empty data frame", {
  df <- tibble::tibble()
  t <- tempfile(fileext = ".csv")
  on.exit(unlink(t))

  vroom_write(df, t)
  expect_equal(vroom(t, show_col_types = FALSE), df)
})

test_that("vroom_write(append = TRUE) works with R connections", {
  df <- data.frame(x = 1, y = 2)
  f <- tempfile(fileext = ".tsv.gz")
  on.exit(unlink(f))

  vroom::vroom_write(df, f)
  vroom::vroom_write(df, f, append = TRUE)

  expect_equal(vroom_lines(f), c("x\ty", "1\t2", "1\t2"))
})

test_that("vroom_write() works with an empty delimiter", {
  df <- data.frame(x = "foo", y = "bar")

  f <- tempfile(fileext = ".tsv.gz")
  on.exit(unlink(f))

  vroom::vroom_write(df, f, delim = "")
  expect_equal(vroom_lines(f), c("xy", "foobar"))
})

test_that("vroom_write_lines() works with empty", {
  f <- tempfile(fileext = ".txt")
  on.exit(unlink(f))

  vroom::vroom_write_lines(character(), f)
  expect_equal(vroom_lines(f), character())
})

test_that("vroom_write_lines() works with normal input", {
  f <- tempfile(fileext = ".txt")
  on.exit(unlink(f))

  vroom::vroom_write_lines(c("foo", "bar"), f)
  expect_equal(vroom_lines(f), c("foo", "bar"))
})

test_that("vroom_write_lines() does not escape or quote lines", {
  f <- tempfile(fileext = ".txt")
  on.exit(unlink(f))

  vroom::vroom_write_lines(c('"foo"', "bar"), f)
  expect_equal(vroom_lines(f), c('"foo"', "bar"))
})

test_that("vroom_write() always outputs in UTF-8", {
  x <- iconv(c("ao\u00FBt", "\u00E9l\u00E8ve", "\u00E7a va"), "UTF-8", "latin1")

  data <- tibble::tibble(X = x)
  names(data) <- iconv("fran\u00E7aise", "UTF-8", "latin1")

  f <- tempfile()
  vroom_write(data, f, delim = ",")

  expected_data <- charToRaw(
    paste0(
      collapse = "\n",
      c(
        enc2utf8(names(data)),
        enc2utf8(data[[1]]),
        ""
      )
    )
  )

  actual_data <- readBin(f, "raw", file.size(f))

  expect_equal(actual_data, expected_data)
})

test_that("vroom_format() does not quote strings that start with the `na` string (#426)", {
  names_df <- tibble::tibble(x = c(NA, "NA", "NATHAN", "JONAH"))

  simple_output <- vroom_format(names_df)
  expect_equal(
    simple_output,
    "x\nNA\nNA\nNATHAN\nJONAH\n"
  )

  output_unique_NA <- vroom_format(names_df, na = "JON")
  expect_equal(
    output_unique_NA,
    "x\nJON\nNA\nNATHAN\nJONAH\n"
  )
})

test_that("na argument modifies how missing values are written", {
  df <- data.frame(x = c(NA, "x"), y = c(1, 2))
  expect_equal(vroom_format(df, ",", na = "None"), "x,y\nNone,1\nx,2\n")
})

test_that("vroom_write() does not overwrite file when appending empty data frame", {
  tf <- withr::local_tempfile()
  data <- tibble::tibble(
    a = "1",
    b = "2",
    c = "3"
  )

  vroom_write(data, file = tf, delim = ",")
  vroom_write(data.frame(), file = tf, append = TRUE, delim = ",")

  expect_equal(vroom_lines(tf, altrep = FALSE), c("a,b,c", "1,2,3"))
})

test_that("vroom adds the id column from the filename for one file", {
  res <- vroom(vroom_example("mtcars.csv"), id = "filename", col_types = list())
  expect_true(all(res$filename == vroom_example("mtcars.csv")))
})

test_that("vroom adds the id column from the filename for multiple files", {
  dir <- tempfile()
  dir.create(dir)

  splits <- split(mtcars, mtcars$cyl)
  for (i in seq_along(splits)) {
    vroom_write(
      splits[[i]],
      file.path(dir, paste0("mtcars_", names(splits)[[i]], ".tsv")),
      delim = "\t"
    )
  }

  files <- list.files(dir, full.names = TRUE)

  res <- vroom(files, id = "filename", col_types = list())

  # construct what the filename column should look like
  filenames <- paste0(
    "mtcars_",
    rep(names(splits), vapply(splits, nrow, integer(1))),
    ".tsv"
  )

  expect_equal(basename(res$filename), filenames)
})

test_that("vroom adds the id column from the filename for multiple connections", {
  dir <- tempfile()
  dir.create(dir)

  splits <- split(mtcars, mtcars$cyl)
  for (i in seq_along(splits)) {
    # write_tsv will automatically gzip them
    vroom_write(
      splits[[i]],
      file.path(dir, paste0("mtcars_", names(splits)[[i]], ".tsv.gz")),
      delim = "\t"
    )
  }

  files <- list.files(dir, full.names = TRUE)

  res <- vroom(files, id = "filename", col_types = list())

  # construct what the filename column should look like
  filenames <- paste0(
    "mtcars_",
    rep(names(splits), vapply(splits, nrow, integer(1))),
    ".tsv.gz"
  )

  expect_equal(basename(res$filename), filenames)
})

test_that("vroom works with many files", {
  skip_on_os("solaris")

  dir <- tempfile()
  dir.create(dir)
  on.exit(unlink(dir, recursive = TRUE))

  for (i in seq_len(200)) {
    vroom_write(
      tibble::tibble(
        x = rnorm(10),
        y = rnorm(10),
      ),
      file.path(dir, paste0(i, ".csv")),
      delim = ","
    )
  }

  files <- list.files(dir, pattern = ".*[.]csv", full.names = TRUE)

  res <- vroom::vroom(files, col_types = list())

  expect_equal(colnames(res), c("x", "y"))
  expect_equal(NROW(res), 2000)
})

test_that("vroom works with many connections", {
  skip_on_os("solaris")

  dir <- withr::local_tempdir()

  # the number of files is intentionally larger than 128, which has
  # historically been the maximum number of connections allowed by R
  # in R >= 4.4, 128 is likely to be the new default, with higher values
  # allowed
  # https://github.com/tidyverse/vroom/issues/64
  # https://github.com/tidyverse/vroom/commit/a41465d70db37ab2bc628ff1e606b71c410fb0e3
  for (i in seq_len(200)) {
    vroom_write(
      tibble::tibble(
        x = rnorm(10),
        y = rnorm(10),
      ),
      file.path(dir, paste0(i, ".csv.gz")),
      delim = ","
    )
  }

  files <- list.files(dir, pattern = ".*[.]csv[.]gz", full.names = TRUE)

  # vroom manages the connections internally
  res <- vroom::vroom(files, col_types = list())
  expect_equal(colnames(res), c("x", "y"))
  expect_equal(NROW(res), 2000)

  # use explicit connections, so we don't ask for anything close to R's max
  connections <- lapply(files[1:20], gzfile)

  res <- vroom::vroom(connections, col_types = list())

  expect_equal(colnames(res), c("x", "y"))
  expect_equal(NROW(res), 200)
})

test_that("vroom errors if numbers of columns are inconsistent", {
  files <- test_path("multi-file", c("foo", "baz"))
  expect_snapshot(error = TRUE, {
    vroom::vroom(files, col_types = list())
  })
})

test_that("vroom errors if column names are inconsistent", {
  files <- test_path("multi-file", c("foo", "bar"))
  expect_snapshot(error = TRUE, {
    vroom::vroom(files, col_types = list())
  })
})

test_that("vroom works if a file contains no data", {
  files <- test_path("multi-file", c("foo", "qux"))
  res <- vroom(files, col_types = list())
  expect_equal(res, tibble::tibble(A = 1, B = 2))
})

test_that("vroom works if some files contain no data, regardless of order (#430)", {
  destdir <- withr::local_tempdir("testing-multiple-files")

  vroom_write_lines(c("A,B"), file.path(destdir, "header_only.csv"))
  vroom_write_lines(c("A,B"), file.path(destdir, "another_header_only.csv"))
  vroom_write_lines(
    c("A,B", "1,2"),
    file.path(destdir, "header_and_one_row.csv")
  )

  files <- file.path(destdir, c("header_only.csv", "header_and_one_row.csv"))
  res <- vroom(files, show_col_types = FALSE)
  expect_equal(res, tibble::tibble(A = 1, B = 2))

  files <- file.path(
    destdir,
    c(
      "header_only.csv",
      "another_header_only.csv",
      "header_and_one_row.csv"
    )
  )
  res <- vroom(files, show_col_types = FALSE)
  expect_equal(res, tibble::tibble(A = 1, B = 2))

  files <- file.path(
    destdir,
    c(
      "header_only.csv",
      "header_and_one_row.csv",
      "another_header_only.csv"
    )
  )
  res <- vroom(files, show_col_types = FALSE)
  expect_equal(res, tibble::tibble(A = 1, B = 2))

  files <- file.path(
    destdir,
    c(
      "header_and_one_row.csv",
      "header_only.csv",
      "another_header_only.csv"
    )
  )
  res <- vroom(files, show_col_types = FALSE)
  expect_equal(res, tibble::tibble(A = 1, B = 2))

  files <- file.path(
    destdir,
    c(
      "header_only.csv",
      "another_header_only.csv"
    )
  )
  res <- vroom(files, show_col_types = FALSE)
  x <- tibble::tibble(A = "", B = "", .rows = 0)
  expect_equal(res, x)
})

test_that("vroom works for indxes that span file boundries (#383)", {
  x <- vroom(
    c(vroom_example("mtcars.csv"), vroom_example("mtcars.csv")),
    col_types = list()
  )
  y <- rbind(mtcars, mtcars)
  idx <- c(c(34, 33), sample(NROW(x), size = 25, replace = T))
  expect_equal(x[idx, 5, drop = TRUE], y[idx, 4])
})

#' Create column specification
#'
#' `cols()` includes all columns in the input data, guessing the column types
#' as the default. `cols_only()` includes only the columns you explicitly
#' specify, skipping the rest.
#'
#' The available specifications are: (long names in quotes and string abbreviations in brackets)
#'
#' | function                      | long name             | short name | description                                               |
#' | ----------                    | -----------           | ---------- | -------------                                             |
#' | `col_logical()`               | "logical"             | "l"        | Logical values containing only `T`, `F`, `TRUE` or `FALSE`.              |
#' | `col_integer()`               | "integer"             | "i"        | Integer numbers.                                          |
#' | `col_big_integer()`           | "big_integer"         | "I"        | Big Integers (64bit), requires the `bit64` package.       |
#' | `col_double()`                | "double", "numeric"   | "d"        | 64-bit double floating point numbers.
#' | `col_character()`             | "character"           | "c"        | Character string data.                                              |
#' | `col_factor(levels, ordered)` | "factor"              | "f"        | A fixed set of values.                                    |
#' | `col_date(format = "")`       | "date"                | "D"        | Calendar dates formatted with the locale's `date_format`. |
#' | `col_time(format = "")`       | "time"                | "t"        | Times formatted with the locale's `time_format`.          |
#' | `col_datetime(format = "")`   | "datetime", "POSIXct" | "T"        | ISO8601 date times.                                       |
#' | `col_number()`                | "number"              | "n"        | Human readable numbers containing the `grouping_mark`     |
#' | `col_skip()`                  | "skip", "NULL"        | "_", "-"   | Skip and don't import this column.                        |
#' | `col_guess()`                 | "guess", "NA"         | "?"        | Parse using the "best" guessed type based on the input.   |
#'
#' @param ... Either column objects created by `col_*()`, or their abbreviated
#'   character names (as described in the `col_types` argument of
#'   [vroom()]). If you're only overriding a few columns, it's
#'   best to refer to columns by name. If not named, the column types must match
#'   the column names exactly. In `col_*()` functions these are stored in the
#'   object.
#' @param .default Any named columns not explicitly overridden in `...`
#'   will be read with this column type.
#' @param .delim The delimiter to use when parsing. If the `delim` argument
#'   used in the call to `vroom()` it takes precedence over the one specified in
#'   `col_types`.
#' @export
#' @aliases col_types
#' @examples
#' cols(a = col_integer())
#' cols_only(a = col_integer())
#'
#' # You can also use the standard abbreviations
#' cols(a = "i")
#' cols(a = "i", b = "d", c = "_")
#'
#' # Or long names (like utils::read.csv)
#' cols(a = "integer", b = "double", c = "skip")
#'
#' # You can also use multiple sets of column definitions by combining
#' # them like so:
#'
#' t1 <- cols(
#'   column_one = col_integer(),
#'   column_two = col_number())
#'
#' t2 <- cols(
#'  column_three = col_character())
#'
#' t3 <- t1
#' t3$cols <- c(t1$cols, t2$cols)
#' t3
cols <- function(..., .default = col_guess(), .delim = NULL) {
  col_types <- list2(...)
  is_character <- vapply(col_types, is.character, logical(1))
  col_types[is_character] <- lapply(col_types[is_character], col_concise)

  if (is.character(.default)) {
    .default <- col_concise(.default)
  }

  col_spec(col_types, .default, .delim)
}

#' @export
#' @rdname cols
cols_only <- function(...) {
  cols(..., .default = col_skip())
}


# col_spec ----------------------------------------------------------------

col_spec <- function(
  col_types,
  default = col_guess(),
  delim,
  call = caller_env()
) {
  if (!is.list(col_types)) {
    cli::cli_abort(
      "{.arg col_types} must be a column specification like that created with {.fun cols} or {.fun cols_only}, not {obj_type_friendly(col_types)}.",
      call = call
    )
  }

  hint <- "Column specifications must be created with the {.code col_*()} functions or their abbreviated character names."

  if (!is.collector(default)) {
    cli::cli_abort(
      c(
        hint,
        "x" = "Bad {.arg .default} specification."
      ),
      call = call
    )
  }

  is_collector <- vapply(col_types, is.collector, logical(1))
  if (any(!is_collector)) {
    # the as.character() is favorable for cli pluralization
    bad_idx <- as.character(which(!is_collector))
    cli::cli_abort(
      c(
        hint,
        "x" = "Bad specification{?s} at position{?s}: {bad_idx}."
      ),
      call = call
    )
  }

  structure(
    list(
      cols = col_types,
      default = default,
      delim = delim
    ),
    class = "col_spec"
  )
}

is.col_spec <- function(x) inherits(x, "col_spec")


#' Coerce to a column specification
#'
#' This is most useful for generating a specification using the short form or coercing from a list.
#'
#' @param x Input object
#' @keywords internal
#' @examples
#' as.col_spec("cccnnn")
#' @export
as.col_spec <- function(x, call = caller_env()) UseMethod("as.col_spec")

#' @export
as.col_spec.character <- function(x, call = caller_env()) {
  if (is_named(x)) {
    return(as.col_spec(as.list(x), call = call))
  }
  letters <- strsplit(x, "")[[1]]
  col_spec(lapply(letters, col_concise), col_guess(), delim = NULL, call = call)
}

#' @export
as.col_spec.NULL <- function(x, call = caller_env()) {
  col_spec(list(), delim = NULL, call = call)
}

#' @export
as.col_spec.list <- function(x, call = caller_env()) {
  do.call(cols, x)
}
#' @export
as.col_spec.col_spec <- function(x, call = caller_env()) {
  if (!"delim" %in% names(x)) {
    x["delim"] <- list(NULL)
  }
  x
}

#' @export
as.col_spec.default <- function(x, call = caller_env()) {
  cli::cli_abort(
    "{.arg col_types} must be {.code NULL}, a {.fun cols} specification, or a string, not {obj_type_friendly(x)}.",
    call = call
  )
}

# Conditionally exported in zzz.R
#' @noRd
# @export
print.col_spec <- function(
  x,
  n = Inf,
  condense = NULL,
  colour = crayon::has_color(),
  ...
) {
  cat(format.col_spec(x, n = n, condense = condense, colour = colour, ...))

  invisible(x)
}

#' @description
#' `cols_condense()` takes a spec object and condenses its definition by setting
#' the default column type to the most frequent type and only listing columns
#' with a different type.
#' @rdname spec
#' @export
cols_condense <- function(x) {
  types <- vapply(x$cols, function(xx) class(xx)[[1]], character(1))
  counts <- table(types)
  most_common <- names(counts)[counts == max(counts)][[1]]

  x$default <- x$cols[types == most_common][[1]]
  x$cols <- x$cols[types != most_common]
  x
}

# Conditionally exported in zzz.R
#' @noRd
# @export
format.col_spec <- function(
  x,
  n = Inf,
  condense = NULL,
  colour = crayon::has_color(),
  ...
) {
  if (n == 0) {
    return("")
  }

  # condense if cols >= n
  condense <- condense %||% (length(x$cols) >= n)
  if (isTRUE(condense)) {
    x <- cols_condense(x)
  }

  # truncate to minumum of n or length
  cols <- x$cols[seq_len(min(length(x$cols), n))]

  default <- NULL
  if (inherits(x$default, "collector_guess")) {
    fun_type <- "cols"
  } else if (inherits(x$default, "collector_skip")) {
    fun_type <- "cols_only"
  } else {
    fun_type <- "cols"
    type <- sub("^collector_", "", class(x$default)[[1]])
    default <- paste0(".default = col_", type, "()")
  }

  delim <- x$delim

  if (!is.null(delim) && nzchar(delim)) {
    delim <- paste0('.delim = ', glue::double_quote(delim), '')
  }

  cols_args <- c(
    default,
    vapply(
      seq_along(cols),
      function(i) {
        col_funs <- sub("^collector_", "col_", class(cols[[i]])[[1]])
        args <- vapply(cols[[i]], deparse2, character(1), sep = "\n    ")
        args <- paste(names(args), args, sep = " = ", collapse = ", ")

        col_funs <- paste0(col_funs, "(", args, ")")
        col_funs <- colourise_cols(col_funs, colour)

        col_names <- names(cols)[[i]] %||% ""

        # Need to handle unnamed columns and columns with non-syntactic names
        named <- col_names != ""

        non_syntactic <- !is_syntactic(col_names) & named
        col_names[non_syntactic] <- paste0(
          "`",
          gsub("`", "\\\\`", col_names[non_syntactic]),
          "`"
        )

        out <- paste0(col_names, " = ", col_funs)
        out[!named] <- col_funs[!named]
        out
      },
      character(1)
    ),
    delim
  )
  if (length(x$cols) == 0 && length(cols_args) == 0) {
    return(paste0(fun_type, "()\n"))
  }

  out <- paste0(fun_type, "(\n  ", paste(collapse = ",\n  ", cols_args))

  if (length(x$cols) > n) {
    out <- paste0(out, "\n  # ... with ", length(x$cols) - n, " more columns")
  }
  out <- paste0(out, "\n)\n")

  out
}

colourise_cols <- function(cols, colourise = crayon::has_color()) {
  if (!isTRUE(colourise)) {
    return(cols)
  }

  fname <- sub("[(].*", "", cols)
  for (i in seq_along(cols)) {
    cols[[i]] <- switch(
      fname,
      col_skip = ,
      col_guess = cols[[i]],

      col_character = ,
      col_factor = crayon::red(cols[[i]]),

      col_logical = crayon::yellow(cols[[i]]),

      col_double = ,
      col_integer = ,
      col_big_integer = ,
      col_number = green(cols[[i]]),

      col_date = ,
      col_datetime = ,
      col_time = blue(cols[[i]])
    )
  }
  cols
}

# This allows str() on a tibble object to print a little nicer.
# Conditionally exported in zzz.R
#' @noRd
# @export
str.col_spec <- function(object, ..., indent.str = "") {
  # Split the formatted column spec into strings
  specs <- strsplit(format(object), "\n")[[1]]
  cat(
    sep = "",
    "\n",

    # Append the current indentation string to the specs
    paste(indent.str, specs, collapse = "\n"),

    "\n"
  )
}


#' Examine the column specifications for a data frame
#'
#' `spec()` extracts the full column specification from a tibble
#' created by vroom.
#'
#' @family parsers
#' @param x The data frame object to extract from
#' @return A col_spec object.
#' @export
#' @examples
#' df <- vroom(vroom_example("mtcars.csv"))
#' s <- spec(df)
#' s
#'
#' cols_condense(s)
spec <- function(x) {
  if (!inherits(x, "tbl_df")) {
    cli::cli_abort(
      "{.arg x} must be a tibble created by vroom, not {obj_type_friendly(x)}."
    )
  }
  attr(x, "spec")
}

col_concise <- function(x, call = caller_env()) {
  switch(
    x,
    "_" = ,
    "skip" = ,
    "NULL" = ,
    "-" = col_skip(),
    "NA" = ,
    "?" = col_guess(),
    character = ,
    c = col_character(),
    factor = ,
    f = col_factor(),
    double = ,
    numeric = ,
    d = col_double(),
    integer = ,
    i = col_integer(),
    big_integer = ,
    I = col_big_integer(),
    logical = ,
    l = col_logical(),
    number = ,
    n = col_number(),
    date = ,
    Date = ,
    D = col_date(),
    datetime = ,
    POSIXct = ,
    T = col_datetime(),
    time = ,
    t = col_time(),
    cli::cli_abort(
      "Unknown column type specification: {.val {x}}",
      call = call
    )
  )
}

vroom_enquo <- function(x) {
  if (quo_is_call(x, "c") || quo_is_call(x, "list")) {
    return(as_quosures(get_expr(x)[-1], get_env(x)))
  }
  x
}

vroom_select <- function(x, col_select, id) {
  # reorder and rename columns
  if (inherits(col_select, "quosures") || !quo_is_null(col_select)) {
    if (inherits(col_select, "quosures")) {
      vars <- tidyselect::vars_select(c(names(spec(x)$cols), id), !!!col_select)
    } else {
      vars <- tidyselect::vars_select(c(names(spec(x)$cols), id), !!col_select)
    }
    if (!is.null(id) && !id %in% vars) {
      names(id) <- id
      vars <- c(id, vars)
    }
    # This can't be just names(x) as we need to have skipped
    # names as well to pass to vars_select()
    x <- x[vars]
    names(x) <- names(vars)
  }
  x
}

col_types_standardise <- function(
  spec,
  num_cols,
  col_names,
  col_select,
  name_repair
) {
  if (num_cols == 0) {
    if (length(spec$cols) > 0) {
      num_cols <- length(spec$cols)
    } else if (length(col_names) > 0) {
      num_cols <- length(col_names)
    }
  }

  if (length(col_names) == 0) {
    col_names <- make_names(NULL, num_cols)
  }

  col_names <- vctrs::vec_as_names(col_names, repair = name_repair)

  type_names <- names(spec$cols)

  if (length(spec$cols) == 0) {
    # no types specified so use defaults

    spec$cols <- rep(list(spec$default), num_cols)
    names(spec$cols) <- col_names[seq_along(spec$cols)]
  } else if (is.null(type_names)) {
    # unnamed types & names guessed from header: match exactly
    if (num_cols < length(spec$cols)) {
      spec$cols <- spec$cols[seq_len(num_cols)]
    } else {
      spec$cols <- c(
        spec$cols,
        rep(list(spec$default), num_cols - length(spec$cols))
      )
    }
    names(spec$cols) <- col_names[seq_along(spec$cols)]
  } else {
    # named types

    if (num_cols > length(col_names)) {
      col_names <- make_names(col_names, num_cols)
    }

    bad_types <- !(type_names %in% col_names)
    if (any(bad_types)) {
      warn(
        paste0(
          "The following named parsers don't match the column names: ",
          paste0(type_names[bad_types], collapse = ", ")
        ),
        class = "vroom_mismatched_column_name"
      )
      spec$cols <- spec$cols[!bad_types]
      type_names <- type_names[!bad_types]
    }

    default_types <- !(col_names %in% type_names)
    if (any(default_types)) {
      defaults <- rep(list(spec$default), sum(default_types))
      names(defaults) <- col_names[default_types]
      spec$cols[names(defaults)] <- defaults
    }

    spec$cols <- spec$cols[col_names]
  }

  if (inherits(col_select, "quosures") || !quo_is_null(col_select)) {
    if (inherits(col_select, "quosures")) {
      to_keep <- names(spec$cols) %in%
        tidyselect::vars_select(
          names(spec$cols),
          !!!col_select,
          .strict = FALSE
        )
    } else {
      to_keep <- names(spec$cols) %in%
        tidyselect::vars_select(names(spec$cols), !!col_select, .strict = FALSE)
    }

    spec$cols[!to_keep] <- rep(list(col_skip()), sum(!to_keep))
  }

  # Set the names, ignoring skipped columns
  kept <- !vapply(spec$cols, inherits, logical(1), "collector_skip")

  # Fill the column names if they are shorter than what is kept.
  if (length(col_names) == length(spec$cols)) {
    names(spec$cols)[kept] <- col_names[kept]
  } else if (length(col_names) == sum(kept)) {
    names(spec$cols)[kept] <- col_names
  } else {
    col_names <- make_names(col_names, sum(kept))
    names(spec$cols)[kept] <- col_names
  }

  spec
}


#' Guess the type of a vector
#'
#' @param x Character vector of values to parse.
#' @inheritParams vroom
#' @param guess_integer If `TRUE`, guess integer types for whole numbers, if
#'   `FALSE` guess numeric type for all numbers.
#' @examples
#'  # Logical vectors
#'  guess_type(c("FALSE", "TRUE", "F", "T"))

#'  # Integers and doubles
#'  guess_type(c("1","2","3"))
#'  guess_type(c("1.6","2.6","3.4"))

#'  # Numbers containing grouping mark
#'  guess_type("1,234,566")

#'  # ISO 8601 date times
#'  guess_type(c("2010-10-10"))
#'  guess_type(c("2010-10-10 01:02:03"))
#'  guess_type(c("01:02:03 AM"))
#' @export
guess_type <- function(
  x,
  na = c("", "NA"),
  locale = default_locale(),
  guess_integer = FALSE
) {
  type <- guess_type_(
    x,
    na = na,
    locale = locale,
    guess_integer = guess_integer
  )
  get(paste0("col_", type), asNamespace("vroom"))()
}

guess_parser <- function(
  x,
  na = c("", "NA"),
  locale = default_locale(),
  guess_integer = FALSE
) {
  guess_type_(x, na = na, locale = locale, guess_integer = guess_integer)
}

show_dims <- function(x) {
  cli_block(class = "vroom_dim_message", {
    cli::cli_text(
      "
      {.strong Rows: }{.val {NROW(x)}}
      {.strong Columns: }{.val {NCOL(x)}}
      "
    )
  })
}

collector_value <- function(x, ...) {
  UseMethod("collector_value")
}

#' @export
collector_value.collector_character <- function(x, ...) {
  character()
}

#' @export
collector_value.collector_double <- function(x, ...) {
  numeric()
}

#' @export
collector_value.collector_integer <- function(x, ...) {
  integer()
}

#' @export
collector_value.collector_number <- function(x, ...) {
  numeric()
}

#' @export
collector_value.collector_logical <- function(x, ...) {
  logical()
}

#' @export
collector_value.collector_factor <- function(x, ...) {
  factor()
}

#' @export
collector_value.collector_datetime <- function(x, ...) {
  vctrs::new_datetime()
}

#' @export
collector_value.collector_date <- function(x, ...) {
  vctrs::new_date()
}

#' @export
collector_value.collector_time <- function(x, ...) {
  hms::hms()
}

#' @export
collector_value.collector_guess <- function(x, ...) {
  character()
}

#' @export
collector_value.collector_skip <- function(x, ...) {
  NULL
}

#' @export
summary.col_spec <- function(
  object,
  width = getOption("width"),
  locale = default_locale(),
  ...
) {
  if (length(object$cols) == 0) {
    return(invisible(object))
  }

  type_map <- c(
    "collector_character" = "chr",
    "collector_double" = "dbl",
    "collector_integer" = "int",
    "collector_number" = "num",
    "collector_logical" = "lgl",
    "collector_factor" = "fct",
    "collector_datetime" = "dttm",
    "collector_date" = "date",
    "collector_time" = "time",
    "collector_guess" = "???"
  )

  col_types <- vapply(object$cols, function(x) class(x)[[1]], character(1))
  col_types <- droplevels(factor(
    type_map[col_types],
    levels = unname(type_map)
  ))
  type_counts <- table(col_types)

  n <- length(type_counts)

  types <- format(vapply(names(type_counts), color_type, character(1)))
  counts <- format(glue::glue("({type_counts})"), justify = "right")
  col_width <- min(width - (crayon::col_nchar(types) + nchar(counts) + 4))
  columns <- vapply(
    split(names(object$cols), col_types),
    function(x) glue::glue_collapse(x, ", ", width = col_width),
    character(1)
  )

  fmt_num <- function(x) {
    prettyNum(
      x,
      big.mark = locale$grouping_mark,
      decimal.mark = locale$decimal_mark
    )
  }

  delim <- object$delim %||% ""

  txt <- glue::glue(
    .transformer = collapse_transformer(sep = "\n"),
    entries = glue::glue("{format(types)} {counts}: {columns}"),

    '
    {if (nzchar(delim)) paste(bold("Delimiter:"), glue::double_quote(delim)) else ""}
    {entries*}


    '
  )
  cli_block(class = "vroom_spec_message", {
    cli::cli_h1("Column specification")
    cli::cli_verbatim(txt)
  })

  invisible(object)
}

show_col_types <- function(x, locale) {
  show_dims(x)
  summary(spec(x), locale = locale)
  cli_block(class = "vroom_spec_message", {
    cli::cli_verbatim("\n\n")
    cli::cli_alert_info(
      "Use {.fn spec} to retrieve the full column specification for this data."
    )
    cli::cli_alert_info(
      "Specify the column types or set {.arg show_col_types = FALSE} to quiet this message."
    )
  })
}

cli_block <- function(expr, class = NULL, type = rlang::inform) {
  msg <- ""
  withCallingHandlers(
    expr,
    message = function(x) {
      msg <<- paste0(msg, x$message)
      invokeRestart("muffleMessage")
    }
  )
  msg <- sub("^\n", "", msg)
  msg <- sub("\n+$", "", msg)

  type(msg, class = class)
}

color_type <- function(type) {
  switch(
    type,
    chr = ,
    fct = crayon::red(type),
    lgl = crayon::yellow(type),
    dbl = ,
    int = ,
    num = green(type),
    date = ,
    dttm = ,
    time = blue(type),
    "???" = type
  )
}

#' @rdname cols
#' @export
col_logical <- function(...) {
  collector("logical", ...)
}

#' @rdname cols
#' @export
col_integer <- function(...) {
  collector("integer", ...)
}

#' @rdname cols
#' @export
col_big_integer <- function(...) {
  collector("big_integer", ...)
}

#' @rdname cols
#' @export
col_double <- function(...) {
  collector("double", ...)
}

#' @rdname cols
#' @export
col_character <- function(...) {
  collector("character", ...)
}

#' @rdname cols
#' @export
col_skip <- function(...) {
  collector("skip", ...)
}

#' @rdname cols
#' @export
col_number <- function(...) {
  collector("number", ...)
}

#' @rdname cols
#' @export
col_guess <- function(...) {
  collector("guess", ...)
}

#' @rdname cols
#' @param levels Character vector of the allowed levels. When `levels = NULL`
#'   (the default), `levels` are discovered from the unique values of the data,
#'   in the order in which they are encountered.
#' @param ordered Is it an ordered factor?
#' @param include_na If `TRUE` and the data contains at least one `NA`, then
#'   `NA` is included in the levels of the constructed factor.
#' @export
col_factor <- function(
  levels = NULL,
  ordered = FALSE,
  include_na = FALSE,
  ...
) {
  collector(
    "factor",
    levels = levels,
    ordered = ordered,
    include_na = include_na,
    ...
  )
}

#' @rdname cols
#' @param format A format specification. If set to "":
#'   * `col_datetime()` expects ISO8601 datetimes. Here are some examples of
#'     input that should just work:
#'     "2024-01-15", "2024-01-15 14:30:00", "2024-01-15T14:30:00Z".
#'   * `col_date()` uses the `date_format` from [locale()] (default `"%AD"`).
#'     These inputs should just work: "2024-01-15", "01/15/2024".
#'   * `col_time()` uses the `time_format` from [locale()] (default `"%AT"`).
#'     These inputs should just work: "14:30:00", "2:30:00 PM".
#'
#'   Unlike [strptime()], the format specification must match the complete
#'   string. For more details, see below.
#'
#' @details
#' ## Date, time, and datetime formats:
#' \pkg{vroom} uses a format specification similar to [strptime()].
#' There are three types of element:
#'
#' 1. A conversion specification that is "%" followed by a letter. For example
#'   "%Y" matches a 4 digit year, "%m", matches a 2 digit month and "%d" matches
#'   a 2 digit day. Month and day default to `1`, (i.e. Jan 1st) if not present,
#'   for example if only a year is given.
#' 2. Whitespace is any sequence of zero or more whitespace characters.
#' 3. Any other character is matched exactly.
#'
#' \pkg{vroom}'s datetime `col_*()` functions recognize the following
#' specifications:
#'
#' * Year: "%Y" (4 digits). "%y" (2 digits); 00-69 -> 2000-2069, 70-99 ->
#'   1970-1999.
#' * Month: "%m" (2 digits), "%b" (abbreviated name in current locale), "%B"
#'   (full name in current locale).
#' * Day: "%d" (2 digits), "%e" (optional leading space), "%a" (abbreviated
#'   name in current locale).
#' * Hour: "%H" or "%I" or "%h", use I (and not H) with AM/PM, use h (and not H)
#'   if your times represent durations longer than one day.
#' * Minutes: "%M"
#' * Seconds: "%S" (integer seconds), "%OS" (partial seconds)
#' * Time zone: "%Z" (as name, e.g. "America/Chicago"), "%z" (as offset from
#'   UTC, e.g. "+0800")
#' * AM/PM indicator: "%p".
#' * Non-digits: "%." skips one non-digit character, "%+" skips one or more
#'   non-digit characters, "%*" skips any number of non-digits characters.
#' * Automatic parsers: "%AD" parses with a flexible YMD parser, "%AT" parses
#'   with a flexible HMS parser.
#' * Shortcuts: "%D" = "%m/%d/%y", "%F" = "%Y-%m-%d", "%R" = "%H:%M", "%T" =
#'   "%H:%M:%S", "%x" = "%y/%m/%d".
#'
#' ### ISO8601 support
#'
#' Currently, vroom does not support all of ISO8601. Missing features:
#'
#' * Week & weekday specifications, e.g. "2013-W05", "2013-W05-10".
#' * Ordinal dates, e.g. "2013-095".
#' * Using commas instead of a period for decimal separator.
#'
#' The parser is also a little laxer than ISO8601:
#'
#' * Dates and times can be separated with a space, not just T.
#' * Mostly correct specifications like "2009-05-19 14:" and "200912-01" work.
#'
#' @export
col_datetime <- function(format = "", ...) {
  collector("datetime", format = format, ...)
}

#' @rdname cols
#' @export
col_date <- function(format = "", ...) {
  collector("date", format = format, ...)
}

#' @rdname cols
#' @export
col_time <- function(format = "", ...) {
  collector("time", format = format, ...)
}

test_that("You can use !! in cols and cols_only", {
  var <- "xyz"
  expect_equal(
    cols(!!var := col_character()),
    cols(xyz = col_character())
  )

  expect_equal(
    cols_only(!!var := col_character()),
    cols_only(xyz = col_character())
  )
})

test_that("format(col_spec) contains the delimiter if specified", {
  expect_match(fixed = TRUE, format(cols(.delim = "\t")), '.delim = "\\t"')
})

test_that("col_types are truncated if you pass too many (#355)", {
  res <- vroom(I("a,b,c,d\n1,2,3,4"), col_types = "cccccccc")
  expect_equal(res, tibble::tibble(a = "1", b = "2", c = "3", d = "4"))
})

test_that("all col_types can be reported with color", {
  local_reproducible_output(crayon = TRUE)
  dat <- vroom(
    I(glue::glue(
      "
      skip,guess,character,factor,logical,double,integer,big_integer,\\
      number,date,datetime
      skip,a,b,c,TRUE,1.3,5,10,\"1,234.56\",2023-01-20,2018-01-01 10:01:01"
    )),
    col_types = "_?cfldiInDT"
  )
  expect_snapshot(spec(dat))
})

# https://github.com/tidyverse/vroom/issues/548
test_that("col_number() works with empty data", {
  out <- vroom(I(""), col_types = "in")
  expect_equal(out, tibble::tibble(X1 = integer(), X2 = numeric()))
})

# https://github.com/tidyverse/vroom/issues/540
test_that("col_skip works with empty data (#540)", {
  out <- vroom(I("a\tb\tc\n"), delim = "\t", col_types = "c-d", skip = 1L)
  expect_equal(out, tibble::tibble(X1 = character(), X3 = numeric()))

  # All columns skipped
  out <- vroom(I("a\tb\n"), delim = "\t", col_types = "--", skip = 1L)
  expect_equal(out, tibble::tibble())
})

test_that("cols() errors for invalid collector objects", {
  expect_snapshot(
    cols(a = col_character(), b = 123),
    error = TRUE
  )

  expect_snapshot(
    cols(a = col_character(), .default = 123),
    error = TRUE
  )
})

test_that("cols() errors for invalid character specifications", {
  expect_snapshot(cols(X = "z", Y = "i", Z = col_character()), error = TRUE)
  expect_snapshot(cols(X = "i", .default = "wut"), error = TRUE)
})

test_that("as.col_spec() errors for unhandled input type", {
  expect_snapshot(
    vroom(I("whatever"), col_types = data.frame()),
    error = TRUE
  )
})

test_that("as.col_spec() errors for unrecognized single-letter spec", {
  expect_snapshot(vroom(I("whatever"), col_types = "dz"), error = TRUE)
})

test_that("vroom can read a tsv", {
  test_vroom(
    "a\tb\tc\n1\t2\t3\n",
    delim = "\t",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )
})

test_that("vroom can read a csv", {
  test_vroom(
    "a,b,c\n1,2,3\n",
    delim = ",",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )
})

test_that("vroom errors informatively when it cannot guess delimiter", {
  expect_snapshot(
    vroom(I("foo\nbar\nbaz\n"), col_types = list()),
    error = TRUE
  )
})

test_that("vroom guesses columns with NAs", {
  test_vroom(
    "a,b,c\nNA,2,3\n4,5,6\n",
    delim = ",",
    equals = tibble::tibble(a = c(NA, 4), b = c(2, 5), c = c(3, 6))
  )

  test_vroom(
    "a,b,c\nfoo,2,3\n4,5,6\n",
    delim = ",",
    na = "foo",
    equals = tibble::tibble(a = c(NA, 4), b = c(2, 5), c = c(3, 6))
  )

  test_vroom(
    "a,b,c\nfoo,2,3\n4.0,5,6\n",
    delim = ",",
    na = "foo",
    equals = tibble::tibble(a = c(NA, 4), b = c(2, 5), c = c(3, 6))
  )

  test_vroom(
    "a,b,c\nfoo,2,3\nbar,5,6\n",
    delim = ",",
    na = "foo",
    equals = tibble::tibble(a = c(NA, "bar"), b = c(2, 5), c = c(3, 6))
  )
})

test_that("vroom can trim whitespace", {
  test_vroom(
    'a,b,c\n foo ,  bar  ,baz\n',
    delim = ",",
    equals = tibble::tibble(a = "foo", b = "bar", c = "baz")
  )

  test_vroom(
    'a,b,c\n\tfoo\t,\t\tbar\t\t,baz\n',
    delim = ",",
    equals = tibble::tibble(a = "foo", b = "bar", c = "baz")
  )

  # whitespace trimmed before quotes
  test_vroom(
    'a,b,c\n "foo" ,  "bar"  ,"baz"\n',
    delim = ",",
    equals = tibble::tibble(a = "foo", b = "bar", c = "baz")
  )

  # whitespace trimmed inside quotes
  test_vroom(
    'a,b,c\n"foo  ","  bar","\t\tbaz"\n',
    delim = ",",
    equals = tibble::tibble(a = "foo", b = "bar", c = "baz")
  )
})

test_that("vroom can read files with quotes", {
  test_vroom(
    '"a","b","c"\n"foo","bar","baz"\n',
    delim = ",",
    equals = tibble::tibble(a = "foo", b = "bar", c = "baz")
  )

  test_vroom(
    '"a","b","c"\n",foo","bar","baz"\n',
    delim = ",",
    equals = tibble::tibble(a = ",foo", b = "bar", c = "baz")
  )

  test_vroom(
    "'a','b','c'\n',foo','bar','baz'\n",
    delim = ",",
    quote = "'",
    equals = tibble::tibble(a = ",foo", b = "bar", c = "baz")
  )
})

test_that("vroom escapes double quotes", {
  test_vroom(
    '"a","b","c"\n"""fo""o","b""""ar","baz"""\n',
    delim = ",",
    equals = tibble::tibble(a = "\"fo\"o", b = "b\"\"ar", c = "baz\"")
  )
})

test_that("vroom escapes backslashes", {
  test_vroom(
    'a,b,c\n\\,foo,\\"ba\\"r,baz\\"\n',
    delim = ",",
    escape_backslash = TRUE,
    equals = tibble::tibble(a = ",foo", b = "\"ba\"r", c = "baz\"")
  )
})

test_that("vroom ignores leading whitespace", {
  test_vroom(
    '\n\n   \t \t\n  \n\na,b,c\n1,2,3\n',
    delim = ",",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )
})

test_that("vroom ignores comments", {
  test_vroom(
    '\n\n \t #a,b,c\na,b,c\n1,2,3\n',
    delim = ",",
    comment = "#",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )
})

test_that("vroom respects skip", {
  test_vroom(
    '#a,b,c\na,b,c\n1,2,3\n',
    delim = ",",
    skip = 1,
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )

  test_vroom(
    '#a,b,c\na,b,c\n1,2,3\n',
    delim = ",",
    skip = 1,
    comment = "#",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )

  test_vroom(
    '#a,b,c\nasdfasdf\na,b,c\n1,2,3\n',
    delim = ",",
    skip = 2,
    comment = "#",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )

  test_vroom(
    '\n\n#a,b,c\nasdfasdf\na,b,c\n1,2,3\n',
    delim = ",",
    skip = 4,
    comment = "#",
    equals = tibble::tibble(a = 1, b = 2, c = 3)
  )
})

test_that("vroom respects col_types", {
  test_vroom(
    'a,b,c\n1,2,3\n',
    delim = ",",
    col_types = "idc",
    equals = tibble::tibble(a = 1L, b = 2, c = "3")
  )

  test_vroom(
    'a,b,c,d\nT,2,3,4\n',
    delim = ",",
    col_types = "lfc_",
    equals = tibble::tibble(a = TRUE, b = factor(2), c = "3")
  )
})

test_that("vroom handles UTF byte order marks", {
  # UTF-8
  expect_equal(
    vroom(
      as.raw(c(
        0xef,
        0xbb,
        0xbf, # BOM
        0x41, # A
        0x0A # newline
      )),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]],
    "A"
  )

  # UTF-16 Big Endian
  expect_equal(
    vroom(
      as.raw(c(
        0xfe,
        0xff, # BOM
        0x41, # A
        0x0A # newline
      )),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]],
    "A"
  )

  # UTF-16 Little Endian
  expect_equal(
    vroom(
      as.raw(c(
        0xff,
        0xfe, # BOM
        0x41, # A
        0x0A # newline
      )),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]],
    "A"
  )

  # UTF-32 Big Endian
  expect_equal(
    vroom(
      as.raw(c(
        0x00,
        0x00,
        0xfe,
        0xff, # BOM
        0x41, # A
        0x0A # newline
      )),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]],
    "A"
  )

  # UTF-32 Little Endian
  expect_equal(
    vroom(
      as.raw(c(
        0xff,
        0xfe,
        0x00,
        0x00, # BOM
        0x41, # A
        0x0A # newline
      )),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]],
    "A"
  )
})

test_that("vroom handles vectors shorter than the UTF byte order marks", {
  skip_on_os("solaris")

  expect_equal(
    charToRaw(vroom(
      as.raw(c(0xef, 0xbb, 0x0A)),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]]),
    as.raw(c(0xef, 0xbb))
  )

  expect_equal(
    charToRaw(vroom(
      as.raw(c(0xfe, 0x0A)),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]]),
    as.raw(c(0xfe))
  )

  expect_equal(
    charToRaw(vroom(
      as.raw(c(0xff, 0x0A)),
      delim = "\n",
      col_names = FALSE,
      col_types = list()
    )[[1]]),
    as.raw(c(0xff))
  )
})

test_that("vroom handles windows newlines", {
  expect_equal(
    vroom(I("a\tb\r\n1\t2\r\n"), trim_ws = FALSE, col_types = list())[[1]],
    1
  )
})

test_that("vroom can read a file with only headers", {
  test_vroom("a\n", equals = tibble::tibble(a = character()))

  test_vroom(
    "a,b,c\n",
    delim = ",",
    equals = tibble::tibble(a = character(), b = character(), c = character())
  )
})

test_that("vroom can read an empty file", {
  test_vroom("\n", equals = tibble::tibble())

  f <- tempfile()
  file.create(f)
  on.exit(unlink(f))

  capture.output(
    type = "message",
    expect_equal(vroom(f, col_types = list()), tibble::tibble())
  )

  capture.output(
    type = "message",
    expect_equal(
      vroom(f, col_names = FALSE, col_types = list()),
      tibble::tibble()
    )
  )

  expect_equal(vroom(character(), col_types = list()), tibble::tibble())
})

test_that("vroom_examples() returns the example files", {
  expect_equal(
    vroom_examples(),
    list.files(system.file("extdata", package = "vroom"))
  )
})

test_that("vroom_example() returns a single example files", {
  expect_equal(
    vroom_example("mtcars.csv"),
    system.file("extdata", "mtcars.csv", package = "vroom")
  )
})

test_that("subsets work", {
  res <- vroom(
    I("1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14"),
    delim = "\t",
    col_names = FALSE,
    col_types = list()
  )
  expect_equal(head(res[[1]]), c(1:6))
  expect_equal(tail(res[[1]]), c(9:14))

  expect_equal(tail(res[[1]][3:8]), c(3:8))
})

test_that("n_max works with normal files", {
  expect_equal(
    NROW(vroom(vroom_example("mtcars.csv"), n_max = 2, col_types = list())),
    2
  )

  # headers don't count
  expect_equal(
    NROW(vroom(
      vroom_example("mtcars.csv"),
      n_max = 2,
      col_names = FALSE,
      col_types = list()
    )),
    2
  )

  # Zero rows with headers should just have the headers
  expect_equal(
    dim(vroom(vroom_example("mtcars.csv"), n_max = 0, col_types = list())),
    c(0, 12)
  )

  # If you don't read the header or any rows it must be empty
  expect_equal(
    dim(vroom(
      vroom_example("mtcars.csv"),
      n_max = 0,
      col_names = FALSE,
      col_types = list()
    )),
    c(0, 0)
  )
})

test_that("n_max works with connections files", {
  expect_equal(
    NROW(vroom(vroom_example("mtcars.csv.gz"), n_max = 2, col_types = list())),
    2
  )

  # headers don't count
  expect_equal(
    NROW(vroom(
      vroom_example("mtcars.csv.gz"),
      n_max = 2,
      col_names = FALSE,
      col_types = list()
    )),
    2
  )

  # Zero rows with headers should just have the headers
  expect_equal(
    dim(vroom(vroom_example("mtcars.csv.gz"), n_max = 0, col_types = list())),
    c(0, 12)
  )

  # Zero rows with explicit column names should not error
  # This used to error with "! negative length vectors are not allowed"
  expect_equal(
    vroom(
      vroom_example("mtcars.csv.gz"),
      col_names = c("a", "b", "c"),
      n_max = 0,
      col_types = list()
    ),
    tibble::tibble(a = character(), b = character(), c = character())
  )

  # If you don't read any rows or read/provide the header, result is empty
  expect_equal(
    vroom(
      vroom_example("mtcars.csv.gz"),
      n_max = 0,
      col_names = FALSE,
      col_types = list()
    ),
    tibble::tibble()
  )
})

test_that("vroom truncates col_names if it is too long", {
  test_vroom(
    "1\n2\n",
    col_names = c("a", "b"),
    equals = tibble::tibble(a = c(1, 2))
  )
})

test_that("vroom makes additional col_names if it is too short", {
  test_vroom(
    "1,2,3\n4,5,6\n",
    col_names = c("a", "b"),
    delim = ",",
    equals = tibble::tibble(a = c(1, 4), b = c(2, 5), X3 = c(3, 6))
  )
})

test_that("vroom reads newlines in data", {
  test_vroom('a\n"1\n2"\n', equals = tibble::tibble(a = "1\n2"))
})

test_that("vroom reads headers with embedded newlines", {
  test_vroom(
    "\"Header\nLine Two\"\nValue\n",
    delim = ",",
    equals = tibble::tibble("Header\nLine Two" = "Value")
  )

  test_vroom(
    "\"Header\",\"Second header\nLine Two\"\nValue,Value2\n",
    delim = ",",
    equals = tibble::tibble(
      "Header" = "Value",
      "Second header\nLine Two" = "Value2"
    )
  )
})

test_that("vroom reads headers with embedded newlines 2", {
  test_vroom(
    "\"Header\nLine Two\"\n\"Another line\nto\nskip\"\nValue,Value2\n",
    skip = 2,
    col_names = FALSE,
    delim = ",",
    equals = tibble::tibble("X1" = "Value", "X2" = "Value2")
  )
})

test_that("vroom uses the number of rows when guess_max = Inf", {
  tf <- tempfile()
  df <- tibble::tibble(x = c(1:1000, "foo", 1001))
  vroom_write(df, tf, delim = "\t")

  # The type should be guessed wrong, because the character comes at the end
  expect_warning(
    res <- vroom(tf, delim = "\t", col_types = list(), altrep = FALSE)
  )
  expect_type(res[["x"]], "double")
  expect_true(is.na(res[["x"]][[NROW(res) - 1]]))

  # The value should exist with guess_max = Inf
  res <- vroom(tf, delim = "\t", guess_max = Inf, col_types = list())
  expect_type(res[["x"]], "character")
  expect_equal(res[["x"]][[NROW(res) - 1]], "foo")
})

test_that("vroom adds columns if a row is too short", {
  test_vroom(
    "a,b,c,d\n1,2\n3,4,5,6\n",
    delim = ",",
    equals = tibble::tibble(
      "a" = c(1, 3),
      "b" = c(2, 4),
      "c" = c(NA, 5),
      "d" = c(NA, 6)
    )
  )
})

test_that("vroom removes columns if a row is too long", {
  test_vroom(
    "a,b,c,d\n1,2,3,4,5,6,7\n8,9,10,11\n",
    delim = ",",
    col_types = c(d = "c"),
    equals = tibble::tibble(
      "a" = c(1, 8),
      "b" = c(2, 9),
      "c" = c(3, 10),
      "d" = c("4,5,6,7", "11")
    )
  )
})

# Figure out a better way to test progress bars...
#test_that("progress bars work", {
#withr::with_options(c("vroom.show_after" = 0), {
#expect_output_file(vroom(vroom_example("mtcars.csv"), progress = TRUE), "mtcars-progress")
#})
#})

test_that("guess_type works with long strings (#74)", {
  expect_s3_class(
    guess_type(
      "https://www.bing.com/search?q=mr+popper%27s+penguins+worksheets+free&FORM=QSRE1"
    ),
    "collector_character"
  )
})

test_that("vroom guesses types if unnamed column types do not match the number of columns", {
  test_vroom(
    I("a,b\n1,2\n"),
    delim = ",",
    col_types = "i",
    equals = tibble::tibble(a = 1L, b = 2L)
  )
})

test_that("column names are properly encoded", {
  skip_on_os("solaris")

  nms <- vroom(I("f\U00F6\U00F6\nbar\n"), delim = "\n", col_types = list())
  expect_equal(Encoding(colnames(nms)), "UTF-8")
})

test_that("Files with windows newlines and missing fields work", {
  test_vroom(
    "a,b,c,d\r\nm,\r\n\r\n",
    delim = ",",
    skip_empty_rows = FALSE,
    equals = tibble::tibble(
      a = c("m", NA),
      b = c(NA, NA),
      c = c(NA, NA),
      d = c(NA, NA)
    )
  )
})

test_that("vroom can read files with no trailing newline", {
  f <- tempfile()
  on.exit(unlink(f))

  writeBin(charToRaw("foo\nbar"), f)
  expect_equal(
    vroom(f, col_names = FALSE, delim = ",", col_types = list())[[1]],
    c("foo", "bar")
  )

  f2 <- tempfile()
  on.exit(unlink(f2), add = TRUE)

  writeBin(charToRaw("foo,bar\n1,2"), f2)
  expect_equal(
    vroom(f2, delim = ",", col_types = list()),
    tibble::tibble(foo = 1, bar = 2)
  )
})


test_that("Can return the spec object", {
  x <- vroom(I("foo,bar\n1,c\n"), col_types = list())
  obj <- spec(x)
  expect_s3_class(obj, "col_spec")
  exp <- as.col_spec(list(foo = "d", bar = "c"))
  exp$delim <- ","
  expect_equal(obj, exp)
})

test_that("vroom handles files with trailing commas, windows newlines, missing a final newline and not null terminated", {
  f <- tempfile()
  on.exit(unlink(f))

  writeChar(
    paste(collapse = "\r\n", c('foo,bar,', '1,2,')),
    con = f,
    eos = NULL
  )

  expect_message(
    regexp = "New names",
    expect_equal(
      vroom(f, col_types = list()),
      tibble::tibble(foo = 1, bar = 2, "...3" = NA)
    )
  )
})

test_that("vroom uses the delim if it is specified in the col_types", {
  # if we give a tab delim in the spec there should only be one column
  expect_equal(
    ncol(vroom(I("a,b,c\n1,2,3\n"), col_types = list(.delim = "\t"))),
    1
  )

  # But specifying an explicit delim overrides the spec
  expect_equal(
    ncol(vroom(
      I("a,b,c\n1,2,3\n"),
      col_types = list(.delim = "\t"),
      delim = ","
    )),
    3
  )

  expect_equal(
    ncol(vroom(
      I("a,b,c\n1,2,3\n"),
      col_types = list(.delim = ","),
      delim = "\t"
    )),
    1
  )
})

test_that("vroom supports NA and NA_integer_ indices", {
  data <- vroom(vroom_example("mtcars.csv"), col_types = list())

  expect_equal(data[NA, 1, drop = TRUE], rep(NA_character_, nrow(data)))
  expect_equal(data[NA_integer_, 1, drop = TRUE], NA_character_)
})

test_that("vroom supports NA and NA_integer_ indices with factors and datetimes", {
  data <- vroom(I("x\ty\nfoo\t2020-01-01 12:00:01"), col_types = "fT")

  expect_equal(data[NA, 1, drop = TRUE], factor(NA, levels = "foo"))
  expect_equal(data[NA, 2, drop = TRUE], .POSIXct(NA_real_, tz = "UTC"))
  expect_equal(data[NA_integer_, 1, drop = TRUE], factor(NA, levels = "foo"))
  expect_equal(
    data[NA_integer_, 2, drop = TRUE],
    .POSIXct(NA_real_, tz = "UTC")
  )
})

test_that("vroom works with windows newlines and files without a trailing newline (#219)", {
  f <- tempfile()
  on.exit(unlink(f))
  writeBin(charToRaw("X,Y\r\n1,12/08/2016\r\n2,05/01/2018"), f)

  res <- vroom(f, col_types = cols(Y = "c"))
  expect_equal(res$Y[[2]], "05/01/2018")
})

test_that("vroom works with `id` and skipped columns", {
  data <- vroom(
    vroom_example("mtcars.csv"),
    col_types = c(mpg = "_"),
    id = "File"
  )

  expect_true(ncol(data) == 12)
  expect_true(names(data)[[1]] == "File")
  expect_false("mpg" %in% names(data))
})

test_that("vroom works with n_max, windows newlines and files larger than the connection buffer", {
  f <- tempfile()
  on.exit(unlink(f))
  writeBin(
    charToRaw(
      "X,Y\r\n1,2\r\n3342343242312312,442342432423432432\r\n432424324,532432324"
    ),
    f
  )

  withr::with_envvar(
    c("VROOM_CONNECTION_SIZE" = 25),
    res <- vroom(f, delim = ",", n_max = 1, col_types = list())
  )

  expect_equal(res$X, 1)
  expect_equal(res$Y, 2)
})

test_that("subsetting works with both double and integer indexes", {
  x <- vroom(I("X1\nfoo"), delim = ",", col_types = list())
  expect_equal(x$X1[1L], "foo")
  expect_equal(x$X1[1], "foo")
  expect_equal(x$X1[NA_integer_], NA_character_)
  expect_equal(x$X1[NA_real_], NA_character_)
})

test_that("quotes inside fields are ignored", {
  x <- vroom(
    I("x\nfoo\"bar\nbaz\n"),
    delim = ",",
    quote = "\"",
    col_types = list()
  )
  expect_equal(x$x[[1]], "foo\"bar")
  expect_equal(x$x[[2]], "baz")
})

test_that("quotes at the beginning and end of lines are used", {
  y <- vroom(
    I("x\n\"foo\"\"bar\"\nbaz\n"),
    delim = ",",
    quote = "\"",
    col_types = list()
  )
  expect_equal(y$x[[1]], "foo\"bar")
  expect_equal(y$x[[2]], "baz")
})

test_that("quotes at delimiters are used", {
  z <- vroom(
    I("x,y,z\n1,\"foo\"\"bar\",2\n3,baz,4"),
    delim = ",",
    quote = "\"",
    col_types = list()
  )
  expect_equal(z$y[[1]], "foo\"bar")
  expect_equal(z$y[[2]], "baz")
})

test_that("vroom reads files with embedded newlines even when num_threads > 1", {
  tf <- tempfile()
  con <- file(tf, "wb")
  on.exit({
    unlink(tf)
  })
  writeLines(
    c("x", rep("foo", 1000), '"bar\nbaz"', rep("qux", 1000)),
    con,
    sep = "\n"
  )
  close(con)

  res <- vroom(tf, delim = ",", num_threads = 5, col_types = list())
  expect_equal(nrow(res), 1000 + 1 + 1000)
  expect_equal(res$x[[1001]], "bar\nbaz")
})

test_that("multi-character comments are supported", {
  res <- vroom(
    I("## this is a comment\n# this is not"),
    delim = "\t",
    comment = "##",
    col_names = FALSE,
    col_types = list()
  )
  expect_equal(res[[1]], "# this is not")
})

test_that("vroom works with quoted fields at the end of a windows newline", {
  f <- tempfile()
  on.exit(unlink(f))
  con <- file(f, "wb")
  writeLines(c('"x"', 1), con, sep = "\r\n")
  close(con)
  res <- vroom(f, delim = ",", col_names = FALSE, col_types = list())
  expect_equal(res[[1]], c("x", 1))
})

test_that("vroom can handle NUL characters in strings", {
  test_vroom(
    test_path("raw.csv"),
    delim = ",",
    progress = FALSE,
    equals = tibble::tibble(abc = "ab", def = "def")
  )
})

test_that("n_max is respected in all cases", {
  expect_equal(
    dim(vroom(I("x\ty\tz\n1\t2\t3\n4\t5\t6\n"), n_max = 1, col_types = list())),
    c(1, 3)
  )
})

test_that("comments are ignored regardless of where they appear", {
  out1 <- vroom(I('x\n1#comment'), comment = "#", col_types = "d", delim = ",")
  out2 <- vroom(
    I('x\n1#comment\n#comment'),
    comment = "#",
    col_types = "d",
    delim = ","
  )
  out3 <- vroom(
    I('x\n"1"#comment'),
    comment = "#",
    col_types = "d",
    delim = ","
  )

  expect_equal(out1$x, 1)
  expect_equal(out2$x, 1)
  expect_equal(out3$x, 1)

  out4 <- vroom(
    I('x,y\n1,#comment'),
    comment = "#",
    delim = ",",
    col_types = "cc",
    progress = FALSE,
    altrep = FALSE
  )
  expect_equal(out4$y, NA_character_)

  expect_warning(
    out5 <- vroom(
      I("x1,x2,x3\nA2,B2,C2\nA3#,B2,C2\nA4,A5,A6"),
      comment = "#",
      delim = ",",
      col_types = "ccc",
      altrep = FALSE,
      progress = FALSE
    )
  )
  expect_warning(
    out6 <- vroom(
      I("x1,x2,x3\nA2,B2,C2\nA3,#B2,C2\nA4,A5,A6"),
      comment = "#",
      delim = ",",
      col_types = "ccc",
      altrep = FALSE,
      progress = FALSE
    )
  )
  expect_warning(
    out7 <- vroom(
      I("x1,x2,x3\nA2,B2,C2\nA3,#B2,C2\n#comment\nA4,A5,A6"),
      comment = "#",
      delim = ",",
      col_types = "ccc",
      altrep = FALSE,
      progress = FALSE
    )
  )

  chk <- tibble::tibble(
    x1 = c("A2", "A3", "A4"),
    x2 = c("B2", NA_character_, "A5"),
    x3 = c("C2", NA_character_, "A6")
  )

  expect_true(all.equal(chk, out5, check.attributes = FALSE))
  expect_true(all.equal(chk, out6, check.attributes = FALSE))
  expect_true(all.equal(chk, out7, check.attributes = FALSE))
})

test_that("escaped/quoted comments are ignored", {
  out1 <- vroom(
    I('x\n\\#'),
    comment = "#",
    delim = ",",
    escape_backslash = TRUE,
    escape_double = FALSE,
    progress = FALSE,
    col_types = "c"
  )
  out2 <- vroom(
    I('x\n"#"'),
    comment = "#",
    progress = FALSE,
    delim = ",",
    col_types = "c"
  )

  expect_equal(out1$x, "#")
  expect_equal(out2$x, "#")
})

test_that("name repair with custom functions works", {
  add_y <- function(x) {
    paste(x, "y", sep = "_")
  }
  out <- vroom(I("x,y,z\n1,2,3"), col_types = "iii", .name_repair = add_y)
  expect_equal(colnames(out), c("x_y", "y_y", "z_y"))
})

test_that("col_types are based on the final (possibly repaired) column names (#311)", {
  suppressMessages(
    out <- vroom(
      I("x,\n1,2\n3,4"),
      delim = ",",
      col_types = list(x = col_double(), "...2" = col_double())
    )
  )
  expect_equal(out[["...2"]], c(2, 4))
})

test_that("mismatched column names throw a classed warning", {
  expect_warning(
    vroom(
      I("x,y\n1,2\n3,4\n"),
      col_types = list(
        x = col_double(),
        y = col_double(),
        z = col_double()
      )
    ),
    class = "vroom_mismatched_column_name"
  )
})

test_that("empty files still generate the correct column width and types", {
  out <- vroom(I(""), col_names = c("foo", "bar"), col_types = list())
  expect_equal(nrow(out), 0)
  expect_equal(ncol(out), 2)
  expect_equal(names(out), c("foo", "bar"))
  expect_type(out[[1]], "character")
  expect_type(out[[2]], "character")

  out <- vroom(I(""), col_types = "ii")
  expect_equal(nrow(out), 0)
  expect_equal(ncol(out), 2)
  expect_equal(names(out), c("X1", "X2"))
  expect_type(out[[1]], "integer")
  expect_type(out[[2]], "integer")
})

test_that("leading whitespace effects guessing", {
  out <- vroom(
    I('a,b,c\n 1,2,3\n'),
    delim = ",",
    trim_ws = FALSE,
    progress = FALSE,
    col_types = list()
  )
  expect_type(out[[1]], "character")

  out <- vroom(
    I('a,b,c\n 1,2,3\n'),
    delim = ",",
    trim_ws = TRUE,
    progress = FALSE,
    col_types = list()
  )
  expect_type(out[[1]], "double")
})

test_that("UTF-16LE encodings can be read", {
  bom <- as.raw(c(255, 254))
  # This is the text.
  text <- "x,y\n\U104371,2\n" # This is a 4 byte UTF-16 character from https://en.wikipedia.org/wiki/UTF-16

  # Converted to UTF-16LE
  text_utf16 <- iconv(text, from = "UTF-8", to = "UTF-16LE", toRaw = TRUE)[[1]]

  # Write the BOM and the text to a file
  tmp_file_name <- tempfile()
  fd <- file(tmp_file_name, "wb")
  writeBin(bom, fd)
  writeBin(text_utf16, fd)
  close(fd)

  # Whether LE or BE is determined automatically by the BOM
  out <- vroom(
    tmp_file_name,
    locale = locale(encoding = "UTF-16"),
    col_types = "ci"
  )
  expect_equal(out$x, "\U104371")
  expect_equal(out$y, 2)
})

test_that("supports unicode grouping and decimal marks (https://github.com/tidyverse/readr/issues/796)", {
  test_vroom(
    I("1\u00A0234\u02D95"),
    locale = locale(grouping_mark = "\u00A0", decimal_mark = "\u02D9"),
    col_types = "n",
    col_names = FALSE,
    delim = ",",
    equals = tibble::tibble(X1 = 1234.5)
  )
})

test_that("handles quotes within skips", {
  data <- I(paste0(
    collapse = "\n",
    c("a\tb\tc", "1a\t1b\t1c", "2a\t2b\t2c\"", "3a\t3b\t3c\"", "4a\t4b\t4c")
  ))

  test_vroom(
    data,
    col_names = c("a", "b", "c"),
    skip = 2,
    quote = "",
    delim = "\t",
    equals = tibble::tibble(
      a = c("2a", "3a", "4a"),
      b = c("2b", "3b", "4b"),
      c = c("2c\"", "3c\"", "4c")
    )
  )

  test_vroom(
    data,
    col_names = c("a", "b", "c"),
    skip = 3,
    quote = "",
    delim = "\t",
    equals = tibble::tibble(
      a = c("3a", "4a"),
      b = c("3b", "4b"),
      c = c("3c\"", "4c")
    )
  )

  test_vroom(
    data,
    col_names = c("a", "b", "c"),
    skip = 4,
    quote = "",
    delim = "\t",
    equals = tibble::tibble(
      a = c("4a"),
      b = c("4b"),
      c = c("4c")
    )
  )
})

test_that("skipped columns retain their name", {
  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = "x",
    col_types = "i__",
    equals = tibble::tibble(
      x = c(1L, 4L)
    )
  )

  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = "y",
    col_types = "_i_",
    equals = tibble::tibble(
      y = c(2L, 5L)
    )
  )

  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = "z",
    col_types = "__i",
    equals = tibble::tibble(
      z = c(3L, 6L)
    )
  )

  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = c("x", "z"),
    col_types = "i_i",
    equals = tibble::tibble(
      x = c(1L, 4L),
      z = c(3L, 6L)
    )
  )
})

test_that("skipped columns retain their name", {
  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = "x",
    col_types = "i__",
    equals = tibble::tibble(
      x = c(1L, 4L)
    )
  )

  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = "y",
    col_types = "_i_",
    equals = tibble::tibble(
      y = c(2L, 5L)
    )
  )

  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = "z",
    col_types = "__i",
    equals = tibble::tibble(
      z = c(3L, 6L)
    )
  )

  test_vroom(
    I("1,2,3\n4,5,6"),
    col_names = c("x", "z"),
    col_types = "i_i",
    equals = tibble::tibble(
      x = c(1L, 4L),
      z = c(3L, 6L)
    )
  )
})

test_that("unnamed column types can be less than the number of columns", {
  test_vroom(
    "x,y\n1,2\n",
    col_types = "i",
    equals = tibble::tibble(
      x = 1L,
      y = 2L
    )
  )
})

test_that("always include the last row when guessing (#352)", {
  f <- tempfile()
  on.exit(unlink(f))

  vroom_write(data.frame("x" = c(rep(NA, 10), 5)), delim = ",", file = f)

  x <- vroom(f, col_types = "?", guess_max = 5, delim = ",")

  expect_type(x[[1]], "double")
})

test_that("vroom works with quote even in the first two lines (#1262)", {
  text <-
    c(
      "1,'I
am
sam'
2,'sam
I
am'"
    )

  test_vroom(
    text,
    col_names = FALSE,
    quote = "'",
    delim = ",",
    equals = tibble::tibble(X1 = c(1, 2), X2 = c("I\nam\nsam", "sam\nI\nam"))
  )
})

test_that("vroom works when grouping_mark is empty (#1241)", {
  x <- vroom(
    I("foo\nbar"),
    locale = locale(grouping_mark = ""),
    delim = ",",
    col_names = FALSE,
    col_types = "c"
  )
  expect_equal(x[[1]], c("foo", "bar"))
})

test_that("vroom works if given col_names and col_types less than the number of columns (https://github.com/tidyverse/readr/issues/1271)", {
  x <- vroom(
    I("a\tb\n"),
    delim = "\t",
    col_names = c("x"),
    col_types = list("x" = "c")
  )

  expect_equal(x[["x"]], "a")
  expect_equal(x[["X2"]], "b")
})

test_that("vroom works with CR line endings only", {
  test_vroom(
    I("a,b\r1,2\r3,4\r"),
    delim = ",",
    equals = tibble::tibble(a = c(1, 3), b = c(2, 4))
  )
})

test_that("vroom works with quotes in comments", {
  test_vroom(
    I("a,b\n#bar \" xyz\n1,2"),
    delim = ",",
    comment = "#",
    equals = tibble::tibble(a = 1, b = 2)
  )

  test_vroom(
    I("#foo \" \na,b\n#bar \" xyz\n1,2"),
    delim = ",",
    comment = "#",
    equals = tibble::tibble(a = 1, b = 2)
  )
})

# https://github.com/tidyverse/vroom/issues/484
test_that("unclosed quote is not a silent failure (file)", {
  f <- withr::local_tempfile(lines = c("A,B,C", "a,b,\"c", "d,e,f"))

  expect_warning(
    res <- vroom(f, show_col_types = FALSE, altrep = FALSE),
    class = "vroom_parse_issue"
  )
  # we don't currently expect to recover and find two rows
  # but we should find 1 row of data
  expect_equal(dim(res), c(1, 3))
})

# https://github.com/tidyverse/vroom/issues/484
test_that("unclosed quote is not a silent failure (connection)", {
  f <- withr::local_tempfile(lines = c("A,B,C", "a,b,\"c", "d,e,f"))

  expect_warning(
    res <- vroom(file(f), show_col_types = FALSE, altrep = FALSE),
    class = "vroom_parse_issue"
  )
  expect_equal(dim(res), c(1, 3))
})

# https://github.com/tidyverse/vroom/issues/484
test_that("unclosed quote is not a silent failure (multi-threaded attempt)", {
  # goal is to create enough rows that vroom attempts multi-threaded indexing
  # empirically confirmed that this is sufficient with some (temporary) print
  # statements
  lines <- c("A,B,C", rep("a,b,c", 100), "d,e,\"f", rep("g,h,i", 100))
  f <- withr::local_tempfile(lines = lines)

  expect_warning(
    res <- vroom(f, show_col_types = FALSE, altrep = FALSE, num_threads = 2),
    class = "vroom_parse_issue"
  )
  # 100 rows before the unclosed quote, plus 1 row where the unclosed quote
  # consumes everything after it (including the 100 "g,h,i" lines)
  expect_equal(dim(res), c(101, 3))
})

test_that("vroom works with comments at end of lines (https://github.com/tidyverse/readr/issues/1309)", {
  test_vroom(
    I("foo,bar#\n1,#\n2#\n#\n3\n"),
    delim = ",",
    comment = "#",
    equals = tibble::tibble(foo = c(1, 2, 3), bar = c(NA, NA, NA))
  )
})

test_that("vroom does not erronously warn for problems when there are embedded newlines and parsing needs to be restarted (https://github.com/tidyverse/readr/issues/1313))", {
  withr::local_seed(1)

  sample_values <- function(n, p_safe) {
    sample(
      c("safe", "UNSAFE\n"),
      n,
      replace = TRUE,
      prob = c(p_safe, 1 - p_safe)
    )
  }

  n <- 300

  df <- tibble::tibble(
    a = sample_values(n, p_safe = .99),
    b = sample_values(n, p_safe = .01),
    c = sample_values(n, p_safe = .01)
  )

  # write to temp file
  path <- tempfile(pattern = "quoted_newlines_", fileext = ".csv")
  withr::defer(unlink(path))

  vroom_write(df, path, delim = ",")

  x <- vroom(path, delim = ",", col_types = list())
  y <- utils::read.csv(path, stringsAsFactors = FALSE)

  expect_warning(expect_equal(as.data.frame(x), y), NA)
})

test_that("n_max works with files without a trailing newline for file connections (https://github.com/tidyverse/readr/issues/1321)", {
  f <- tempfile()
  on.exit(unlink(f))

  writeBin(
    charToRaw(
      "foo,bar
1,2
3,4
5,6"
    ),
    f
  )

  x <- vroom(f, n_max = Inf, delim = ",", col_types = list())
  y <- vroom(f, n_max = 4, delim = ",", col_types = list())
  z <- vroom(f, n_max = 5, delim = ",", col_types = list())
  expect_equal(y, x)
  expect_equal(z, x)
})

# https://github.com/tidyverse/vroom/issues/453
test_that("vroom can read a date column with no data and skip 1", {
  test_vroom(
    "date\n",
    delim = ",",
    col_names = 'date',
    col_types = 'D',
    skip = 1,
    equals = tibble::tibble(date = as.Date(character()))
  )
})

# https://github.com/tidyverse/vroom/issues/453
test_that("vroom can read a datetime column with no data and skip 1", {
  test_vroom(
    "dt\n",
    delim = ",",
    col_names = 'dt',
    col_types = 'T',
    skip = 1,
    equals = tibble::tibble(dt = as.POSIXct(character()))
  )
})

# https://github.com/tidyverse/vroom/issues/554
# https://github.com/tidyverse/vroom/issues/534
test_that("vroom(col_select =) output has 'spec_tbl_df' class, spec, and problems when readr is attached", {
  # Register readr's [.spec_tbl_df method which drops attributes and the "spec_tbl_df" class
  readr_single_bracket <- function(x, ...) {
    attr(x, "spec") <- NULL
    attr(x, "problems") <- NULL
    class(x) <- setdiff(class(x), "spec_tbl_df")
    NextMethod(`[`)
  }
  registerS3method("[", "spec_tbl_df", readr_single_bracket)

  # Unfortunately you can't just de-register the method and
  # local_mocked_s3_method() only works if method exists to begin with.
  # We'll do next best thing which is to put a pass-through method back.
  withr::defer({
    registerS3method("[", "spec_tbl_df", function(x, ...) NextMethod(`[`))
  })

  expect_warning(
    dat <- vroom(
      I("a,b\n1,2\nz,3\n4,5"),
      col_types = "dc",
      col_select = c(a, b),
      show_col_types = FALSE,
      altrep = FALSE
    ),
    class = "vroom_parse_issue"
  )

  expect_s3_class(dat, "spec_tbl_df")
  expect_equal(
    attr(dat, "spec", exact = TRUE),
    cols(
      a = col_double(),
      b = col_character(),
      .delim = ","
    )
  )
  expect_no_error(probs <- problems(dat))
  if (exists("probs")) {
    expect_equal(nrow(probs), 1)
    expect_equal(probs$row, 3)
    expect_equal(probs$col, 1)
  }
})

test_that("strings mapped to levels", {
  test_vroom(
    "a\nb\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = c("a", "b"))),
    equals = tibble::tibble(X1 = factor(c("a", "b")))
  )
})

test_that("can generate ordered factor", {
  res <- test_vroom(
    "a\nb\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = c("a", "b"), ordered = TRUE)),
    equals = tibble::tibble(X1 = ordered(c("a", "b")))
  )

  expect_true(is.ordered(res$X1))
})

test_that("NA if value not in levels", {
  test_vroom(
    "a\nb\nc\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = c("a", "b"))),
    equals = tibble::tibble(X1 = factor(c("a", "b", NA)))
  )
})

test_that("NAs silently passed along", {
  test_vroom(
    "a\nb\nNA\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = c("a", "b"), include_na = FALSE)),
    equals = tibble::tibble(X1 = factor(c("a", "b", NA)))
  )
})

test_that("levels = NULL", {
  test_vroom(
    "a\nb\nc\nb\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = NULL)),
    equals = tibble::tibble(X1 = factor(c("a", "b", "c", "b")))
  )
})

test_that("levels = NULL orders by data", {
  test_vroom(
    "b\na\nc\nb\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = NULL)),
    equals = tibble::tibble(
      X1 = factor(c("b", "a", "c", "b"), levels = c("b", "a", "c"))
    )
  )
})

test_that("levels = NULL is the default", {
  test_vroom(
    "a\nb\nc\nd\n",
    col_names = FALSE,
    col_types = list(X1 = "f"),
    equals = tibble::tibble(X1 = factor(c("a", "b", "c", "d")))
  )
})

test_that("NAs included in levels if desired", {
  test_vroom(
    "NA\nb\na\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = c("a", "b", NA))),
    equals = tibble::tibble(
      X1 = factor(c(NA, "b", "a"), levels = c("a", "b", NA), exclude = NULL)
    )
  )

  test_vroom(
    "NA\nb\na\n",
    col_names = FALSE,
    col_types = list(
      X1 = col_factor(levels = c("a", "b", NA), include_na = TRUE)
    ),
    equals = tibble::tibble(
      X1 = factor(c(NA, "b", "a"), levels = c("a", "b", NA), exclude = NULL)
    )
  )

  test_vroom(
    "NA\nb\na\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = NULL, include_na = FALSE)),
    equals = tibble::tibble(X1 = factor(c(NA, "b", "a"), levels = c("b", "a")))
  )

  test_vroom(
    "NA\nb\na\n",
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = NULL, include_na = TRUE)),
    equals = tibble::tibble(
      X1 = factor(c(NA, "b", "a"), levels = c(NA, "b", "a"), exclude = NULL)
    )
  )
})

test_that("Factors handle encodings properly (#615)", {
  encoded <- function(x, encoding) {
    Encoding(x) <- encoding
    x
  }
  f <- tempfile()
  on.exit(unlink(f))
  writeBin(charToRaw(encoded("test\nA\n\xC4\n", "latin1")), f)
  x <- test_vroom(
    f,
    delim = ",",
    col_types = cols(col_factor(c("A", "\uC4"))),
    locale = locale(encoding = "latin1"),
    equals = tibble::tibble(
      test = factor(c("A", "\uC4"), levels = c("A", "\uC4"))
    )
  )
})

test_that("factors parse like factor if trim_ws = FALSE", {
  test_vroom(
    "a\na \n",
    col_names = FALSE,
    trim_ws = FALSE,
    col_types = list(X1 = col_factor(levels = "a")),
    equals = tibble::tibble(X1 = factor(c("a", "a "), levels = c("a")))
  )
  test_vroom(
    "a\na \n",
    col_names = FALSE,
    trim_ws = FALSE,
    col_types = list(X1 = col_factor(levels = "a ")),
    equals = tibble::tibble(X1 = factor(c("a", "a "), levels = c("a ")))
  )
  test_vroom(
    "a\na \n",
    col_names = FALSE,
    trim_ws = FALSE,
    col_types = list(X1 = col_factor(levels = c("a ", "a"))),
    equals = tibble::tibble(X1 = factor(c("a", "a "), levels = c("a ", "a")))
  )
})

test_that("Can parse a factor with levels of NA and empty string", {
  x <- c(
    "NC",
    "NC",
    "NC",
    "",
    "",
    "NB",
    "NA",
    "",
    "",
    "NB",
    "NA",
    "NA",
    "NC",
    "NB",
    "NB",
    "NC",
    "NB",
    "NA",
    "NA"
  )

  x_in <- paste0(paste(x, collapse = "\n"), "\n")

  test_vroom(
    x_in,
    col_names = FALSE,
    col_types = list(X1 = col_factor(levels = c("NA", "NB", "NC", ""))),
    na = character(),
    skip_empty_rows = FALSE,
    equals = tibble::tibble(X1 = factor(x, levels = c("NA", "NB", "NC", "")))
  )
})


test_that("encodings are respected", {
  loc <- locale(encoding = "ISO-8859-1")
  expected <- c("fran\u00e7ais", "\u00e9l\u00e8ve")

  x <- vroom(
    test_path("enc-iso-8859-1.txt"),
    delim = "\n",
    locale = loc,
    col_types = c(X1 = "f"),
    col_names = FALSE
  )
  expect_equal(x[[1]], factor(expected, levels = expected))

  y <- vroom(
    test_path("enc-iso-8859-1.txt"),
    delim = "\n",
    locale = loc,
    col_types = list(X1 = col_factor(levels = expected)),
    col_names = FALSE
  )

  expect_equal(y[[1]], factor(expected, levels = expected))
})

test_that("Results are correct with backslash escapes", {
  obj <- vroom(
    I("A,T\nB,F\n"),
    col_names = FALSE,
    col_types = list("f", "f"),
    escape_backslash = TRUE
  )
  exp <- tibble::tibble(
    X1 = factor(c("A", "B")),
    X2 = factor(c("T", "F"), levels = c("T", "F"))
  )
  expect_equal(obj, exp)

  obj2 <- vroom(
    I("A,T\nB,F\n"),
    col_names = FALSE,
    col_types = list("f", "f"),
    escape_backslash = FALSE
  )
  expect_equal(obj2, exp)
})


test_that("subsetting works with both double and integer indexes", {
  x <- vroom(I("X1\nfoo"), delim = ",", col_types = "f")
  expect_equal(x$X1[1L], factor("foo"))
  expect_equal(x$X1[1], factor("foo"))
  expect_equal(x$X1[NA_integer_], factor(NA_character_, levels = "foo"))
  expect_equal(x$X1[NA_real_], factor(NA_character_, levels = "foo"))
})

test_that("results are correct even with quoted values", {
  expect_equal(
    vroom(
      I('day\n"Sun"\n"Sat"\n"Sat"'),
      altrep = FALSE,
      col_types = "f",
      delim = ","
    )$day,
    factor(c("Sun", "Sat", "Sat"), levels = c("Sun", "Sat"))
  )
})

test_that("NAs are correctly encoded and not included in levels unless desired", {
  test_vroom(
    "X\nunknown\nb\na\n",
    col_types = list(X = col_factor(levels = NULL, include_na = FALSE)),
    na = "unknown",
    equals = tibble::tibble(
      X = factor(c(NA, "b", "a"), levels = c("b", "a"), exclude = NULL)
    )
  )
  test_vroom(
    "X\nunknown\nb\na\nmissing\n",
    col_types = list(X = col_factor(levels = NULL, include_na = FALSE)),
    na = c("unknown", "missing"),
    equals = tibble::tibble(
      X = factor(c(NA, "b", "a", NA), levels = c("b", "a"), exclude = NULL)
    )
  )
  test_vroom(
    "X\nunknown\nb\na\n",
    col_types = list(X = col_factor(levels = NULL, include_na = TRUE)),
    na = "unknown",
    equals = tibble::tibble(
      X = factor(c(NA, "b", "a"), levels = c(NA, "b", "a"), exclude = NULL)
    )
  )
  test_vroom(
    "X\nunknown\nb\na\nmissing\n",
    col_types = list(X = col_factor(levels = NULL, include_na = TRUE)),
    na = c("unknown", "missing"),
    equals = tibble::tibble(
      X = factor(c(NA, "b", "a", NA), levels = c(NA, "b", "a"), exclude = NULL)
    )
  )
})

test_that("datetime parsing works", {
  test_vroom(
    "date,time,datetime
2018-01-01,10:01:01 AM,2018-01-01 10:01:01
2019-01-01,05:04:03 AM,2019-01-01 05:04:03
",
    delim = ",",
    equals = tibble::tibble(
      date = c(as.Date("2018-01-01"), as.Date("2019-01-01")),
      time = c(hms::hms(1, 1, 10), hms::hms(3, 4, 5)),
      datetime = vctrs::vec_c(
        as.POSIXct("2018-01-01 10:01:01", tz = "UTC"),
        as.POSIXct("2019-01-01 05:04:03", tz = "UTC")
      )
    )
  )
})

# Parsing ----------------------------------------------------------------------

r_parse <- function(x, fmt) as.POSIXct(strptime(x, fmt, tz = "UTC"))

test_that("%d, %m and %y", {
  target <- utctime(2010, 2, 3, 0, 0, 0, 0)

  test_parse_datetime("10-02-03", "%y-%m-%d", expected = target)
  test_parse_datetime("10-03-02", "%y-%d-%m", expected = target)
  test_parse_datetime("03/02/10", "%d/%m/%y", expected = target)
  test_parse_datetime("02/03/10", "%m/%d/%y", expected = target)
})

test_that("Compound formats work", {
  target <- utctime(2010, 2, 3, 0, 0, 0, 0)

  test_parse_datetime("02/03/10", "%D", expected = target)
  test_parse_datetime("2010-02-03", "%F", expected = target)
  test_parse_datetime("10/02/03", "%x", expected = target)
})

test_that("%y matches R behaviour", {
  test_parse_datetime(
    "01-01-69",
    "%d-%m-%y",
    expected = r_parse("01-01-69", "%d-%m-%y")
  )
  test_parse_datetime(
    "01-01-68",
    "%d-%m-%y",
    expected = r_parse("01-01-68", "%d-%m-%y")
  )
})

test_that("%e allows leading space", {
  test_parse_datetime(
    "201010 1",
    "%Y%m%e",
    expected = utctime(2010, 10, 1, 0, 0, 0, 0)
  )
})

test_that("%OS captures partial seconds", {
  test_parse_datetime(
    "2001-01-01 00:00:01.125",
    "%Y-%m-%d %H:%M:%OS",
    expected = utctime(2001, 1, 1, 0, 0, 1, .125)
  )
  test_parse_datetime(
    "2001-01-01 00:00:01.133",
    "%Y-%m-%d %H:%M:%OS",
    expected = utctime(2001, 1, 1, 0, 0, 1, .133)
  )
})

test_that("%Y requires 4 digits", {
  test_parse_date("03-01-01", "%Y-%m-%d", expected = as.Date(NA))
  test_parse_date("003-01-01", "%Y-%m-%d", expected = as.Date(NA))
  test_parse_date("0003-01-01", "%Y-%m-%d", expected = as.Date("0003-01-01"))
  test_parse_date("00003-01-01", "%Y-%m-%d", expected = as.Date(NA))
})

test_that("invalid dates return NA", {
  test_parse_datetime(
    "2010-02-30",
    "%Y-%m-%d",
    expected = .POSIXct(NA_real_, tz = "UTC")
  )
})

test_that("failed parsing returns NA", {
  test_parse_datetime(
    c("2010-02-ab", "2010-02", "2010/02/01"),
    "%Y-%m-%d",
    expected = .POSIXct(rep(NA_real_, 3), tz = "UTC")
  )
})

test_that("invalid specs returns NA", {
  test_parse_datetime(
    "2010-02-20",
    "%Y-%m-%m",
    expected = .POSIXct(NA_real_, tz = "UTC")
  )
})

test_that("ISO8601 partial dates are not parsed", {
  test_parse_datetime("20", "", expected = .POSIXct(NA_real_, tz = "UTC"))
  test_parse_datetime("2001", "", expected = .POSIXct(NA_real_, tz = "UTC"))
  test_parse_datetime("2001-01", "", expected = .POSIXct(NA_real_, tz = "UTC"))
})

test_that("Year only gets parsed", {
  test_parse_datetime(
    "2010",
    "%Y",
    expected = ISOdate(2010, 1, 1, 0, tz = "UTC")
  )
  test_parse_datetime(
    "2010-06",
    "%Y-%m",
    expected = ISOdate(2010, 6, 1, 0, tz = "UTC")
  )
})

test_that("%p detects AM/PM", {
  test_parse_datetime(
    c("2015-01-01 01:00 AM", "2015-01-01 01:00 am"),
    "%F %I:%M %p",
    expected = .POSIXct(c(1420074000, 1420074000), "UTC")
  )

  test_parse_datetime(
    c("2015-01-01 01:00 PM", "2015-01-01 01:00 pm"),
    "%F %I:%M %p",
    expected = .POSIXct(c(1420117200, 1420117200), "UTC")
  )

  test_parse_datetime(
    "12/31/1991 12:01 AM",
    "%m/%d/%Y %I:%M %p",
    expected = .POSIXct(694137660, "UTC")
  )

  test_parse_datetime(
    "12/31/1991 12:01 PM",
    "%m/%d/%Y %I:%M %p",
    expected = .POSIXct(694180860, "UTC")
  )

  test_parse_datetime(
    "12/31/1991 01:01 AM",
    "%m/%d/%Y %I:%M %p",
    expected = .POSIXct(694141260, "UTC")
  )

  test_parse_datetime(
    c("12/31/1991 00:01 PM", "12/31/1991 13:01 PM"),
    "%m/%d/%Y %I:%M %p",
    expected = .POSIXct(rep(NA_real_, 2), tz = "UTC")
  )
})

test_that("%b and %B are case insensitive", {
  ref <- as.Date("2001-01-01")

  test_parse_date("2001 JAN 01", "%Y %b %d", expected = ref)
  test_parse_date("2001 JANUARY 01", "%Y %B %d", expected = ref)
})

test_that("%. requires a value", {
  ref <- as.Date("2001-01-01")

  test_parse_date("2001?01?01", "%Y%.%m%.%d", expected = ref)
  test_parse_date("20010101", "%Y%.%m%.%d", expected = as.Date(NA))
})

test_that("%Z detects named time zones", {
  ref <- .POSIXct(1285912800, "America/Chicago")
  ct <- locale(tz = "America/Chicago")

  test_parse_datetime("2010-10-01 01:00", "", expected = ref, locale = ct)
  test_parse_datetime(
    "2010-10-01 01:00 America/Chicago",
    "%Y-%m-%d %H:%M %Z",
    locale = ct,
    expected = ref
  )
})

test_that("%Z detects named time zones", {
  ref <- .POSIXct(1285912800, "UTC")

  test_parse_datetime("1285912800", "%s", expected = ref)
})

test_that("parse_date returns a double like as.Date()", {
  ref <- as.Date("2001-01-01")

  res <- test_parse_date("2001-01-01", "", expected = ref)
  expect_type(res[[1]], "double")
})

test_that("parses NA/empty correctly", {
  expect_equal(
    vroom(
      I("x\n\n"),
      delim = ",",
      col_types = list(x = "T"),
      skip_empty_rows = FALSE
    ),
    tibble::tibble(x = .POSIXct(NA_real_, tz = "UTC"))
  )

  expect_equal(
    vroom(
      I("x\n\n"),
      delim = ",",
      col_types = list(x = "D"),
      skip_empty_rows = FALSE
    ),
    tibble::tibble(x = as.Date(NA))
  )

  test_parse_datetime(
    "TeSt",
    "",
    na = "TeSt",
    expected = .POSIXct(NA_real_, tz = "UTC")
  )
  test_parse_date("TeSt", "", na = "TeSt", expected = as.Date(NA))
})

## Locales -----------------------------------------------------------------

test_that("locale affects months", {
  jan1 <- as.Date("2010-01-01")

  fr <- locale("fr")
  test_parse_date("1 janv. 2010", "%d %b %Y", locale = fr, expected = jan1)
  test_parse_date("1 janvier 2010", "%d %B %Y", locale = fr, expected = jan1)
})

test_that("locale affects day of week", {
  a <- as.POSIXct("2010-01-01", tz = "UTC")
  b <- .POSIXct(unclass(as.Date("2010-01-01")) * 86400, tz = "UTC")
  fr <- locale("fr")

  test_parse_datetime(
    "Ven. 1 janv. 2010",
    "%a %d %b %Y",
    locale = fr,
    expected = a
  )
  test_parse_datetime(
    "Ven. 1 janv. 2010",
    "%a %d %b %Y",
    locale = fr,
    expected = b
  )
})

test_that("locale affects am/pm", {
  skip_on_os("windows")
  skip_on_os("solaris")
  skip_if_not(l10n_info()$`UTF-8`)

  expected <- hms::hms(hours = 13, minutes = 30)
  test_parse_time("01:30 PM", "%H:%M %p", expected = expected)
  test_parse_time(
    "\UC624\UD6C4 01\UC2DC 30\UBD84",
    "%p %H\UC2DC %M\UBD84",
    expected = expected,
    locale = locale("ko")
  )
})

test_that("locale affects both guessing and parsing", {
  out <- vroom(
    I("01/02/2013\n"),
    delim = ",",
    col_names = FALSE,
    col_types = list(),
    locale = locale(date_format = "%m/%d/%Y")
  )
  expect_equal(out[[1]][[1]], as.Date("2013-01-02"))
})

## Time zones ------------------------------------------------------------------

test_that("same times with different offsets parsed as same time", {
  # From http://en.wikipedia.org/wiki/ISO_8601#Time_offsets_from_UTC
  same_time <- paste(
    "2010-02-03",
    c("18:30Z", "22:30+04", "1130-0700", "15:00-03:30")
  )
  test_parse_datetime(
    same_time,
    format = "",
    expected = rep(utctime(2010, 2, 3, 18, 30, 0, 0), 4)
  )
})

test_that("offsets can cross date boundaries", {
  expected <- as.POSIXct("2015-02-01 01:00:00Z", tz = "UTC")
  test_parse_datetime("2015-01-31T2000-0500", expected = expected)
  test_parse_datetime("2015-02-01T0100Z", expected = expected)
})

test_that("unambiguous times with and without daylight savings", {
  skip("Not working on CI")
  skip_on_cran() # need to figure out why this fails

  melb <- locale(tz = "Australia/Melbourne")

  # Melbourne had daylight savings in 2015 that ended the morning of 2015-04-05
  expected_melb <- .POSIXct(c(1428109200, 1428285600), "Australia/Melbourne")
  test_parse_datetime(
    c("2015-04-04 12:00:00", "2015-04-06 12:00:00"),
    locale = melb,
    expected = expected_melb
  )

  # Japan didn't have daylight savings in 2015
  expected_ja <- .POSIXct(c(1428116400, 1428289200), "Japan")
  ja <- locale(tz = "Japan")
  test_parse_datetime(
    c("2015-04-04 12:00:00", "2015-04-06 12:00:00"),
    locale = ja,
    expected = expected_ja
  )
})

test_that("ambiguous times always choose the earliest time", {
  ny <- locale(tz = "America/New_York")

  format <- "%Y-%m-%d %H:%M:%S%z"
  expected <- as.POSIXct(
    "1970-10-25 01:30:00-0400",
    tz = "America/New_York",
    format = format
  )

  test_parse_datetime("1970-10-25 01:30:00", locale = ny, expected = expected)
})

test_that("nonexistent times return NA", {
  ny <- locale(tz = "America/New_York")
  expected <- .POSIXct(NA_real_, tz = "America/New_York")

  test_parse_datetime("1970-04-26 02:30:00", locale = ny, expected = expected)
})

test_that("can use `tz = ''` for system time zone", {
  withr::local_timezone("Europe/London")

  system <- locale(tz = "")
  expected <- as.POSIXct("1970-01-01 00:00:00", tz = "Europe/London")

  test_parse_datetime(
    "1970-01-01 00:00:00",
    locale = system,
    expected = expected
  )
})

## Guessing ---------------------------------------------------------------------

test_that("DDDD-DD not parsed as date (i.e. doesn't trigger partial date match)", {
  expect_type(
    vroom(I("1989-90\n1990-91\n"), delim = "\n", col_types = list())[[1]],
    "character"
  )
})

test_that("leading zeros don't get parsed as date without explicit separator", {
  expect_type(
    vroom(
      I("00010203\n"),
      col_names = FALSE,
      delim = "\n",
      col_types = list()
    )[[1]],
    "double"
  )
  expect_s3_class(
    vroom(
      I("0001-02-03\n"),
      col_names = FALSE,
      delim = "\n",
      col_types = list()
    )[[1]],
    "Date"
  )
})

test_that("must have either two - or none", {
  expect_s3_class(
    vroom(
      I("2000-10-10\n"),
      col_names = FALSE,
      delim = "\n",
      col_types = list()
    )[[1]],
    "Date"
  )
  expect_type(
    vroom(
      I("2000-1010\n"),
      col_names = FALSE,
      delim = "\n",
      col_types = list()
    )[[1]],
    "character"
  )
  expect_type(
    vroom(
      I("200010-10\n"),
      col_names = FALSE,
      delim = "\n",
      col_types = list()
    )[[1]],
    "character"
  )
  expect_type(
    vroom(
      I("20001010\n"),
      col_names = FALSE,
      delim = "\n",
      col_types = list()
    )[[1]],
    "double"
  )
})

test_that("times are guessed even without AM / PM", {
  expect_s3_class(guess_type("01:02:03"), "collector_time")
  expect_s3_class(guess_type("01:02:03 AM"), "collector_time")
  expect_s3_class(guess_type("01:02:03 PM"), "collector_time")
})

test_that("subsetting works with both double and integer indexes", {
  x <- vroom(I("X1\n2020-01-01 01:01:01"), delim = ",", col_types = "T")
  dt <- as.POSIXct("2020-01-01 01:01:01", tz = "UTC")
  na_dt <- .POSIXct(NA_real_, tz = "UTC")
  expect_equal(x$X1[1L], dt)
  expect_equal(x$X1[1], dt)
  expect_equal(x$X1[NA_integer_], na_dt)
  expect_equal(x$X1[NA_real_], na_dt)
})

test_that("malformed date / datetime formats cause R errors", {
  expect_snapshot(
    error = TRUE,
    vroom(
      I("x\n6/28/2016"),
      delim = ",",
      col_types = list(x = col_date("%m/%/%Y")),
      altrep = FALSE
    )
  )
  expect_snapshot(
    error = TRUE,
    vroom(
      I("x\n6/28/2016"),
      delim = ",",
      col_types = list(x = col_datetime("%m/%/%Y")),
      altrep = FALSE
    )
  )
})

test_that("single digit dates and hours are parsed correctly (https://github.com/tidyverse/readr/issues/1276)", {
  test_vroom(
    I("4/9/2021 2:18:25 PM"),
    col_types = list(col_datetime("%m/%d/%Y %H:%M:%S %p")),
    col_names = "X",
    delim = ",",
    equals = tibble::tibble(X = as.POSIXct("2021-04-09 14:18:25", tz = "UTC"))
  )
})

test_that("durations", {
  parse_time <- function(x, format, ...) {
    vroom(
      I(x),
      delim = ",",
      col_names = FALSE,
      col_types = list(col_time(format = format)),
      altrep = FALSE
    )[[1]]
  }
  expect_warning(parse_time("25:00:00", format = "%H:%M:%S"))
  expect_equal(
    parse_time("25:00:00", format = "%h:%M:%S"),
    hms::hms(hours = 25)
  )
  expect_equal(
    parse_time("1000000000:00:00", format = "%h:%M:%S"),
    hms::hms(hours = 1e9)
  )
  expect_equal(
    parse_time("-1:23:45", format = "%h:%M:%S"),
    hms::as_hms(-hms::hms(45, 23, 1))
  )
  expect_equal(
    parse_time("-1:23:45.67", format = "%h:%M:%OS"),
    hms::as_hms(-hms::hms(45.67, 23, 1))
  )
})

test_vroom <- function(content, delim = ",", col_types = list(), ..., equals) {
  if (any(grepl("\n", content))) {
    content <- I(content)
  }
  suppressWarnings({
    # with altrep
    withr::with_envvar(
      c("VROOM_USE_ALTREP_CHR" = "true", "VROOM_USE_ALTREP_NUMERICS" = "true"),
      {
        expect_equal(
          vroom(content, delim = delim, col_types = col_types, ...),
          equals
        )
      }
    )

    # without altrep
    withr::with_envvar(
      c(
        "VROOM_USE_ALTREP_CHR" = "false",
        "VROOM_USE_ALTREP_NUMERICS" = "false"
      ),
      {
        expect_equal(
          vroom(content, delim = delim, col_types = col_types, ...),
          equals
        )
      }
    )

    if (!file.exists(content)) {
      tf <- tempfile()
      on.exit(unlink(tf))
      out_con <- file(tf, "wb", encoding = "UTF-8")
      writeBin(charToRaw(content), out_con)
      close(out_con)

      con <- file(tf, "rb")
    } else {
      con <- file(content, "rb")
    }
    on.exit(close(con), add = TRUE)

    res <- vroom(con, delim = delim, col_types = col_types, ...)

    expect_equal(res, equals)
    for (i in seq_along(res)) {
      force_materialization(res[[i]])
    }
    expect_equal(res, equals)
  })

  invisible(res)
}

test_parse_number <- function(x, expected, ...) {
  test_vroom(
    paste0(paste0(x, collapse = "\n"), "\n"),
    delim = "\t",
    col_names = FALSE,
    col_types = "n",
    ...,
    equals = tibble::tibble(X1 = expected)
  )
}

test_parse_datetime <- function(x, expected, format = "", ...) {
  test_vroom(
    paste0(paste0(x, collapse = "\n"), "\n"),
    delim = "\t",
    col_names = FALSE,
    col_types = cols(X1 = col_datetime(format = format)),
    ...,
    equals = tibble::tibble(X1 = expected)
  )
}

test_parse_date <- function(x, expected, format = "", ...) {
  test_vroom(
    paste0(paste0(x, collapse = "\n"), "\n"),
    delim = "\t",
    col_names = FALSE,
    col_types = cols(X1 = col_date(format = format)),
    ...,
    equals = tibble::tibble(X1 = expected)
  )
}

test_parse_time <- function(x, expected, format = "", ...) {
  test_vroom(
    paste0(paste0(x, collapse = "\n"), "\n"),
    delim = "\t",
    col_names = FALSE,
    col_types = cols(X1 = col_time(format = format)),
    ...,
    equals = tibble::tibble(X1 = expected)
  )
}

expect_error_free <- function(object, ...) {
  expect_error(object, regexp = NA)
}

on_github_actions <- function() {
  identical(Sys.getenv("GITHUB_ACTIONS"), "true")
}

test_that("problems returns a detailed warning message", {
  expect_snapshot(vroom(I("a,b,c\nx,y,z,,"), altrep = FALSE, col_types = "ccc"))
})

test_that("problems with data parsing works for single files", {
  expect_warning(
    x <- vroom(I("x,y\n1,2\n1,1.x\n"), col_types = "dd", altrep = FALSE),
    class = "vroom_parse_issue"
  )
  probs <- problems(x)

  expect_equal(probs$row, 3)
  expect_equal(probs$col, 2)
  expect_equal(probs$expected, "a double")
  expect_equal(probs$actual, "1.x")
})

test_that("problems works for multiple files", {
  out1 <- file.path(tempdir(), "out1.txt")
  out2 <- file.path(tempdir(), "out2.txt")
  on.exit(unlink(c(out1, out2)))

  writeLines("x,y\n1,2\n1,1.x\n2,2", out1)
  writeLines("x,y\n3.x,4\n1,2\n2,2", out2)

  expect_warning(
    x <- vroom(c(out1, out2), delim = ",", col_types = "dd", altrep = F),
    class = "vroom_parse_issue"
  )
  probs <- problems(x)

  expect_equal(probs$row, c(3, 2))
  expect_equal(probs$col, c(2, 1))
  expect_equal(probs$expected, c("a double", "a double"))
  expect_equal(probs$actual, c("1.x", "3.x"))
  expect_equal(basename(probs$file), basename(c(out1, out2)))
})

test_that("problems with number of columns works for single files", {
  expect_warning(
    probs3 <- problems(vroom(
      I("x,y,z\n1,2\n"),
      col_names = TRUE,
      col_types = "ddd",
      altrep = FALSE
    )),
    class = "vroom_parse_issue"
  )
  expect_equal(probs3$row, 2)
  expect_equal(probs3$col, 2)
  expect_equal(probs3$expected, "3 columns")
  expect_equal(probs3$actual, "2 columns")

  expect_warning(
    probs3 <- problems(vroom(
      I("x,y,z\n1,2\n"),
      col_names = FALSE,
      col_types = "ddd",
      altrep = FALSE
    )),
    class = "vroom_parse_issue"
  )
  expect_equal(probs3$row[[4]], 2)
  expect_equal(probs3$col[[4]], 2)
  expect_equal(probs3$expected[[4]], "3 columns")
  expect_equal(probs3$actual[[4]], "2 columns")

  expect_warning(
    probs4 <- problems(vroom(
      I("x,y\n1,2,3,4\n"),
      col_names = TRUE,
      col_types = "dd",
      altrep = FALSE
    )),
    class = "vroom_parse_issue"
  )
  expect_equal(probs4$row[[2]], 2)
  expect_equal(probs4$col[[2]], 4)
  expect_equal(probs4$expected[[2]], "2 columns")
  expect_equal(probs4$actual[[2]], "4 columns")

  expect_warning(
    probs2 <- problems(vroom(
      I("x,y\n1,2,3,4\n"),
      col_names = FALSE,
      col_types = "dd",
      altrep = FALSE
    )),
    class = "vroom_parse_issue"
  )
  expect_equal(probs2$row[[4]], 2)
  expect_equal(probs2$col[[4]], 4)
  expect_equal(probs2$expected[[4]], "2 columns")
  expect_equal(probs2$actual[[4]], "4 columns")
})

test_that("parsing problems are shown for all datatypes", {
  types <- list(
    "an integer" = col_integer(),
    "a big integer" = col_big_integer(),
    "a double" = col_double(),
    "a number" = col_number(),
    "value in level set" = col_factor(levels = "foo"),
    "date in ISO8601" = col_date(),
    "date in ISO8601" = col_datetime(),
    "time in ISO8601" = col_time()
  )

  for (i in seq_along(types)) {
    type <- types[[i]]
    expected <- names(types)[[i]]

    res <- vroom(
      I("x\nxyz\n"),
      delim = ",",
      col_types = list(type),
      altrep = TRUE
    )

    # This calls the type_Elt function
    expect_warning(res[[1]][[1]], class = "vroom_parse_issue")
    expect_equal(problems(res)$expected, expected)

    res <- vroom(
      I("x\nxyz\n"),
      delim = ",",
      col_types = list(type),
      altrep = TRUE
    )

    # This calls the read_type function
    expect_warning(
      vroom_materialize(res, replace = FALSE),
      class = "vroom_parse_issue"
    )
    expect_equal(problems(res)$expected, expected)
  }

  expect_warning(
    res <- vroom(I("x\nxyz\n"), delim = ",", col_types = list(col_logical())),
    class = "vroom_parse_issue"
  )
})

test_that("problems that are generated more than once are not duplicated", {
  res <- vroom(I("x\n1\n2\n3\n4\n5\na"), col_types = "i", delim = ",")

  # generate first problem
  expect_warning(res[[1]][[6]], class = "vroom_parse_issue")

  # generate the same problem again
  res[[1]][[6]]

  probs <- problems(res)
  expect_equal(probs$row, 7)
  expect_equal(probs$col, 1)
  expect_equal(probs$expected, "an integer")
})

test_that("problems return the proper row number", {
  expect_warning(
    x <- vroom(I("a,b,c\nx,y,z,,"), altrep = FALSE, col_types = "ccc"),
    class = "vroom_parse_issue"
  )
  expect_equal(problems(x)$row, 2)

  expect_warning(
    y <- vroom(I("a,b,c\nx,y,z\nx,y,z,,"), altrep = FALSE, col_types = "ccc"),
    class = "vroom_parse_issue"
  )
  expect_equal(problems(y)$row, 3)

  expect_warning(
    z <- vroom(
      I("a,b,c\nx,y,z,,\nx,y,z,,\n"),
      altrep = FALSE,
      col_types = "ccc"
    ),
    class = "vroom_parse_issue"
  )
  expect_equal(problems(z)$row, c(2, 3))
})

# https://github.com/tidyverse/vroom/pull/441#discussion_r883611090
test_that("can promote vroom parse warning to error", {
  make_warning <- function() {
    x <- vroom(
      I("a\nx\n"),
      delim = ",",
      col_types = "d",
      altrep = TRUE
    )

    # Trigger vroom parse warning while inside R's internal C code for `[` and ensure it doesn't crash R.
    # `[` -> R's C function `do_subset()` -> ALTREP calls `vroom::real_Elt()` -> `vroom::warn_for_errors()`
    # To avoid calling `cpp11::unwind_protect()` (which throws on longjmp, i.e. on `abort()`) while inside
    # R's internal C code (which doesn't catch C++ exceptions), `vroom::warn_for_errors()` warns
    # with cli called from base R's machinery, rather than from `cpp11::package()`
    # https://github.com/r-lib/cpp11/issues/274
    # https://github.com/tidyverse/vroom/pull/441#discussion_r883611090
    x$a[1]
  }

  # This fails hard if we unwind protect the warning (aborts RStudio)
  # - Try to throw error after catching the warning
  expect_snapshot(error = TRUE, {
    withCallingHandlers(
      expr = make_warning(),
      vroom_parse_issue = function(cnd) {
        abort("oh no")
      }
    )
  })
})

test_that("emits an error message if provided incorrect input", {
  # user provides something other than a data frame
  a_vector <- c(1, 2, 3)
  expect_snapshot(problems(a_vector), error = TRUE)

  # user provides a data frame from an incorrect source
  a_tibble <- tibble::tibble(x = c(1), y = c(2))
  expect_snapshot(problems(a_tibble), error = TRUE)
})

# https://github.com/tidyverse/vroom/issues/535
test_that("problems are correct even if print is first encounter", {
  foo <- vroom(
    I("a\n1\nz\n3\nF\n5"),
    delim = ",",
    col_types = "d",
    show_col_types = FALSE
  )

  expect_output(expect_warning(print(foo), class = "vroom_parse_issue"))

  probs <- problems(foo)
  expect_equal(probs$row, c(3, 5))
  expect_equal(probs$actual, c("z", "F"))

  foo <- vroom(
    I("1\nz\n3\nF\n5"),
    delim = ",",
    col_names = FALSE,
    col_types = "d",
    show_col_types = FALSE
  )

  expect_output(expect_warning(print(foo), class = "vroom_parse_issue"))

  probs <- problems(foo)
  expect_equal(probs$row, c(2, 4))
  expect_equal(probs$actual, c("z", "F"))
})

({
  library(vroom)
  library(dplyr)
})
x <- vroom(
  file,
  trim_ws = FALSE,
  quote = "",
  escape_double = FALSE,
  na = character(),
  altrep = FALSE
)
print(x)
a <- head(x)
b <- tail(x)
c <- sample_n(x, 100)
d <- filter(x, X1 == "helpless_sheep")
e <- group_by(x, X1) %>% summarise(avg_nchar = mean(nchar(X2)))

# Generated by cpp11: do not edit by hand

force_materialization <- function(x) {
  invisible(.Call(`_vroom_force_materialization`, x))
}

vroom_materialize <- function(x, replace) {
  .Call(`_vroom_vroom_materialize`, x, replace)
}

vroom_convert <- function(x) {
  .Call(`_vroom_vroom_convert`, x)
}

vroom_str_ <- function(x) {
  .Call(`_vroom_vroom_str_`, x)
}

gen_character_ <- function(n, min, max, values, seed, seed2) {
  .Call(`_vroom_gen_character_`, n, min, max, values, seed, seed2)
}

guess_type_ <- function(input, na, locale, guess_integer) {
  .Call(`_vroom_guess_type_`, input, na, locale, guess_integer)
}

convert_connection <- function(in_con, out_con, from, to) {
  .Call(`_vroom_convert_connection`, in_con, out_con, from, to)
}

vroom_ <- function(inputs, delim, quote, trim_ws, escape_double, escape_backslash, comment, skip_empty_rows, skip, n_max, progress, col_names, col_types, col_select, name_repair, id, na, locale, guess_max, num_threads, altrep) {
  .Call(`_vroom_vroom_`, inputs, delim, quote, trim_ws, escape_double, escape_backslash, comment, skip_empty_rows, skip, n_max, progress, col_names, col_types, col_select, name_repair, id, na, locale, guess_max, num_threads, altrep)
}

has_trailing_newline <- function(filename) {
  .Call(`_vroom_has_trailing_newline`, filename)
}

vroom_rle <- function(input) {
  .Call(`_vroom_vroom_rle`, input)
}

utctime_ <- function(year, month, day, hour, min, sec, psec) {
  .Call(`_vroom_utctime_`, year, month, day, hour, min, sec, psec)
}

vroom_errors_ <- function(errors) {
  .Call(`_vroom_vroom_errors_`, errors)
}

vroom_fwf_ <- function(inputs, col_starts, col_ends, trim_ws, col_names, col_types, col_select, name_repair, skip, comment, skip_empty_rows, n_max, id, na, locale, guess_max, num_threads, altrep, progress) {
  .Call(`_vroom_vroom_fwf_`, inputs, col_starts, col_ends, trim_ws, col_names, col_types, col_select, name_repair, skip, comment, skip_empty_rows, n_max, id, na, locale, guess_max, num_threads, altrep, progress)
}

whitespace_columns_ <- function(filename, skip, n, comment) {
  .Call(`_vroom_whitespace_columns_`, filename, skip, n, comment)
}

vroom_write_ <- function(input, filename, delim, eol, na_str, col_names, append, options, num_threads, progress, buf_lines) {
  invisible(.Call(`_vroom_vroom_write_`, input, filename, delim, eol, na_str, col_names, append, options, num_threads, progress, buf_lines))
}

vroom_write_connection_ <- function(input, con, delim, eol, na_str, col_names, options, num_threads, progress, buf_lines, is_stdout, append) {
  invisible(.Call(`_vroom_vroom_write_connection_`, input, con, delim, eol, na_str, col_names, options, num_threads, progress, buf_lines, is_stdout, append))
}

vroom_format_ <- function(input, delim, eol, na_str, col_names, append, options, num_threads, progress, buf_lines) {
  .Call(`_vroom_vroom_format_`, input, delim, eol, na_str, col_names, append, options, num_threads, progress, buf_lines)
}

collector <- function(type, ...) {
  structure(list(...), class = c(paste0("collector_", type), "collector"))
}

is.collector <- function(x) inherits(x, "collector")

# Conditionally exported in zzz.R
#' @noRd
# @export
print.collector <- function(x, ...) {
  cat("<", class(x)[1], ">\n", sep = "")
}

test_that("TRUE and FALSE parsed", {
  test_vroom(
    "TRUE\nFALSE\n",
    col_names = FALSE,
    equals = tibble::tibble(X1 = c(TRUE, FALSE))
  )
})

test_that("true and false parsed", {
  test_vroom(
    "true\nfalse\n",
    col_names = FALSE,
    equals = tibble::tibble(X1 = c(TRUE, FALSE))
  )
})

test_that("True and False parsed", {
  test_vroom(
    "True\nFalse\n",
    col_names = FALSE,
    equals = tibble::tibble(X1 = c(TRUE, FALSE))
  )
})

test_that("T and F parsed", {
  test_vroom(
    "T\nF\n",
    col_names = FALSE,
    equals = tibble::tibble(X1 = c(TRUE, FALSE))
  )
})

test_that("t and f parsed", {
  test_vroom(
    "t\nf\n",
    col_names = FALSE,
    equals = tibble::tibble(X1 = c(TRUE, FALSE))
  )
})

test_that("1 and 0 parsed", {
  # 1 and 0 are never guessed as logical, but they can be parsed as such if you
  # explicitly set the column type.
  test_vroom(
    "1\n0\n",
    col_types = "l",
    col_names = FALSE,
    equals = tibble::tibble(X1 = c(TRUE, FALSE))
  )
})

test_that("NA can be a logical value", {
  test_vroom(
    "1\n0\n",
    col_types = "l",
    col_names = FALSE,
    na = "1",
    equals = tibble::tibble(X1 = c(NA, FALSE))
  )
})

test_that("locale() creates a valid locale object", {
  loc <- locale()
  expect_s3_class(loc, "locale")
  expect_equal(loc$decimal_mark, ".")
  expect_equal(loc$grouping_mark, ",")
  expect_equal(loc$tz, "UTC")
  expect_equal(loc$encoding, "UTF-8")
})

test_that("locale() errors when decimal_mark equals grouping_mark", {
  expect_snapshot(
    locale(decimal_mark = ".", grouping_mark = "."),
    error = TRUE
  )
})

test_that("locale() sets complementary grouping_mark when only decimal_mark is specified", {
  loc1 <- locale(decimal_mark = ",")
  expect_equal(loc1$decimal_mark, ",")
  expect_equal(loc1$grouping_mark, ".")

  loc2 <- locale(decimal_mark = ".")
  expect_equal(loc2$decimal_mark, ".")
  expect_equal(loc2$grouping_mark, ",")
})

test_that("locale() sets complementary decimal_mark when only grouping_mark is specified", {
  loc1 <- locale(grouping_mark = ".")
  expect_equal(loc1$decimal_mark, ",")
  expect_equal(loc1$grouping_mark, ".")

  loc2 <- locale(grouping_mark = ",")
  expect_equal(loc2$decimal_mark, ".")
  expect_equal(loc2$grouping_mark, ",")
})

test_that("locale() accepts language codes for date_names", {
  fr <- locale("fr")
  expect_equal(fr$date_names$mon[[1]], "janvier")

  es <- locale("es")
  expect_equal(es$date_names$mon[[1]], "enero")
})

test_that("locale() errors for unrecognized language code", {
  expect_snapshot(
    locale(date_names = "fake"),
    error = TRUE
  )
})

test_that("locale() warns for unrecognized encoding", {
  expect_snapshot(
    locale(encoding = "FAKE-ENCODING-9999")
  )
})

test_that("locale() validates timezone", {
  expect_no_error(locale(tz = "UTC"))
  expect_no_error(locale(tz = "America/New_York"))

  expect_snapshot(
    locale(tz = "Invalid/Timezone"),
    error = TRUE
  )
})

test_that("locale() can consult and validate system time zone", {
  expect_no_error(locale(tz = ""))

  withr::local_timezone("foo")
  expect_snapshot(
    locale(tz = ""),
    error = TRUE
  )
})

test_that("default_locale() returns a locale", {
  loc <- default_locale()
  expect_s3_class(loc, "locale")
})

as.integer64 <- bit64::as.integer64

test_that("integers are returned correctly", {
  # empty fields are returned as NAs
  test_vroom(
    "foo,bar,baz\n1,,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64(NA),
      baz = as.integer64(3)
    )
  )

  # numbers which are not integers are returned as NAs
  test_vroom(
    "foo,bar,baz\n1,1.5,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64(NA),
      baz = as.integer64(3)
    )
  )

  # fields with non-digits are returned as NAs
  test_vroom(
    "foo,bar,baz\n1,32xyz,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64(NA),
      baz = as.integer64(3)
    )
  )

  # 2^31 - 1 is the maximum representable integer with 32 bit ints
  test_vroom(
    "foo,bar,baz\n1,2147483647,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64("2147483647"),
      baz = as.integer64(3)
    )
  )

  # But 2^31 should also work
  test_vroom(
    "foo,bar,baz\n1,2147483648,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64("2147483648"),
      baz = as.integer64(3)
    )
  )

  # As well as -2^31
  test_vroom(
    "foo,bar,baz\n1,9223372036854775807,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64("9223372036854775807"),
      baz = as.integer64(3)
    )
  )

  # But 2^63 should be NA
  test_vroom(
    "foo,bar,baz\n1,9223372036854775808,3\n",
    col_types = list(.default = "I"),
    delim = ",",
    equals = tibble::tibble(
      foo = as.integer64(1),
      bar = as.integer64(NA),
      baz = as.integer64(3)
    )
  )
})

test_that("NA can be a big int value", {
  test_vroom(
    I("x\n1\n2\n"),
    delim = ",",
    col_types = "I",
    na = "1",
    equals = tibble::tibble(x = as.integer64(c(NA_integer_, 2L)))
  )
})

test_that("integers are returned correctly", {
  # empty fields are returned as NAs
  test_vroom(
    "foo,bar,baz\n1,,3\n",
    col_types = list(.default = "i"),
    delim = ",",
    equals = tibble::tibble(foo = 1L, bar = NA_integer_, baz = 3L)
  )

  # numbers which are not integers are returned as NAs
  test_vroom(
    "foo,bar,baz\n1,1.5,3\n",
    col_types = list(.default = "i"),
    delim = ",",
    equals = tibble::tibble(foo = 1L, bar = NA_integer_, baz = 3L)
  )

  # fields with non-digits are returned as NAs
  test_vroom(
    "foo,bar,baz\n1,32xyz,3\n",
    col_types = list(.default = "i"),
    delim = ",",
    equals = tibble::tibble(foo = 1L, bar = NA_integer_, baz = 3L)
  )

  # 2^31 - 1 is the maximum representable integer with 32 bit ints
  test_vroom(
    "foo,bar,baz\n1,2147483647,3\n",
    col_types = list(.default = "i"),
    delim = ",",
    equals = tibble::tibble(foo = 1L, bar = 2147483647L, baz = 3L)
  )

  test_vroom(
    "foo,bar,baz\n1,2147483648,3\n",
    col_types = list(.default = "i"),
    delim = ",",
    equals = tibble::tibble(foo = 1L, bar = NA_integer_, baz = 3L)
  )
})

test_that("NA can be a int value", {
  test_vroom(
    I("x\n1\n2\n"),
    delim = ",",
    col_types = "i",
    na = "1",
    equals = tibble::tibble(x = c(NA_integer_, 2L))
  )
})

test_that("multi-byte reading works with unicode delimiters and UTF-8 encoding", {
  test_vroom(
    test_path("multi-byte-ascii.txt"),
    delim = "||",
    equals = tibble::tibble(
      id = 1:3,
      name = c("ed", "leigh", "nathan"),
      age = c(36, NA, 14)
    )
  )
})

test_that("multi-byte reading works with unicode delimiters and UTF-8 encoding", {
  skip_on_os("solaris")

  test_vroom(
    test_path("multi-byte-unicode.txt"),
    delim = "\U2764",
    equals = tibble::tibble(
      id = 1:3,
      name = c("ed", "leigh", "nathan"),
      age = c(36, NA, 14)
    )
  )
})

---
title: "Get started with vroom"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Get started with vroom}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r}
#| label: setup
#| include: false
knitr::opts_knit$set(root.dir = tempdir())
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
options(tibble.print_min = 3)
```

The vroom package contains one main function `vroom()` which is used to read all types of delimited files. A delimited file is any file in which the data is separated (delimited) by one or more characters.

The most common type of delimited files are CSV (Comma Separated Values) or TSV (Tab Separated Values) files, typically these files have a `.csv` and `.tsv` suffix respectively.

```{r}
library(vroom)
```

This vignette covers the following topics:

- The basics of reading files, including
  - single files
  - multiple files
  - compressed files
  - remote files
- Skipping particular columns.
- Specifying column types, for additional safety and when the automatic guessing
  fails.
- Writing regular and compressed files

## Reading files
To read a CSV, or other type of delimited file with vroom pass the file to `vroom()`.
The delimiter will be automatically guessed if it is a common delimiter; e.g. ("," "\t" " " "|" ":" ";").
If the guessing fails or you are using a less common delimiter specify it with the `delim` parameter. (e.g. `delim = ","`).

We have included an example CSV file in the vroom package for use in examples and tests.
Access it with `vroom_example("mtcars.csv")`

```{r}
# See where the example file is stored on your machine
file <- vroom_example("mtcars.csv")
file

# Read the file, by default vroom will guess the delimiter automatically.
vroom(file)

# You can also specify it explicitly, which is (slightly) faster, and safer if
# you know how the file is delimited.
vroom(file, delim = ",")
```

## Reading multiple files

If you are reading a set of files which all have the same columns (as in, names and types), you can pass the filenames directly to `vroom()` and it will combine them into one result.
vroom's example datasets include several files named like `mtcars-i.csv`.
These files contain subsets of the `mtcars` data, for cars with different numbers of cylinders.
First, we get a character vector of these filepaths.

```{r}
ve <- grep("mtcars-[0-9].csv", vroom_examples(), value = TRUE)
files <- sapply(ve, vroom_example)
files
```

Now we can efficiently read them into one table by passing the filenames directly to vroom.

```{r}
vroom(files)
```

Often the filename or directory where the files are stored contains information.
The `id` parameter can be used to add an extra column to the result with the full path to each file.
(in this case we name the column `path`).

```{r}
vroom(files, id = "path")
```

## Reading compressed files

vroom supports reading zip, gz, bz2 and xz compressed files automatically, just pass the filename of the compressed file to vroom.

```{r}
file <- vroom_example("mtcars.csv.gz")

vroom(file)
```

`vroom()` decompresses, indexes and writes the decompressed data to a file in the temp directory in a single stream.
The temporary file is used to lazily look up the values and will be automatically cleaned up when all values in the object have been fully read, the object is removed, or the R session ends.

### Reading individual files from a multi-file zip archive

If you are reading a zip file that contains multiple files with the same format, you can read a subset of the files at once like so:

```{r}
zip_file <- vroom_example("mtcars-multi-cyl.zip")
filenames <- unzip(zip_file, list = TRUE)$Name
filenames

# imagine we only want to read 2 of the 3 files
vroom(purrr::map(filenames[c(1, 3)], \(x) unz(zip_file, x)))
```

## Reading remote files

vroom can read files directly from the internet as well by passing the URL of the file to vroom.

```{r}
#| eval: !expr as.logical(Sys.getenv("NOT_CRAN", "false"))
file <- "https://raw.githubusercontent.com/tidyverse/vroom/main/inst/extdata/mtcars.csv"
vroom(file)
```

It can even read compressed files from the internet.

```{r}
#| eval: !expr as.logical(Sys.getenv("NOT_CRAN", "false"))
file <- "https://raw.githubusercontent.com/tidyverse/vroom/main/inst/extdata/mtcars.csv.gz"
vroom(file)
```

## Column selection

vroom provides the same interface for column selection and renaming as [dplyr::select()](https://dplyr.tidyverse.org/reference/select.html).
This provides very efficient, flexible and readable selections. For example you can select by:

- A character vector of column names
```{r}
file <- vroom_example("mtcars.csv.gz")

vroom(file, col_select = c(model, cyl, gear))
```
- A numeric vector of column indexes, e.g. `c(1, 2, 5)`
```{r}
vroom(file, col_select = c(1, 3, 11))
```
- Using the selection helpers such as `starts_with()` and `ends_with()`
```{r}
vroom(file, col_select = starts_with("d"))
```
- You can also rename columns
```{r}
vroom(file, col_select = c(car = model, everything()))
```

## Reading fixed width files

 A fixed width file can be a very compact representation of numeric data.
 Unfortunately, it's also often painful to read because you need to describe the length of every field.
 vroom aims to make it as easy as possible by providing a number of different ways to describe the field structure.
 Use `vroom_fwf()` in conjunction with one of the following helper functions to read the file.

```{r}
fwf_sample <- vroom_example("fwf-sample.txt")
cat(readLines(fwf_sample))
```

- `fwf_empty()` - Guess based on the position of empty columns.
```{r}
vroom_fwf(fwf_sample, fwf_empty(fwf_sample, col_names = c("first", "last", "state", "ssn")))
```

- `fwf_widths()` - Use user provided set of field widths.
```{r}
vroom_fwf(fwf_sample, fwf_widths(c(20, 10, 12), c("name", "state", "ssn")))
```

- `fwf_positions()` - Use user provided sets of start and end positions.
```{r}
vroom_fwf(fwf_sample, fwf_positions(c(1, 30), c(20, 42), c("name", "ssn")))
```

- `fwf_cols()` - Use user provided named widths.
```{r}
vroom_fwf(fwf_sample, fwf_cols(name = 20, state = 10, ssn = 12))
```

- `fwf_cols()` - Use user provided named pairs of positions.
```{r}
vroom_fwf(fwf_sample, fwf_cols(name = c(1, 20), ssn = c(30, 42)))
```

## Column types

vroom guesses the data types of columns as they are read, however sometimes the guessing fails and it is necessary to explicitly set the type of one or more columns.

The available specifications are: (with single letter abbreviations in quotes)

* `col_logical()` 'l', containing only `T`, `F`, `TRUE`, `FALSE`, `1` or `0`.
* `col_integer()` 'i', integer values.
* `col_big_integer()` 'I', Big integer values. (64bit integers)
* `col_double()` 'd', floating point values.
* `col_number()` 'n', numbers containing the `grouping_mark`
* `col_date(format = "")` 'D': with the locale's `date_format`.
* `col_time(format = "")` 't': with the locale's `time_format`.
* `col_datetime(format = "")` 'T': ISO8601 date times.
* `col_factor(levels, ordered)` 'f', a fixed set of values.
* `col_character()` 'c', everything else.
* `col_skip()` '_, -', don't import this column.
* `col_guess()` '?', parse using the "best" type based on the input.

You can tell vroom what columns to use with the `col_types()` argument in a number of ways.

If you only need to override a single column the most concise way is to use a named vector.

```{r}
# read the 'hp' columns as an integer
vroom(vroom_example("mtcars.csv"), col_types = c(hp = "i"))

# also skip reading the 'cyl' column
vroom(vroom_example("mtcars.csv"), col_types = c(hp = "i", cyl = "_"))

# also read the gears as a factor
vroom(vroom_example("mtcars.csv"), col_types = c(hp = "i", cyl = "_", gear = "f"))
```

You can read all the columns with the same type, by using the `.default`
argument. For example reading everything as a character.

```{r}
vroom(vroom_example("mtcars.csv"), col_types = c(.default = "c"))
```

However you can also use the `col_*()` functions in a list.

```{r}
vroom(
  vroom_example("mtcars.csv"),
  col_types = list(hp = col_integer(), cyl = col_skip(), gear = col_factor())
)
```

This is most useful when a column type needs additional information, such as for categorical data when you know all of the levels of a factor.

```{r}
vroom(
  vroom_example("mtcars.csv"),
  col_types = list(gear = col_factor(levels = c(gear = c("3", "4", "5"))))
)
```

## Name repair

Often the names of columns in the original dataset are not ideal to work with.
`vroom()` uses the same `.name_repair` argument as tibble, so you can use one of the default name repair strategies or provide a custom function.
A great approach is to use the [`janitor::make_clean_names()`](https://sfirke.github.io/janitor/reference/make_clean_names.html) function as the input.
This will automatically clean the names to use whatever case you specify, here I am setting it to use `ALLCAPS` names.

```{r}
#| eval: false
vroom(
  vroom_example("mtcars.csv"),
  .name_repair = \(x) janitor::make_clean_names(x, case = "all_caps")
)
```


## Writing delimited files

Use `vroom_write()` to write delimited files, the default delimiter is tab, to write TSV files. Writing to TSV by default has the following benefits:
  - Avoids the issue of whether to use `;` (common in Europe) or `,` (common in the US)
  - Unlikely to require quoting in fields, as very few fields contain tabs
  - More easily and efficiently ingested by Unix command line tools such as `cut`, `perl` and `awk`.

```{r}
vroom_write(mtcars, "mtcars.tsv")
```

```{r}
#| include: false
unlink("mtcars.tsv")
```

### Writing CSV delimited files

However you can also use `delim = ','` to write CSV files, which are common as inputs to GUI spreadsheet tools like Excel or Google Sheets.

```{r}
vroom_write(mtcars, "mtcars.csv", delim = ",")
```

```{r}
#| include: false
unlink("mtcars.csv")
```

### Writing compressed files

For gzip, bzip2 and xz compression the outputs will be automatically compressed if the filename ends in `.gz`, `.bz2` or `.xz`.

```{r}
vroom_write(mtcars, "mtcars.tsv.gz")

vroom_write(mtcars, "mtcars.tsv.bz2")

vroom_write(mtcars, "mtcars.tsv.xz")
```

```{r}
#| include: false
unlink(c("mtcars.tsv.gz", "mtcars.tsv.bz2", "mtcars.tsv.xz"))
```

It is also possible to use other compressors by using `pipe()` with `vroom_write()` to create a pipe connection to command line utilities, such as

- [pigz](https://zlib.net/pigz/), a parallel gzip implementation
- lbzip2, a parallel bzip2 implementation
- [pixz](https://github.com/vasi/pixz), a parallel xz implementation
- [Zstandard](https://facebook.github.io/zstd/), a modern real-time compression algorithm.

The parallel compression versions can be considerably faster for large output files and generally `vroom_write()` is fast enough that the compression speed becomes the bottleneck when writing.

```{r}
#| eval: !expr nzchar(Sys.which("pigz"))
vroom_write(mtcars, pipe("pigz > mtcars.tsv.gz"))
```

```{r}
#| include: false
unlink("mtcars.tsv.gz")
```

### Reading and writing from standard input and output

vroom supports reading and writing to the C-level `stdin` and `stdout` of the R process by using `stdin()` and `stdout()`. E.g.
from a shell prompt you can pipe to and from vroom directly.

```shell
cat inst/extdata/mtcars.csv | Rscript -e 'vroom::vroom(stdin())'

Rscript -e 'vroom::vroom_write(iris, stdout())' | head
```

Note this interpretation of `stdin()` and `stdout()` differs from that used elsewhere by R, however we believe it better matches most user's expectations for this use case.

## Further reading

- `vignette("benchmarks")` discusses the performance of vroom, how it compares to alternatives and how it achieves its results.
- [📽 vroom: Because Life is too short to read slow](https://www.youtube.com/watch?v=RA9AjqZXxMU&t=10s) - Presentation of vroom at UseR!2019 ([slides](https://speakerdeck.com/jimhester/vroom))
- [📹 vroom: Read and write rectangular data quickly](https://www.youtube.com/watch?v=ZP_y5eaAc60) - a video tour of the vroom features.

---
title: "Vroom Benchmarks"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Vroom Benchmarks}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r}
#| include: false
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

library(ggplot2)
library(forcats)
library(dplyr)
library(tidyr)
library(fs)

pretty_sec <- function(x) {
  x[!is.na(x)] <- prettyunits::pretty_sec(x[!is.na(x)])
  x
}

pretty_lgl <- function(x) {
  case_when(
    x == TRUE ~ "TRUE",
    x == FALSE ~ "FALSE",
    TRUE ~ ""
  )
}

read_benchmark <- function(file, desc) {
  vroom::vroom(file, col_types = c("ccccddddd")) |>
    filter(op != "setup") |>
    mutate(
      altrep = case_when(
        grepl("^vroom_no_altrep", reading_package) ~ FALSE,
        grepl("^vroom", reading_package) ~ TRUE,
        TRUE ~ NA
      ),
      reading_package = case_when(
        grepl("^vroom", reading_package) ~ "vroom",
        TRUE ~ reading_package
      ),
    label = fct_reorder(
      glue::glue("{reading_package}{altrep}\n{manip_package}",
        altrep = ifelse(is.na(altrep), "", glue::glue("(altrep = {altrep})"))
      ),
      case_when(type == "real" ~ time, TRUE ~ 0),
      sum),
    op = factor(op, desc)
  )
}

generate_subtitle <- function(data) {
  rows <- scales::comma(data$rows[[1]])
  cols <- scales::comma(data$cols[[1]])
  size <- fs_bytes(data$size[[1]])
  glue::glue("{rows} x {cols} - {size}B")
}

plot_benchmark <- function(data, title) {

  subtitle <- generate_subtitle(data)
  data <- data |>
    filter(reading_package != "read.delim", type == "real")

  p1 <- data |>
    ggplot() +
    geom_bar(aes(x = label, y = time, fill = op, group = label), stat = "identity") +
    scale_fill_brewer(type = "qual", palette = "Set2") +
    scale_y_continuous(labels = scales::number_format(suffix = "s")) +
    coord_flip() +
    labs(title = title, subtitle = subtitle, x = NULL, y = NULL, fill = NULL) +
    theme(legend.position = "bottom")

  p2 <- data |>
    group_by(label) |>
    summarise(max_memory = max(max_memory)) |>
    ggplot() +
    geom_bar(aes(x = label, y = max_memory / (1024 * 1024)), stat = "identity") +
    scale_y_continuous(labels = scales::number_format(suffix = "Mb")) +
    coord_flip() +
    labs(title = "Maximum memory usage", x = NULL, y = NULL) +
    theme(axis.text.y = element_blank(), axis.ticks.y = element_blank())

  library(patchwork)
  p1 + p2 + plot_layout(widths = c(2, 1))
}

make_table <- function(data) {
  data |>
    filter(type == "real") |>
    select(-label, -size, -type, -rows, -cols) |>
    spread(op, time) |>
    mutate(
      total = read + print + head + tail + sample + filter + aggregate,
      max_memory = as.character(bench::as_bench_bytes(max_memory))
    ) |>
    arrange(desc(total)) |>
    mutate_if(is.numeric, pretty_sec) |>
    mutate_if(is.logical, pretty_lgl) |>
    select(reading_package, manip_package, altrep, max_memory, everything()) |>
    rename(
      "reading\npackage" = reading_package,
      "manipulating\npackage" = manip_package,
      memory = max_memory
    ) |>
    knitr::kable(digits = 2, align = "r", format = "html")
}

desc <- c("setup", "read", "print", "head", "tail", "sample", "filter", "aggregate")
```
vroom is a new approach to reading delimited and fixed width data into R.

It stems from the observation that when parsing files reading data from disk
and finding the delimiters is generally not the main bottle neck. Instead
(re)-allocating memory and parsing the values into R data types (particularly
for characters) takes the bulk of the time.

Therefore you can obtain very rapid input by first performing a fast indexing
step and then using the Altrep framework to access the values in a lazy /
delayed fashion.

## How it works

The initial reading of the file simply records the locations of each individual
record, the actual values are not read into R. Altrep vectors are
created for each column in the data which hold a pointer to the index and the
memory mapped file. When these vectors are indexed the value is read from the
memory mapping.

This means initial reading is extremely fast, in the real world dataset below
it is ~ 1/4 the time of the multi-threaded `data.table::fread()`. Sampling
operations are likewise extremely fast, as only the data actually included in
the sample is read. This means things like the tibble print method, calling
`head()`, `tail()` `x[sample(), ]` etc. have very low overhead. Filtering also
can be fast, only the columns included in the filter selection have to be fully
read and only the data in the filtered rows needs to be read from the remaining
columns. Grouped aggregations likewise only need to read the grouping
variables and the variables aggregated.

Once a particular vector is fully materialized the speed for all subsequent
operations should be identical to a normal R vector.

This approach potentially also allows you to work with data that is larger than
memory. As long as you are careful to avoid materializing the entire dataset at
once it can be efficiently queried and subset.

# Reading delimited files

The following benchmarks all measure reading delimited files of various sizes
and data types. Because vroom delays reading the benchmarks also do some
manipulation of the data afterwards to try and provide a more realistic
performance comparison.

Because the `read.delim` results are so much slower than the others they are
excluded from the plots, but are retained in the tables.

## Taxi Trip Dataset

This real world dataset is from Freedom of Information Law (FOIL)
Taxi Trip Data from the NYC Taxi and Limousine Commission 2013, originally
posted at <https://chriswhong.com/open-data/foil_nyc_taxi/>. It is also hosted
on [archive.org](https://archive.org/details/nycTaxiTripData2013).

The first table trip_fare_1.csv is 1.55G in size.

    #> Observations: 14,776,615
    #> Variables: 11
    #> $ medallion       <chr> "89D227B655E5C82AECF13C3F540D4CF4", "0BD7C8F5B...
    #> $ hack_license    <chr> "BA96DE419E711691B9445D6A6307C170", "9FD8F69F0...
    #> $ vendor_id       <chr> "CMT", "CMT", "CMT", "CMT", "CMT", "CMT", "CMT...
    #> $ pickup_datetime <chr> "2013-01-01 15:11:48", "2013-01-06 00:18:35", ...
    #> $ payment_type    <chr> "CSH", "CSH", "CSH", "CSH", "CSH", "CSH", "CSH...
    #> $ fare_amount     <dbl> 6.5, 6.0, 5.5, 5.0, 9.5, 9.5, 6.0, 34.0, 5.5, ...
    #> $ surcharge       <dbl> 0.0, 0.5, 1.0, 0.5, 0.5, 0.0, 0.0, 0.0, 1.0, 0...
    #> $ mta_tax         <dbl> 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0...
    #> $ tip_amount      <int> 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0...
    #> $ tolls_amount    <dbl> 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.8, 0.0, 0...
    #> $ total_amount    <dbl> 7.0, 7.0, 7.0, 6.0, 10.5, 10.0, 6.5, 39.3, 7.0...

### Taxi Benchmarks

code: [bench/taxi](https://github.com/tidyverse/vroom/tree/main/inst/bench/taxi)

All benchmarks were run on a Amazon EC2
[m5.4xlarge](https://aws.amazon.com/ec2/instance-types/m5/) instance with 16
vCPUs and an [EBS](https://aws.amazon.com/ebs/) volume type.

The benchmarks labeled `vroom_base` uses `vroom` with base functions for
manipulation. `vroom_dplyr` uses `vroom` to read the file and dplyr functions to
manipulate. `data.table` uses `fread()` to read the file and `data.table`
functions to manipulate and `readr` uses `readr` to read the file and `dplyr` to
manipulate. By default vroom only uses Altrep for character vectors, these are
labeled `vroom(altrep: normal)`. The benchmarks labeled `vroom(altrep: full)`
instead use Altrep vectors for all supported types and `vroom(altrep: none)`
disable Altrep entirely.

The following operations are performed.

  - The data is read
  - `print()` - _N.B. read.delim uses `print(head(x, 10))` because printing the whole dataset takes > 10 minutes_
  - `head()`
  - `tail()`
  - Sampling 100 random rows
  - Filtering for "UNK" payment, this is 6434 rows (0.0435% of total).
  - Aggregation of mean fare amount per payment type.

```{r}
#| warning: false
#| echo: false
#| message: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage across different R packages (vroom, data.table, readr) for analyzing taxi trip data. The chart shows operation breakdowns including read, print, head, tail, sample, filter, and aggregate operations. Consult the associated table for detailed timing and memory usage statistics."
taxi <- read_benchmark(path_package("vroom", "bench", "taxi.tsv"), desc)

plot_benchmark(taxi, "Time to analyze taxi trip data")

make_table(taxi)
```

(*N.B. Rcpp used in the dplyr implementation
fully materializes all the Altrep numeric vectors when using `filter()` or `sample_n()`,
which is why the first of these cases have additional overhead when using full Altrep.*).

## All numeric data

All numeric data is really a worst case scenario for vroom. The index takes
about as much memory as the parsed data. Also because parsing doubles can be
done quickly in parallel and text representations of doubles are only ~25
characters at most there isn't a great deal of savings for delayed parsing.

For these reasons (and because the data.table implementation is very fast)
vroom is a bit slower than fread for pure numeric data.

However because vroom is multi-threaded it is a bit quicker than readr and
read.delim for this type of data.

### Long
code: [bench/all_numeric-long](https://github.com/tidyverse/vroom/tree/main/inst/bench/all_numeric-long)

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage for reading and analyzing long all-numeric data across different R packages. Shows performance breakdown by operation type, with data.table performing slightly faster than vroom for this numeric-heavy workload."
all_num <- read_benchmark(path_package("vroom", "bench", "all_numeric-long.tsv"), desc)

plot_benchmark(all_num, "Time to analyze long all numeric data")

make_table(all_num)
```

### Wide

code: [bench/all_numeric-wide](https://github.com/tidyverse/vroom/tree/main/inst/bench/all_numeric-wide)

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage for reading and analyzing wide all-numeric data across different R packages. Shows performance breakdown by operation type, with data.table performing slightly faster than vroom for this wide numeric dataset."
all_num_wide <- read_benchmark(path_package("bench", "all_numeric-wide.tsv", package = "vroom"), desc)

plot_benchmark(all_num_wide, "Time to analyze wide all numeric data")

make_table(all_num_wide)
```

## All character data

code: [bench/all_character-long](https://github.com/tidyverse/vroom/tree/main/inst/bench/all_character-long)

All character data is a best case scenario for vroom when using Altrep, as it takes full advantage of the lazy reading.

### Long

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage for reading and analyzing long all-character data across different R packages. Shows vroom with Altrep significantly outperforming other packages due to lazy character vector evaluation."
all_chr <- read_benchmark(path_package("vroom", "bench", "all_character-long.tsv"), desc)

plot_benchmark(all_chr, "Time to analyze long all character data")

make_table(all_chr)
```

### Wide

code: [bench/all_character-wide](https://github.com/tidyverse/vroom/tree/main/inst/bench/all_character-wide)

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage for reading and analyzing wide all-character data across different R packages. Shows vroom with Altrep significantly outperforming other packages due to lazy character vector evaluation."
all_chr_wide <- read_benchmark(path_package("vroom", "bench", "all_character-wide.tsv"), desc)

plot_benchmark(all_chr_wide, "Time to analyze wide all character data")

make_table(all_chr_wide)
```

# Reading multiple delimited files

code: [bench/taxi_multiple](https://github.com/tidyverse/vroom/tree/main/inst/bench/taxi_multiple)

```{r}
#| echo: false
#| message: false
#| eval: true
mult <- read_benchmark(path_package("vroom", "bench", "taxi_multiple.tsv"), desc)
```

The benchmark reads all 12 files in the taxi trip fare data, totaling `r scales::comma(mult$rows[[1]])` rows
and `r mult$cols[[1]]` columns for a total file size of `r format(fs_bytes(mult$size[[1]]))`.

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage for reading and analyzing data from multiple taxi trip files across different R packages. Shows vroom's performance advantage when reading multiple files simultaneously."
plot_benchmark(mult, "Time to analyze multiple file data")

make_table(mult)
```

# Reading fixed width files

## United States Census 5-Percent Public Use Microdata Sample files

```{r}
#| echo: false
#| message: false
#| eval: true
fwf <- read_benchmark(path_package("vroom", "bench", "fwf.tsv"), desc)
```

This fixed width dataset contains individual records of the characteristics of a 5 percent sample of people and housing units from the year 2000 and is freely available at <https://web.archive.org/web/20150908055439/https://www2.census.gov/census_2000/datasets/PUMS/FivePercent/California/all_California.zip>. The data is split into files by state, and the state of California was used in this benchmark.

The data totals `r scales::comma(fwf$rows[[1]])` rows
and `r fwf$cols[[1]]` columns with a total file size of `r format(fs_bytes(fwf$size[[1]]))`.

## Census data benchmarks

code: [bench/fwf](https://github.com/tidyverse/vroom/tree/main/inst/bench/fwf)

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Horizontal bar chart comparing time and memory usage for reading and analyzing fixed-width format data (US Census data) across different R packages. Shows vroom's performance with fixed-width files."
plot_benchmark(fwf, "Time to analyze fixed width data")

make_table(fwf)
```

# Writing delimited files

code: [bench/taxi_writing](https://github.com/tidyverse/vroom/tree/main/inst/bench/taxi_writing)

The benchmarks write out the taxi trip dataset in a few different ways.

- An uncompressed file
- A gzip compressed file using `gzfile()` _(readr and vroom do this automatically for files ending in `.gz`)_
- A gzip compressed file compressed with multiple threads (natively for data.table and using a `pipe()` connection to [pigz](https://zlib.net/pigz/) for the rest).
- A [Zstandard](https://facebook.github.io/zstd/) compressed file (data.table does not support this format).

```{r}
#| warning: false
#| message: false
#| echo: false
#| fig-height: 8
#| fig-width: 10
#| fig-alt: "Grouped horizontal bar chart comparing file writing performance across R packages (base, readr, data.table, vroom) with different compression methods (uncompressed, gzip, multithreaded gzip, and Zstandard). Shows vroom's competitive writing performance, especially with compression."
taxi_writing <- read_benchmark(path_package("vroom", "bench", "taxi_writing.tsv"), c("setup", "writing")) |>
  rename(
    package = reading_package,
    compression = manip_package
  ) |> mutate(
    package = factor(package, c("base", "readr", "data.table", "vroom")),
    compression = factor(compression, rev(c("gzip", "multithreaded_gzip", "zstandard", "uncompressed")))
  ) |> filter(type == "real")

subtitle <- generate_subtitle(taxi_writing)

taxi_writing |>
  ggplot(aes(x = compression, y = time, fill = package)) +
  geom_bar(stat = "identity", position = position_dodge2(reverse = TRUE, padding = .05)) +
  scale_fill_brewer(type = "qual", palette = "Set2") +
  scale_y_continuous(labels = scales::number_format(suffix = "s")) +
  theme(legend.position = "bottom") +
  coord_flip() +
  labs(title = "Writing taxi trip data", subtitle = subtitle, x = NULL, y = NULL, fill = NULL)

taxi_writing |>
  select(-size, -op, -rows, -cols, -type, -altrep, -label, -max_memory) |>
  mutate_if(is.numeric, pretty_sec) |>
  pivot_wider(names_from = package, values_from = time) |>
  arrange(desc(compression)) |>
  knitr::kable(digits = 2, align = "r", format = "html")
```

## Session and package information

```{r}
#| echo: false
#| warning: false
#| message: false
si <- vroom::vroom(path_package("vroom", "bench", "session_info.tsv"))
class(si) <- c("packages_info", "data.frame")
select(as.data.frame(si), package, version = ondiskversion, date, source) |>
  knitr::kable()
```

# locale() errors when decimal_mark equals grouping_mark

    Code
      locale(decimal_mark = ".", grouping_mark = ".")
    Condition
      Error in `locale()`:
      ! `decimal_mark` and `grouping_mark` must be different.
      i Both were specified as ".".

# locale() errors for unrecognized language code

    Code
      locale(date_names = "fake")
    Condition
      Error in `locale()`:
      ! Unrecognized language code: "fake"

# locale() warns for unrecognized encoding

    Code
      locale(encoding = "FAKE-ENCODING-9999")
    Condition
      Warning:
      `encoding` not found in `iconvlist()`: "FAKE-ENCODING-9999".
    Output
      <locale>
      Numbers:  123,456.78
      Formats:  %AD / %AT
      Timezone: UTC
      Encoding: FAKE-ENCODING-9999
      <date_names>
      Days:   Sunday (Sun), Monday (Mon), Tuesday (Tue), Wednesday (Wed), Thursday
              (Thu), Friday (Fri), Saturday (Sat)
      Months: January (Jan), February (Feb), March (Mar), April (Apr), May (May),
              June (Jun), July (Jul), August (Aug), September (Sep), October
              (Oct), November (Nov), December (Dec)
      AM/PM:  AM/PM

# locale() validates timezone

    Code
      locale(tz = "Invalid/Timezone")
    Condition
      Error in `locale()`:
      ! Unknown timezone: "Invalid/Timezone".

# locale() can consult and validate system time zone

    Code
      locale(tz = "")
    Condition
      Error in `locale()`:
      ! Unknown system timezone: "foo".

# vroom errors if the file does not exist

    Code
      vroom(tf, col_types = list())
    Condition
      Error:
      ! '<tempfile>' does not exist.

---

    Code
      vroom("does-not-exist.csv", col_types = list())
    Condition
      Error:
      ! 'does-not-exist.csv' does not exist in current working directory: '<workdir>'.

# vroom() informs user to use I() for literal data (or not)

    Code
      x <- vroom("a,b,c,d\n1,2,3,4", show_col_types = FALSE)
    Condition
      Warning:
      The `file` argument of `vroom()` must use `I()` for literal data as of vroom 1.5.0.
        
        # Bad:
        vroom("X,Y\n1.5,2.3\n")
        
        # Good:
        vroom(I("X,Y\n1.5,2.3\n"))

# standardise_path() errors for a mix of connection and not connection

    Code
      f(list(file, conn))
    Condition
      Error in `f()`:
      ! `some_arg_name` cannot be a mix of connection and non-connection inputs

# standardise_path() errors for invalid input

    Code
      f(as.list(files))
    Condition
      Error in `f()`:
      ! `some_arg_name` must be one of the supported input types:
      * A filepath or character vector of filepaths
      * A connection or list of connections
      * Literal or raw input
      x `some_arg_name` is a list.

# multiple files with non-ASCII encoding fails informatively

    Code
      vroom(c(input, input), locale = locale(encoding = "UTF-16"))
    Condition
      Error in `vroom()`:
      ! Encoding "UTF-16" is only supported when reading a single input.
      i `file` has length 2.

# writing to .zip without archive package fails informatively

    Code
      vroom_write(mtcars, tempfile(fileext = ".zip"))
    Condition
      Error in `vroom_write()`:
      ! The package "archive" is required to write `.zip` files.

# reading archive-only formats without archive package fails informatively

    Code
      vroom(vroom_example("mtcars.csv.tar.gz"), col_types = list())
    Condition
      Error:
      ! The package "archive" is required to read `.csv.tar.gz` files.

# problems returns a detailed warning message

    Code
      vroom(I("a,b,c\nx,y,z,,"), altrep = FALSE, col_types = "ccc")
    Condition
      Warning:
      One or more parsing issues, call `problems()` on your data frame for details, e.g.:
        dat <- vroom(...)
        problems(dat)
    Output
      # A tibble: 1 x 3
        a     b     c    
        <chr> <chr> <chr>
      1 x     y     z,,  

# can promote vroom parse warning to error

    Code
      withCallingHandlers(expr = make_warning(), vroom_parse_issue = function(cnd) {
        abort("oh no")
      })
    Condition
      Error:
      ! oh no

# emits an error message if provided incorrect input

    Code
      problems(a_vector)
    Condition
      Error in `problems()`:
      ! The `x` argument of `vroom::problems()` must be a data frame created by vroom:
      x `x` has class <numeric>

---

    Code
      problems(a_tibble)
    Condition
      Error in `problems()`:
      ! The `x` argument of `vroom::problems()` must be a data frame created by vroom:
      x `x` seems to have been created with something else, maybe readr?

# vroom errors informatively when it cannot guess delimiter

    Code
      vroom(I("foo\nbar\nbaz\n"), col_types = list())
    Condition
      Error:
      ! Could not guess the delimiter.
      i Use `vroom(delim =)` to explicitly specify the delimiter.

# all col_types can be reported with color

    Code
      spec(dat)
    Output
      cols(
        skip = col_skip(),
        guess = [31mcol_character()[39m,
        character = [31mcol_character()[39m,
        factor = [31mcol_factor(levels = NULL, ordered = FALSE, include_na = FALSE)[39m,
        logical = [33mcol_logical()[39m,
        double = [32mcol_double()[39m,
        integer = [32mcol_integer()[39m,
        big_integer = [32mcol_big_integer()[39m,
        number = [32mcol_number()[39m,
        date = [34mcol_date(format = "")[39m,
        datetime = [34mcol_datetime(format = "")[39m,
        .delim = ","
      )

# cols() errors for invalid collector objects

    Code
      cols(a = col_character(), b = 123)
    Condition
      Error in `cols()`:
      ! Column specifications must be created with the `col_*()` functions or their abbreviated character names.
      x Bad specification at position: 2.

---

    Code
      cols(a = col_character(), .default = 123)
    Condition
      Error in `cols()`:
      ! Column specifications must be created with the `col_*()` functions or their abbreviated character names.
      x Bad `.default` specification.

# cols() errors for invalid character specifications

    Code
      cols(X = "z", Y = "i", Z = col_character())
    Condition
      Error in `lapply()`:
      ! Unknown column type specification: "z"

---

    Code
      cols(X = "i", .default = "wut")
    Condition
      Error in `cols()`:
      ! Unknown column type specification: "wut"

# as.col_spec() errors for unhandled input type

    Code
      vroom(I("whatever"), col_types = data.frame())
    Condition
      Error in `vroom()`:
      ! `col_types` must be `NULL`, a `cols()` specification, or a string, not a <data.frame> object.

# as.col_spec() errors for unrecognized single-letter spec

    Code
      vroom(I("whatever"), col_types = "dz")
    Condition
      Error in `lapply()`:
      ! Unknown column type specification: "z"

# fwf_cols errors when arguments have different shapes

    Code
      fwf_cols(a = 10, b = c(11, 15))
    Condition
      Error in `fwf_cols()`:
      ! All inputs must have the same shape.
      x Found inputs with different lengths: 1 and 2.
      i Provide either single values (widths) or pairs of values (positions).

---

    Code
      fwf_cols(a = 1:3, b = 4:5)
    Condition
      Error in `fwf_cols()`:
      ! All inputs must have the same shape.
      x Found inputs with different lengths: 3 and 2.
      i Provide either single values (widths) or pairs of values (positions).

# fwf_cols errors with invalid number of values

    Code
      fwf_cols(a = 1:4, b = 5:8)
    Condition
      Error in `fwf_cols()`:
      ! All inputs must be either a single value or a pair of values.
      x The provided inputs each have length 4.
      i Single values specify column widths: `fwf_cols(a = 10, b = 5)`.
      i Pairs of values specify start and end positions: `fwf_cols(a = c(1, 10), b = c(11, 15))`.

---

    Code
      fwf_cols(a = c(), b = c())
    Condition
      Error in `fwf_cols()`:
      ! All inputs must be either a single value or a pair of values.
      x The provided inputs each have length 0.
      i Single values specify column widths: `fwf_cols(a = 10, b = 5)`.
      i Pairs of values specify start and end positions: `fwf_cols(a = c(1, 10), b = c(11, 15))`.

# fwf_positions errors when start and end have different lengths

    Code
      fwf_positions(c(1, 5, 10), c(4, 9))
    Condition
      Error in `fwf_positions()`:
      ! `start` and `end` must have the same length.
      i `start` has length 3.
      i `end` has length 2.

# fwf_positions() errors for start position of 0

    Code
      fwf_positions(c(0, 4), c(3, 7))
    Condition
      Error in `fwf_positions()`:
      ! `start` positions must be >= 1, i.e. use 1-based indexing.
      i The first character in a line is at position 1, not 0.
      i If you got these positions from `fwf_empty()`, note that its output uses 0-based indexing.

# Errors if begin is greater than end

    Code
      vroom_fwf(I("1  2  3\n"), positions, col_types = list())
    Condition
      Error in `verify_fwf_positions()`:
      ! `begin` cannot be greater than `end`.
      x Problem with column: "bar".

# vroom errors if numbers of columns are inconsistent

    Code
      vroom::vroom(files, col_types = list())
    Condition
      Error:
      ! Files must all have 2 columns:
      i File 2 has 3 columns.

# vroom errors if column names are inconsistent

    Code
      vroom::vroom(files, col_types = list())
    Condition
      Error:
      ! Files must have consistent column names:
      * File 1 column 1 is: A
      * File 2 column 1 is: C

# vroom errors when the connection buffer is too small

    Code
      vroom(file(vroom_example("mtcars.csv")), col_types = list())
    Condition
      Error:
      ! The size of the connection buffer (32) was not large enough
      to fit a complete line:
        * Increase it by setting `Sys.setenv("VROOM_CONNECTION_SIZE")`

# malformed date / datetime formats cause R errors

    Code
      vroom(I("x\n6/28/2016"), delim = ",", col_types = list(x = col_date("%m/%/%Y")),
      altrep = FALSE)
    Condition
      Error:
      ! Unsupported format

---

    Code
      vroom(I("x\n6/28/2016"), delim = ",", col_types = list(x = col_datetime(
        "%m/%/%Y")), altrep = FALSE)
    Condition
      Error:
      ! Unsupported format

=pod

=for comment
DO NOT EDIT. This Pod was generated by Swim.
See http://github.com/ingydotnet/swim-pm#readme

=encoding utf8

=head1 NAME

Vroom - Slide Shows in Vim

=for html
<a href="https://travis-ci.org/ingydotnet/vroom-pm"><img src="https://travis-ci.org/ingydotnet/vroom-pm.png" alt="vroom-pm"></a>
<a href="https://coveralls.io/r/ingydotnet/vroom-pm?branch=master"><img src="https://coveralls.io/repos/ingydotnet/vroom-pm/badge.png" alt="vroom-pm"></a>

=head1 SYNOPSIS

    > mkdir MySlides    # Make a Directory for Your Slides
    > cd MySlides       # Go In There
    > vroom new         # Create Example Slides File
    > vim slides.vroom  # Edit the File and Add Your Own Slides
    > vroom vroom       # Show Your Slides
    > vroom html        # Publish Your Slides as HTML

=head1 DESCRIPTION

Ever given a Slide Show and needed to switch over to Vim?

Now you don't ever have to switch again. You're already there.

Vroom lets you create your slides in a single file using a Wiki-like style,
much like Spork and Sporx do. The difference is that your slides don't compile
to HTML or JavaScript or XUL. They get turned into a set of files that begin
with '0', like '03' or '07c' or '05b.pl'.

The slides are named in alphabetic order. That means you can bring them
all into a Vim session with the command: C<vim 0*>. C<vroom vroom> does
exactly that.

You can do things like advance to the next slide with the spacebar. Vroom
creates a file called C<./.vimrc> with helpful key mappings for navigating a
slideshow. See [KEY MAPPINGS] below.

Vroom takes advantage of Vim's syntax highlighting. It also lets you run
slides that contain code.

Since Vim is an editor, you can change your slides during the show.

=head1 COMMAND USAGE

C<vroom> has a few command line options:

=over

=item C<vroom new>

Write an example C<slides.vroom> file. This example contains all the config
options and also examples of all the Vroom syntax features.

=item C<vroom vroom>

Compile (create) the slides files from the input file and start vim show.

=item C<vroom compile>

Just compile the slides.

=item C<vroom html>

Publish the slides to HTML, with embedded JavaScript to navigate with the
spacebar and backspace keys. Created in the C<html/> subdirectory.

=item C<vroom text>

Publish the slides to plain text. This action uses all the text slides in
their unsplit form. Created in the C<text/> subdirectory.

=item C<vroom clean>

Clean up all the compiled output files.

=item C<vroom ghpublish>

Creates a shell script in the current directory, that is intended to
publish your slides to the special GitHub branch called gh-pages. See
[GITHUB NOTES] below.

This command does NOT run the script. It merely creates it for you. It is up
to you to review the script and run it (if it makes sense on your system).

=item C<< vroom <action> --skip=# >>

The skip option takes a number as its input and skips that number of files
during compilation. This is useful when you are polishing your slides and are
finished with the first 50. You can say:

    vroom vroom --skip=50

and it will start on slide #51.

=item C<< vroom <action> --input=<file_name> >>

This option lets you specify an alternate input file name, instead of the
default one, C<slides.vroom>.

=back

=head1 INPUT FORMAT

Here is an example slides.vroom file:

    ---- config
    # These are YAML settings for Vroom
    title: My Spiffy Slideshow
    # height: 84
    # width: 20
    auto_size: 1  # Determines height/width automatically
    # skip: 12      # Skip 12 slides. Useful when making slides.
    ---- center
    My Presentation

    by Ingy
    ----
    == Stuff I care about:

    * Foo
    +* Bar
    +* Baz
    ---- perl,i10
    # Perl code indented 10 spaces
    use Vroom;

    print "Hello World";
    ---- center
    THE END

A line that starts with C<==> is a header line. It will be centered.

Lines that begin with a C<+> cause vroom to split the slide there, causing an
animation effect.

Lines that begin with a C<%> are slide titles. Titles are completely optional.
They are used with notes files, and also for the index page if you convert to
HTML. You can have only one of these per slide.

A line consisting of nothing but C<====> indicates that what follows are notes
for this slide. Notes are also optional. They are primarily used for notes
files, but are also included if you convert your presentation to HTML. See
[SLIDE NOTES] below.

=head1 CONFIGURATION OPTIONS

each slide can have one or more configuration options. Options are a comma
separated list that follow the C<----> header for a slide. Like this:

    ---- config
    ---- center
    ---- perl,i20
    ---- include file-name
    ---- replace
    ---- skip

=over

=item config

The slide is really a yaml configuration. It will not be displayed in the
presentation, but will tell vroom what to do from that point forward.

Usually, a C<config> slide is the first thing in your input file, but you can
use more than one config slide.

=item center

Center the contents of the slide.

=item C<i##>

'i' followed by a number means to indent the contents by the number of
characters.

=item C<i-##>

'i' followed by a negative number means to strip that number of leading
characters from the contents of the slide. This can be useful if you need to
have characters special to Vroom at the beginning of your lines, for example
if the contents of your slide is unified diff output.

=item perl,ruby,python,php,javascript,haskell,actionscript,html,yaml,xml,json,make,shell,diff

Specifies that the slide is one of those syntaxen, and that the appropriate
file extension will be used, thus causing vim to syntax highlight the slide.

=item include file-path-name

Replace the line with the contents of the specified file. Useful to include
long files that would make your slides file unruly.

=item replace

With the C<replace> option, the '+' animations in the slide cause the content
to replace the previous partial slide, rather than append to it.

=item skip

Ignore the following slide completely.

=back

=head2 Config Slide Options

You can specify the following configuration options in a config slide:

=over

=item C<< title: <text> >>

The title of your presentation.

=item C<< height: <number> >>

The number of lines in the terminal you plan to use when presenting the show.
Used for centering the content.

=item C<< width: <number> >>

The number of columns in the terminal you plan to use when presenting the
show. Used for centering the content.

=item C<< auto_size: <0|1> >>

When set to 1, the height/width options above will be ignored and determined
each time you start the slideshow.

=item C<< indent: <number> >>

All slides will be indented by this number of spaces by default.

=item C<< list_indent: <number> >>

Auto detect slides that have lists in them, and indent them by the specified
number of columns.

=item C<< vim: <name> >>

You can specify the name of the vim executable to use. If you set this to
C<gvim> special gvim support will be provided.

=item GVim options

The following options are available, if your vim option is set to gvim.

    fuopt: maxhorz,maxvert
    guioptions: egmLtT
    guicursor: a:blinkon0-ver25-Cursor
    guifont: Bitstream_Vera_Sans_Mono:h18

These are all documented by gvim's help system. Please see that for more
information.

=back

=head1 SLIDE NOTES

You can add notes to each slide, if you like. When you create your
presentation (with C<vroom compile> or C<vroom vroom>), a file called
C<notes.txt> will be created containing all your notes, along with indications
of when to proceed to the next slide. If you give any of your slides titles,
they will also be put into the notes file in order to help you keep track of
where you are in the presentation.

You can print out your notes file, or simply bring it up on a separate device
(such as your smartphone). The notes are not part of the presentation; they
are just for you.

However, if you convert your presentation to HTML, the notes will be included
in a smaller font below each slide. This is useful when sharing your slides
with others who were not present at the presentation.

=head1 KEY MAPPINGS

These are the standard key mappings specified in the local C<.vimrc>.

=over

=item C<< <SPACE> >>

Advance one slide.

=item C<< <BACKSPACE> >>

Go back one slide.

=item C<??>

Bring up the help screen.

=item C<RR> (or R -- deprecated)

If the current slide is declared Perl, Python, Ruby, PHP, Haskell or
JavaScript, then run it accordingly.

=item C<QQ>

Quit Vroom.

=item C<VV>

Since these vim options apply while editing the C<slides.vroom> file (yes,
beware), you can use this shortcut to launch Vroom on the current contents
whilst writing your slides.

=item C<EE>

Edit the file that the cursor is on the filename of.

You can put file path names in your slides, and then easily bring them up
during your presentation.

=item C<OO>

On a Mac, run the OS X C<open> command on the argument that your cursor is on.

For instance, if you want to display an image, you could put the file path of
the image in your slide, then use OO to launch it.

=back

=head1 CUSTOM CONFIGURATION

You can create a file called C<.vroom/vimrc> in your home directory. If vroom
sees this file, it will append it onto every local C<.vimrc> file it creates.

Use this file to specify your own custom vim settings for all your vroom
presentations.

You can also create a file called C<.vroom/gvimrc> for gvim overrides, if you
are using gvim.

=head1 USING MACVIM OR GVIM

If you have a Mac, you really should try using MacVim for Vroom slide shows.
You can run it in fullscreen mode, and it looks kinda professional.

To do this, set the vim option in your config section:

    vim: gvim

NOTE: On my Mac, I have gvim symlinked to mvim, which is a smart startup
      script that ships with MacVim. Ping me, if you have questions about
      this setup.

=head1 GITHUB NOTES

I(ngy) put all my public talks on github. I think it is an excellent way to
publish your slides and give people a url to review them. Here are the things
I do to make this work well:

=over

=item * I create a repository for every presentation I give. The name of  the repo is of the form <topic>-<event/time>-talk. You can go to  L<http://github.com/ingydotnet/> and look for the repos ending with C<-talk>.

=item * GitHub has a feature called gh-pages that you can use to create a  website for each github repo. I use this feature to publish the html  output of my talk. I do something like this:

    vroom html
    mv html /tmp
    git branch gh-pages
    git checkout gh-pages
    rm -r *.html
    mv /tmp/html/* .
    rmdir /tmp/html
    git add .
    git commit -m 'Publish my slides'
    git push origin gh-pages
    git checkout master

=item * Vroom comes with a C<ghpublish> option. If you run:

    > vroom ghpublish
it will generate a script called C<ghpublish> that contains commands like the
ones above, to publish your slides to a gh-pages branch.

=item * If my repo is called C<vroom-yapcna2009-talk>, then after I publish  the talk to the gh-pages branch, it will be available as  L<http://ingydotnet.github.com/vroom-yapcna2009-talk>.  I then link this url from  L<http://github.com/ingydotnet/vroom-yapcna2009-talk> as the Homepage  url.

=back

You can see an example of a talk published to HTML and posted via gh-pages at
L<http://ingydotnet.github.com/vroom-pm/>.

=cut

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom_write.R
\name{vroom_write}
\alias{vroom_write}
\title{Write a data frame to a delimited file}
\usage{
vroom_write(
  x,
  file,
  delim = "\\t",
  eol = "\\n",
  na = "NA",
  col_names = !append,
  append = FALSE,
  quote = c("needed", "all", "none"),
  escape = c("double", "backslash", "none"),
  bom = FALSE,
  num_threads = vroom_threads(),
  progress = vroom_progress()
)
}
\arguments{
\item{x}{A data frame or tibble to write to disk.}

\item{file}{File or connection to write to.}

\item{delim}{Delimiter used to separate values. Defaults to \verb{\\t} to write
tab separated value (TSV) files.}

\item{eol}{The end of line character to use. Most commonly either \code{"\\n"} for
Unix style newlines, or \code{"\\r\\n"} for Windows style newlines.}

\item{na}{String used for missing values. Defaults to 'NA'.}

\item{col_names}{If \code{FALSE}, column names will not be included at the top of
the file. If \code{TRUE}, column names will be included. If not specified,
\code{col_names} will take the opposite value given to \code{append}.}

\item{append}{If \code{FALSE}, will overwrite existing file. If \code{TRUE},
will append to existing file. In both cases, if the file does not exist, a
new file is created.}

\item{quote}{How to handle fields which contain characters that need to be
quoted.
\itemize{
\item \code{needed} - Values are only quoted if needed: if they contain a delimiter,
quote, or newline.
\item \code{all} - Quote all fields.
\item \code{none} - Never quote fields.
}}

\item{escape}{The type of escape to use when quotes are in the data.
\itemize{
\item \code{double} - quotes are escaped by doubling them.
\item \code{backslash} - quotes are escaped by a preceding backslash.
\item \code{none} - quotes are not escaped.
}}

\item{bom}{If \code{TRUE} add a UTF-8 BOM at the beginning of the file. This is
recommended when saving data for consumption by excel, as it will force
excel to read the data with the correct encoding (UTF-8)}

\item{num_threads}{Number of threads to use when reading and materializing
vectors. If your data contains newlines within fields the parser will
automatically be forced to use a single thread only.}

\item{progress}{Display a progress bar? By default it will only display
in an interactive session and not while executing in an RStudio notebook
chunk. The display of the progress bar can be disabled by setting the
environment variable \code{VROOM_SHOW_PROGRESS} to \code{"false"}.}
}
\description{
Write a data frame to a delimited file
}
\examples{
# If you only specify a file name, vroom_write() will write
# the file to your current working directory.
out_file <- tempfile(fileext = "csv")
vroom_write(mtcars, out_file, ",")

# You can also use a literal filename
# vroom_write(mtcars, "mtcars.tsv")

# If you add an extension to the file name, write_()* will
# automatically compress the output.
# vroom_write(mtcars, "mtcars.tsv.gz")
# vroom_write(mtcars, "mtcars.tsv.bz2")
# vroom_write(mtcars, "mtcars.tsv.xz")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom.R
\name{vroom_altrep}
\alias{vroom_altrep}
\title{Show which column types are using Altrep}
\usage{
vroom_altrep(which = NULL)
}
\arguments{
\item{which}{A character vector of column types to use Altrep for. Can also
take \code{TRUE} or \code{FALSE} to use Altrep for all possible or none of the
types}
}
\description{
\code{vroom_altrep()} can be used directly as input to the \code{altrep}
argument of \code{\link[=vroom]{vroom()}}.
}
\details{
Alternatively there is also a family of environment variables to control use of
the Altrep framework. These can then be set in your \code{.Renviron} file, e.g.
with \code{usethis::edit_r_environ()}. The variables can take one of \code{true}, \code{false},
\code{TRUE}, \code{FALSE}, \code{1}, or \code{0}.
\itemize{
\item \code{VROOM_USE_ALTREP_NUMERICS} - If set use Altrep for \emph{all} numeric types
(default \code{false}).
}

There are also individual variables for each type. Currently only
\code{VROOM_USE_ALTREP_CHR} defaults to \code{true}.
\itemize{
\item \code{VROOM_USE_ALTREP_CHR}
\item \code{VROOM_USE_ALTREP_FCT}
\item \code{VROOM_USE_ALTREP_INT}
\item \code{VROOM_USE_ALTREP_BIG_INT}
\item \code{VROOM_USE_ALTREP_DBL}
\item \code{VROOM_USE_ALTREP_NUM}
\item \code{VROOM_USE_ALTREP_LGL}
\item \code{VROOM_USE_ALTREP_DTTM}
\item \code{VROOM_USE_ALTREP_DATE}
\item \code{VROOM_USE_ALTREP_TIME}
}
}
\examples{
vroom_altrep()
vroom_altrep(c("chr", "fct", "int"))
vroom_altrep(TRUE)
vroom_altrep(FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom-package.R
\docType{package}
\name{vroom-package}
\alias{vroom-package}
\title{vroom: Read and Write Rectangular Text Data Quickly}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

The goal of 'vroom' is to read and write data (like 'csv', 'tsv' and 'fwf') quickly. When reading it uses a quick initial indexing step, then reads the values lazily , so only the data you actually use needs to be read. The writer formats the data in parallel and writes to disk asynchronously from formatting.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://vroom.tidyverse.org}
  \item \url{https://github.com/tidyverse/vroom}
  \item Report bugs at \url{https://github.com/tidyverse/vroom/issues}
}

}
\author{
\strong{Maintainer}: Jennifer Bryan \email{jenny@posit.co} (\href{https://orcid.org/0000-0002-6983-2759}{ORCID})

Authors:
\itemize{
  \item Jim Hester (\href{https://orcid.org/0000-0002-2739-7082}{ORCID})
  \item Hadley Wickham \email{hadley@posit.co} (\href{https://orcid.org/0000-0003-4757-117X}{ORCID})
}

Other contributors:
\itemize{
  \item Shelby Bearrows [contributor]
  \item https://github.com/mandreyel/ (mio library) [copyright holder]
  \item Jukka Jylänki (grisu3 implementation) [copyright holder]
  \item Mikkel Jørgensen (grisu3 implementation) [copyright holder]
  \item Posit Software, PBC (\href{https://ror.org/03wc8by49}{ROR}) [copyright holder, funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generator.R
\name{gen_tbl}
\alias{gen_tbl}
\title{Generate a random tibble}
\usage{
gen_tbl(
  rows,
  cols = NULL,
  col_types = NULL,
  locale = default_locale(),
  missing = 0
)
}
\arguments{
\item{rows}{Number of rows to generate}

\item{cols}{Number of columns to generate, if \code{NULL} this is derived from \code{col_types}.}

\item{col_types}{One of \code{NULL}, a \code{\link[=cols]{cols()}} specification, or
a string.

If \code{NULL}, all column types will be inferred from \code{guess_max} rows
of the input, interspersed throughout the file. This is convenient (and
fast), but not robust. If the guessed types are wrong, you'll need to
increase \code{guess_max} or supply the correct types yourself.

Column specifications created by \code{\link[=list]{list()}} or \code{\link[=cols]{cols()}} must contain
one column specification for each column. If you only want to read a
subset of the columns, use \code{\link[=cols_only]{cols_only()}}.

Alternatively, you can use a compact string representation where each
character represents one column:
\itemize{
\item c = character
\item i = integer
\item I = big integer
\item n = number
\item d = double
\item l = logical
\item f = factor
\item D = date
\item T = date time
\item t = time
\item ? = guess
\item _ or - = skip
}

By default, reading a file without a column specification will print a
message showing the guessed types. To suppress this message, set
\code{show_col_types = FALSE}.}

\item{locale}{The locale controls defaults that vary from place to place.
The default locale is US-centric (like R), but you can use
\code{\link[=locale]{locale()}} to create your own locale that controls things like
the default time zone, encoding, decimal mark, big mark, and day/month
names.}

\item{missing}{The percentage (from 0 to 1) of missing data to use}
}
\description{
This is useful for benchmarking, but also for bug reports when you cannot
share the real dataset.
}
\details{
There is also a family of functions to generate individual vectors of each
type.
}
\examples{
# random 10 x 5 table with random column types
rand_tbl <- gen_tbl(10, 5)
rand_tbl

# all double 25 x 4 table
dbl_tbl <- gen_tbl(25, 4, col_types = "dddd")
dbl_tbl

# Use the dots in long form column types to change the random function and options
types <- rep(times = 4, list(col_double(f = stats::runif, min = -10, max = 25)))
types
dbl_tbl2 <- gen_tbl(25, 4, col_types = types)
dbl_tbl2
}
\seealso{
\link{generators} to generate individual vectors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom_write.R
\name{vroom_format}
\alias{vroom_format}
\title{Convert a data frame to a delimited string}
\usage{
vroom_format(
  x,
  delim = "\\t",
  eol = "\\n",
  na = "NA",
  col_names = TRUE,
  escape = c("double", "backslash", "none"),
  quote = c("needed", "all", "none"),
  bom = FALSE,
  num_threads = vroom_threads()
)
}
\arguments{
\item{x}{A data frame or tibble to write to disk.}

\item{delim}{Delimiter used to separate values. Defaults to \verb{\\t} to write
tab separated value (TSV) files.}

\item{eol}{The end of line character to use. Most commonly either \code{"\\n"} for
Unix style newlines, or \code{"\\r\\n"} for Windows style newlines.}

\item{na}{String used for missing values. Defaults to 'NA'.}

\item{col_names}{If \code{FALSE}, column names will not be included at the top of
the file. If \code{TRUE}, column names will be included. If not specified,
\code{col_names} will take the opposite value given to \code{append}.}

\item{escape}{The type of escape to use when quotes are in the data.
\itemize{
\item \code{double} - quotes are escaped by doubling them.
\item \code{backslash} - quotes are escaped by a preceding backslash.
\item \code{none} - quotes are not escaped.
}}

\item{quote}{How to handle fields which contain characters that need to be
quoted.
\itemize{
\item \code{needed} - Values are only quoted if needed: if they contain a delimiter,
quote, or newline.
\item \code{all} - Quote all fields.
\item \code{none} - Never quote fields.
}}

\item{bom}{If \code{TRUE} add a UTF-8 BOM at the beginning of the file. This is
recommended when saving data for consumption by excel, as it will force
excel to read the data with the correct encoding (UTF-8)}

\item{num_threads}{Number of threads to use when reading and materializing
vectors. If your data contains newlines within fields the parser will
automatically be forced to use a single thread only.}
}
\description{
This is equivalent to \code{\link[=vroom_write]{vroom_write()}}, but instead of writing to
disk, it returns a string. It is primarily useful for examples and for
testing.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom_fwf.R
\name{vroom_fwf}
\alias{vroom_fwf}
\alias{fwf_empty}
\alias{fwf_widths}
\alias{fwf_positions}
\alias{fwf_cols}
\title{Read a fixed-width file into a tibble}
\usage{
vroom_fwf(
  file,
  col_positions = fwf_empty(file, skip, n = guess_max),
  col_types = NULL,
  col_select = NULL,
  id = NULL,
  locale = default_locale(),
  na = c("", "NA"),
  comment = "",
  skip_empty_rows = TRUE,
  trim_ws = TRUE,
  skip = 0,
  n_max = Inf,
  guess_max = 100,
  altrep = TRUE,
  num_threads = vroom_threads(),
  progress = vroom_progress(),
  show_col_types = NULL,
  .name_repair = "unique"
)

fwf_empty(file, skip = 0, col_names = NULL, comment = "", n = 100L)

fwf_widths(widths, col_names = NULL)

fwf_positions(start, end = NULL, col_names = NULL)

fwf_cols(...)
}
\arguments{
\item{file}{Either a path to a file, a connection, or literal data (either a
single string or a raw vector). \code{file} can also be a character vector
containing multiple filepaths or a list containing multiple connections.

Files ending in \code{.gz}, \code{.bz2}, \code{.xz}, or \code{.zip} will be automatically
decompressed. Files starting with \verb{http://}, \verb{https://}, \verb{ftp://}, or
\verb{ftps://} will be automatically downloaded. Remote compressed files
(\code{.gz}, \code{.bz2}, \code{.xz}, \code{.zip}) will be automatically downloaded and
decompressed.

Literal data is most useful for examples and tests. To be recognised as
literal data, wrap the input with \code{I()}.}

\item{col_positions}{Column positions, as created by \code{\link[=fwf_empty]{fwf_empty()}},
\code{fwf_widths()}, \code{fwf_positions()}, or \code{fwf_cols()}. To read in only
selected fields, use \code{fwf_positions()}. If the width of the last column
is variable (a ragged fwf file), supply the last end position as \code{NA}.}

\item{col_types}{One of \code{NULL}, a \code{\link[=cols]{cols()}} specification, or
a string.

If \code{NULL}, all column types will be inferred from \code{guess_max} rows
of the input, interspersed throughout the file. This is convenient (and
fast), but not robust. If the guessed types are wrong, you'll need to
increase \code{guess_max} or supply the correct types yourself.

Column specifications created by \code{\link[=list]{list()}} or \code{\link[=cols]{cols()}} must contain
one column specification for each column. If you only want to read a
subset of the columns, use \code{\link[=cols_only]{cols_only()}}.

Alternatively, you can use a compact string representation where each
character represents one column:
\itemize{
\item c = character
\item i = integer
\item I = big integer
\item n = number
\item d = double
\item l = logical
\item f = factor
\item D = date
\item T = date time
\item t = time
\item ? = guess
\item _ or - = skip
}

By default, reading a file without a column specification will print a
message showing the guessed types. To suppress this message, set
\code{show_col_types = FALSE}.}

\item{col_select}{Columns to include in the results. You can use the same
mini-language as \code{dplyr::select()} to refer to the columns by name. Use
\code{c()} to use more than one selection expression. Although this
usage is less common, \code{col_select} also accepts a numeric column index. See
\code{\link[tidyselect:language]{?tidyselect::language}} for full details on the
selection language.}

\item{id}{Either a string or 'NULL'. If a string, the output will contain a
column with that name with the filename(s) as the value, i.e. this column
effectively tells you the source of each row. If 'NULL' (the default), no
such column will be created.}

\item{locale}{The locale controls defaults that vary from place to place.
The default locale is US-centric (like R), but you can use
\code{\link[=locale]{locale()}} to create your own locale that controls things like
the default time zone, encoding, decimal mark, big mark, and day/month
names.}

\item{na}{Character vector of strings to interpret as missing values. Set this
option to \code{character()} to indicate no missing values.}

\item{comment}{A string used to identify comments. Any line that starts
with the comment string at the beginning of the file (before any data
lines) will be ignored. Unlike \code{\link[=vroom]{vroom()}}, comment lines in the middle
of the file are not filtered out.}

\item{skip_empty_rows}{Should blank rows be ignored altogether? i.e. If this
option is \code{TRUE} then blank rows will not be represented at all.  If it is
\code{FALSE} then they will be represented by \code{NA} values in all the columns.}

\item{trim_ws}{Should leading and trailing whitespace (ASCII spaces and tabs) be trimmed from
each field before parsing it?}

\item{skip}{Number of lines to skip before reading data. If \code{comment} is
supplied any commented lines are ignored \emph{after} skipping.}

\item{n_max}{Maximum number of lines to read.}

\item{guess_max}{Maximum number of lines to use for guessing column types.
See \code{vignette("column-types", package = "readr")} for more details.}

\item{altrep}{Control which column types use Altrep representations,
either a character vector of types, \code{TRUE} or \code{FALSE}. See
\code{\link[=vroom_altrep]{vroom_altrep()}} for for full details.}

\item{num_threads}{Number of threads to use when reading and materializing
vectors. If your data contains newlines within fields the parser will
automatically be forced to use a single thread only.}

\item{progress}{Display a progress bar? By default it will only display
in an interactive session and not while executing in an RStudio notebook
chunk. The display of the progress bar can be disabled by setting the
environment variable \code{VROOM_SHOW_PROGRESS} to \code{"false"}.}

\item{show_col_types}{Control showing the column specifications. If \code{TRUE}
column specifications are always shown, if \code{FALSE} they are never shown. If
\code{NULL} (the default), they are shown only if an explicit specification is
not given in \code{col_types}, i.e. if the types have been guessed.}

\item{.name_repair}{Handling of column names. The default behaviour is to
ensure column names are \code{"unique"}. Various repair strategies are
supported:
\itemize{
\item \code{"minimal"}: No name repair or checks, beyond basic existence of names.
\item \code{"unique"} (default value): Make sure names are unique and not empty.
\item \code{"check_unique"}: No name repair, but check they are \code{unique}.
\item \code{"unique_quiet"}: Repair with the \code{unique} strategy, quietly.
\item \code{"universal"}: Make the names \code{unique} and syntactic.
\item \code{"universal_quiet"}: Repair with the \code{universal} strategy, quietly.
\item A function: Apply custom name repair (e.g., \code{name_repair = make.names}
for names in the style of base R).
\item A purrr-style anonymous function, see \code{\link[rlang:as_function]{rlang::as_function()}}.
}

This argument is passed on as \code{repair} to \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}}.
See there for more details on these terms and the strategies used
to enforce them.}

\item{col_names}{Either NULL, or a character vector column names.}

\item{n}{Number of lines the tokenizer will read to determine file structure. By default
it is set to 100.}

\item{widths}{Width of each field. Use \code{NA} as the width of the last field
when reading a ragged fixed-width file.}

\item{start, end}{Starting and ending (inclusive) positions of each field.
\strong{Positions are 1-based}: the first character in a line is at position 1.
Use \code{NA} as the last value of \code{end} when reading a ragged fixed-width
file.}

\item{...}{Named or unnamed arguments, each addressing one column. Each input
should be either a single integer (a column width) or a pair of integers
(column start and end positions). All arguments must have the same shape,
i.e. all widths or all positions.}
}
\description{
Fixed-width files store tabular data with each field occupying a specific
range of character positions in every line. Once the fields are identified,
converting them to the appropriate R types works just like for delimited
files. The unique challenge with fixed-width files is describing where each
field begins and ends. \pkg{vroom} tries to ease this pain by offering a
few different ways to specify the field structure:
\itemize{
\item \code{fwf_empty()} - Guesses based on the positions of empty columns. This is
the default. (Note that \code{fwf_empty()} returns 0-based positions, for
internal use.)
\item \code{fwf_widths()} - Supply the widths of the columns.
\item \code{fwf_positions()} - Supply paired vectors of start and end positions. These
are interpreted as 1-based positions, so are off-by-one compared to the
output of \code{fwf_empty()}.
\item \code{fwf_cols()} - Supply named arguments of paired start and end positions or
column widths.
}

Note: \code{fwf_empty()} cannot work with a connection or with any of the input
types that involve a connection internally, which includes remote and
compressed files. The reason is that this would necessitate reading from the
connection twice. In these cases, you'll have to either provide the field
structure explicitly with another \verb{fwf_*()} function or download (and
decompress, if relevant) the file first.
}
\details{
Here's a enhanced example using the contents of the file accessed via
\code{vroom_example("fwf-sample.txt")}.

\if{html}{\out{<div class="sourceCode">}}\preformatted{         1         2         3         4
123456789012345678901234567890123456789012
[     name 20      ][state 10][  ssn 12  ]
John Smith          WA        418-Y11-4111
Mary Hartford       CA        319-Z19-4341
Evan Nolan          IL        219-532-c301
}\if{html}{\out{</div>}}

Here are some valid field specifications for the above (they aren't all
equivalent! but they are all valid):

\if{html}{\out{<div class="sourceCode">}}\preformatted{fwf_widths(c(20, 10, 12), c("name", "state", "ssn"))
fwf_positions(c(1, 30), c(20, 42), c("name", "ssn"))
fwf_cols(state = c(21, 30), last = c(6, 20), first = c(1, 4), ssn = c(31, 42))
fwf_cols(name = c(1, 20), ssn = c(30, 42))
fwf_cols(name = 20, state = 10, ssn = 12)
}\if{html}{\out{</div>}}
}
\examples{
fwf_sample <- vroom_example("fwf-sample.txt")
writeLines(vroom_lines(fwf_sample))

# You can specify column positions in several ways:
# 1. Guess based on position of empty columns
vroom_fwf(fwf_sample, fwf_empty(fwf_sample, col_names = c("first", "last", "state", "ssn")))
# 2. A vector of field widths
vroom_fwf(fwf_sample, fwf_widths(c(20, 10, 12), c("name", "state", "ssn")))
# 3. Paired vectors of start and end positions
vroom_fwf(fwf_sample, fwf_positions(c(1, 30), c(20, 42), c("name", "ssn")))
# 4. Named arguments with start and end positions
vroom_fwf(fwf_sample, fwf_cols(name = c(1, 20), ssn = c(30, 42)))
# 5. Named arguments with column widths
vroom_fwf(fwf_sample, fwf_cols(name = 20, state = 10, ssn = 12))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/problems.R
\name{problems}
\alias{problems}
\title{Retrieve parsing problems}
\usage{
problems(x = .Last.value, lazy = FALSE)
}
\arguments{
\item{x}{A data frame from \code{vroom::vroom()}.}

\item{lazy}{If \code{TRUE}, just the problems found so far are returned. If
\code{FALSE} (the default) the lazy data is first read completely and all
problems are returned.}
}
\value{
A data frame with one row for each problem and four columns:
\itemize{
\item row,col - Row and column number that caused the problem, referencing the
original input
\item expected - What vroom expected to find
\item actual - What it actually found
\item file - The file with the problem
}
}
\description{
vroom will only fail to parse a file if the file is invalid in a way that is
unrecoverable. However there are a number of non-fatal problems that you
might want to know about. You can retrieve a data frame of these problems
with this function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/col_types.R
\name{cols}
\alias{cols}
\alias{col_types}
\alias{cols_only}
\alias{col_logical}
\alias{col_integer}
\alias{col_big_integer}
\alias{col_double}
\alias{col_character}
\alias{col_skip}
\alias{col_number}
\alias{col_guess}
\alias{col_factor}
\alias{col_datetime}
\alias{col_date}
\alias{col_time}
\title{Create column specification}
\usage{
cols(..., .default = col_guess(), .delim = NULL)

cols_only(...)

col_logical(...)

col_integer(...)

col_big_integer(...)

col_double(...)

col_character(...)

col_skip(...)

col_number(...)

col_guess(...)

col_factor(levels = NULL, ordered = FALSE, include_na = FALSE, ...)

col_datetime(format = "", ...)

col_date(format = "", ...)

col_time(format = "", ...)
}
\arguments{
\item{...}{Either column objects created by \verb{col_*()}, or their abbreviated
character names (as described in the \code{col_types} argument of
\code{\link[=vroom]{vroom()}}). If you're only overriding a few columns, it's
best to refer to columns by name. If not named, the column types must match
the column names exactly. In \verb{col_*()} functions these are stored in the
object.}

\item{.default}{Any named columns not explicitly overridden in \code{...}
will be read with this column type.}

\item{.delim}{The delimiter to use when parsing. If the \code{delim} argument
used in the call to \code{vroom()} it takes precedence over the one specified in
\code{col_types}.}

\item{levels}{Character vector of the allowed levels. When \code{levels = NULL}
(the default), \code{levels} are discovered from the unique values of the data,
in the order in which they are encountered.}

\item{ordered}{Is it an ordered factor?}

\item{include_na}{If \code{TRUE} and the data contains at least one \code{NA}, then
\code{NA} is included in the levels of the constructed factor.}

\item{format}{A format specification. If set to "":
\itemize{
\item \code{col_datetime()} expects ISO8601 datetimes. Here are some examples of
input that should just work:
"2024-01-15", "2024-01-15 14:30:00", "2024-01-15T14:30:00Z".
\item \code{col_date()} uses the \code{date_format} from \code{\link[=locale]{locale()}} (default \code{"\%AD"}).
These inputs should just work: "2024-01-15", "01/15/2024".
\item \code{col_time()} uses the \code{time_format} from \code{\link[=locale]{locale()}} (default \code{"\%AT"}).
These inputs should just work: "14:30:00", "2:30:00 PM".
}

Unlike \code{\link[=strptime]{strptime()}}, the format specification must match the complete
string. For more details, see below.}
}
\description{
\code{cols()} includes all columns in the input data, guessing the column types
as the default. \code{cols_only()} includes only the columns you explicitly
specify, skipping the rest.
}
\details{
The available specifications are: (long names in quotes and string abbreviations in brackets)\tabular{llll}{
   function \tab long name \tab short name \tab description \cr
   \code{col_logical()} \tab "logical" \tab "l" \tab Logical values containing only \code{T}, \code{F}, \code{TRUE} or \code{FALSE}. \cr
   \code{col_integer()} \tab "integer" \tab "i" \tab Integer numbers. \cr
   \code{col_big_integer()} \tab "big_integer" \tab "I" \tab Big Integers (64bit), requires the \code{bit64} package. \cr
   \code{col_double()} \tab "double", "numeric" \tab "d" \tab 64-bit double floating point numbers. \cr
   \code{col_character()} \tab "character" \tab "c" \tab Character string data. \cr
   \code{col_factor(levels, ordered)} \tab "factor" \tab "f" \tab A fixed set of values. \cr
   \code{col_date(format = "")} \tab "date" \tab "D" \tab Calendar dates formatted with the locale's \code{date_format}. \cr
   \code{col_time(format = "")} \tab "time" \tab "t" \tab Times formatted with the locale's \code{time_format}. \cr
   \code{col_datetime(format = "")} \tab "datetime", "POSIXct" \tab "T" \tab ISO8601 date times. \cr
   \code{col_number()} \tab "number" \tab "n" \tab Human readable numbers containing the \code{grouping_mark} \cr
   \code{col_skip()} \tab "skip", "NULL" \tab "_", "-" \tab Skip and don't import this column. \cr
   \code{col_guess()} \tab "guess", "NA" \tab "?" \tab Parse using the "best" guessed type based on the input. \cr
}

\subsection{Date, time, and datetime formats:}{

\pkg{vroom} uses a format specification similar to \code{\link[=strptime]{strptime()}}.
There are three types of element:
\enumerate{
\item A conversion specification that is "\%" followed by a letter. For example
"\%Y" matches a 4 digit year, "\%m", matches a 2 digit month and "\%d" matches
a 2 digit day. Month and day default to \code{1}, (i.e. Jan 1st) if not present,
for example if only a year is given.
\item Whitespace is any sequence of zero or more whitespace characters.
\item Any other character is matched exactly.
}

\pkg{vroom}'s datetime \verb{col_*()} functions recognize the following
specifications:
\itemize{
\item Year: "\%Y" (4 digits). "\%y" (2 digits); 00-69 -> 2000-2069, 70-99 ->
1970-1999.
\item Month: "\%m" (2 digits), "\%b" (abbreviated name in current locale), "\%B"
(full name in current locale).
\item Day: "\%d" (2 digits), "\%e" (optional leading space), "\%a" (abbreviated
name in current locale).
\item Hour: "\%H" or "\%I" or "\%h", use I (and not H) with AM/PM, use h (and not H)
if your times represent durations longer than one day.
\item Minutes: "\%M"
\item Seconds: "\%S" (integer seconds), "\%OS" (partial seconds)
\item Time zone: "\%Z" (as name, e.g. "America/Chicago"), "\%z" (as offset from
UTC, e.g. "+0800")
\item AM/PM indicator: "\%p".
\item Non-digits: "\%." skips one non-digit character, "\%+" skips one or more
non-digit characters, "\%*" skips any number of non-digits characters.
\item Automatic parsers: "\%AD" parses with a flexible YMD parser, "\%AT" parses
with a flexible HMS parser.
\item Shortcuts: "\%D" = "\%m/\%d/\%y", "\%F" = "\%Y-\%m-\%d", "\%R" = "\%H:\%M", "\%T" =
"\%H:\%M:\%S", "\%x" = "\%y/\%m/\%d".
}
\subsection{ISO8601 support}{

Currently, vroom does not support all of ISO8601. Missing features:
\itemize{
\item Week & weekday specifications, e.g. "2013-W05", "2013-W05-10".
\item Ordinal dates, e.g. "2013-095".
\item Using commas instead of a period for decimal separator.
}

The parser is also a little laxer than ISO8601:
\itemize{
\item Dates and times can be separated with a space, not just T.
\item Mostly correct specifications like "2009-05-19 14:" and "200912-01" work.
}
}

}
}
\examples{
cols(a = col_integer())
cols_only(a = col_integer())

# You can also use the standard abbreviations
cols(a = "i")
cols(a = "i", b = "d", c = "_")

# Or long names (like utils::read.csv)
cols(a = "integer", b = "double", c = "skip")

# You can also use multiple sets of column definitions by combining
# them like so:

t1 <- cols(
  column_one = col_integer(),
  column_two = col_number())

t2 <- cols(
 column_three = col_character())

t3 <- t1
t3$cols <- c(t1$cols, t2$cols)
t3
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom_write.R
\name{output_column}
\alias{output_column}
\title{Preprocess column for output}
\usage{
output_column(x)
}
\arguments{
\item{x}{A vector}
}
\description{
This is a generic function that applied to each column before it is saved
to disk. It provides a hook for S3 classes that need special handling.
}
\examples{
# Most types are returned unchanged
output_column(1)
output_column("x")

# datetimes are formatted in ISO 8601
output_column(Sys.Date())
output_column(Sys.time())
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom.R
\name{vroom}
\alias{vroom}
\title{Read a delimited file into a tibble}
\usage{
vroom(
  file,
  delim = NULL,
  col_names = TRUE,
  col_types = NULL,
  col_select = NULL,
  id = NULL,
  skip = 0,
  n_max = Inf,
  na = c("", "NA"),
  quote = "\\"",
  comment = "",
  skip_empty_rows = TRUE,
  trim_ws = TRUE,
  escape_double = TRUE,
  escape_backslash = FALSE,
  locale = default_locale(),
  guess_max = 100,
  altrep = TRUE,
  num_threads = vroom_threads(),
  progress = vroom_progress(),
  show_col_types = NULL,
  .name_repair = "unique"
)
}
\arguments{
\item{file}{Either a path to a file, a connection, or literal data (either a
single string or a raw vector). \code{file} can also be a character vector
containing multiple filepaths or a list containing multiple connections.

Files ending in \code{.gz}, \code{.bz2}, \code{.xz}, or \code{.zip} will be automatically
decompressed. Files starting with \verb{http://}, \verb{https://}, \verb{ftp://}, or
\verb{ftps://} will be automatically downloaded. Remote compressed files
(\code{.gz}, \code{.bz2}, \code{.xz}, \code{.zip}) will be automatically downloaded and
decompressed.

Literal data is most useful for examples and tests. To be recognised as
literal data, wrap the input with \code{I()}.}

\item{delim}{One or more characters used to delimit fields within a
file. If \code{NULL} the delimiter is guessed from the set of \code{c(",", "\\t", " ", "|", ":", ";")}.}

\item{col_names}{Either \code{TRUE}, \code{FALSE} or a character vector
of column names.

If \code{TRUE}, the first row of the input will be used as the column
names, and will not be included in the data frame. If \code{FALSE}, column
names will be generated automatically: X1, X2, X3 etc.

If \code{col_names} is a character vector, the values will be used as the
names of the columns, and the first row of the input will be read into
the first row of the output data frame.

Missing (\code{NA}) column names will generate a warning, and be filled
in with dummy names \code{...1}, \code{...2} etc. Duplicate column names
will generate a warning and be made unique, see \code{name_repair} to control
how this is done.}

\item{col_types}{One of \code{NULL}, a \code{\link[=cols]{cols()}} specification, or
a string.

If \code{NULL}, all column types will be inferred from \code{guess_max} rows
of the input, interspersed throughout the file. This is convenient (and
fast), but not robust. If the guessed types are wrong, you'll need to
increase \code{guess_max} or supply the correct types yourself.

Column specifications created by \code{\link[=list]{list()}} or \code{\link[=cols]{cols()}} must contain
one column specification for each column. If you only want to read a
subset of the columns, use \code{\link[=cols_only]{cols_only()}}.

Alternatively, you can use a compact string representation where each
character represents one column:
\itemize{
\item c = character
\item i = integer
\item I = big integer
\item n = number
\item d = double
\item l = logical
\item f = factor
\item D = date
\item T = date time
\item t = time
\item ? = guess
\item _ or - = skip
}

By default, reading a file without a column specification will print a
message showing the guessed types. To suppress this message, set
\code{show_col_types = FALSE}.}

\item{col_select}{Columns to include in the results. You can use the same
mini-language as \code{dplyr::select()} to refer to the columns by name. Use
\code{c()} to use more than one selection expression. Although this
usage is less common, \code{col_select} also accepts a numeric column index. See
\code{\link[tidyselect:language]{?tidyselect::language}} for full details on the
selection language.}

\item{id}{Either a string or 'NULL'. If a string, the output will contain a
column with that name with the filename(s) as the value, i.e. this column
effectively tells you the source of each row. If 'NULL' (the default), no
such column will be created.}

\item{skip}{Number of lines to skip before reading data. If \code{comment} is
supplied any commented lines are ignored \emph{after} skipping.}

\item{n_max}{Maximum number of lines to read.}

\item{na}{Character vector of strings to interpret as missing values. Set this
option to \code{character()} to indicate no missing values.}

\item{quote}{Single character used to quote strings.}

\item{comment}{A string used to identify comments. Any text after the
comment characters will be silently ignored.}

\item{skip_empty_rows}{Should blank rows be ignored altogether? i.e. If this
option is \code{TRUE} then blank rows will not be represented at all.  If it is
\code{FALSE} then they will be represented by \code{NA} values in all the columns.}

\item{trim_ws}{Should leading and trailing whitespace (ASCII spaces and tabs) be trimmed from
each field before parsing it?}

\item{escape_double}{Does the file escape quotes by doubling them?
i.e. If this option is \code{TRUE}, the value '""' represents
a single quote, '"'.}

\item{escape_backslash}{Does the file use backslashes to escape special
characters? This is more general than \code{escape_double} as backslashes
can be used to escape the delimiter character, the quote character, or
to add special characters like \verb{\\\\n}.}

\item{locale}{The locale controls defaults that vary from place to place.
The default locale is US-centric (like R), but you can use
\code{\link[=locale]{locale()}} to create your own locale that controls things like
the default time zone, encoding, decimal mark, big mark, and day/month
names.}

\item{guess_max}{Maximum number of lines to use for guessing column types.
See \code{vignette("column-types", package = "readr")} for more details.}

\item{altrep}{Control which column types use Altrep representations,
either a character vector of types, \code{TRUE} or \code{FALSE}. See
\code{\link[=vroom_altrep]{vroom_altrep()}} for for full details.}

\item{num_threads}{Number of threads to use when reading and materializing
vectors. If your data contains newlines within fields the parser will
automatically be forced to use a single thread only.}

\item{progress}{Display a progress bar? By default it will only display
in an interactive session and not while executing in an RStudio notebook
chunk. The display of the progress bar can be disabled by setting the
environment variable \code{VROOM_SHOW_PROGRESS} to \code{"false"}.}

\item{show_col_types}{Control showing the column specifications. If \code{TRUE}
column specifications are always shown, if \code{FALSE} they are never shown. If
\code{NULL} (the default), they are shown only if an explicit specification is
not given in \code{col_types}, i.e. if the types have been guessed.}

\item{.name_repair}{Handling of column names. The default behaviour is to
ensure column names are \code{"unique"}. Various repair strategies are
supported:
\itemize{
\item \code{"minimal"}: No name repair or checks, beyond basic existence of names.
\item \code{"unique"} (default value): Make sure names are unique and not empty.
\item \code{"check_unique"}: No name repair, but check they are \code{unique}.
\item \code{"unique_quiet"}: Repair with the \code{unique} strategy, quietly.
\item \code{"universal"}: Make the names \code{unique} and syntactic.
\item \code{"universal_quiet"}: Repair with the \code{universal} strategy, quietly.
\item A function: Apply custom name repair (e.g., \code{name_repair = make.names}
for names in the style of base R).
\item A purrr-style anonymous function, see \code{\link[rlang:as_function]{rlang::as_function()}}.
}

This argument is passed on as \code{repair} to \code{\link[vctrs:vec_as_names]{vctrs::vec_as_names()}}.
See there for more details on these terms and the strategies used
to enforce them.}
}
\description{
Read a delimited file into a tibble
}
\examples{
# get path to example file
input_file <- vroom_example("mtcars.csv")
input_file

# Read from a path

# Input sources -------------------------------------------------------------
# Read from a path
vroom(input_file)
# You can also use paths directly
# vroom("mtcars.csv")

\dontrun{
# Including remote paths
vroom("https://github.com/tidyverse/vroom/raw/main/inst/extdata/mtcars.csv")
}

# Or directly from a string with `I()`
vroom(I("x,y\n1,2\n3,4\n"))

# Column selection ----------------------------------------------------------
# Pass column names or indexes directly to select them
vroom(input_file, col_select = c(model, cyl, gear))
vroom(input_file, col_select = c(1, 3, 11))

# Or use the selection helpers
vroom(input_file, col_select = starts_with("d"))

# You can also rename specific columns
vroom(input_file, col_select = c(car = model, everything()))

# Column types --------------------------------------------------------------
# By default, vroom guesses the columns types, looking at 1000 rows
# throughout the dataset.
# You can specify them explicitly with a compact specification:
vroom(I("x,y\n1,2\n3,4\n"), col_types = "dc")

# Or with a list of column types:
vroom(I("x,y\n1,2\n3,4\n"), col_types = list(col_double(), col_character()))

# File types ----------------------------------------------------------------
# csv
vroom(I("a,b\n1.0,2.0\n"), delim = ",")
# tsv
vroom(I("a\tb\n1.0\t2.0\n"))
# Other delimiters
vroom(I("a|b\n1.0|2.0\n"), delim = "|")

# Read datasets across multiple files ---------------------------------------
mtcars_by_cyl <- vroom_example(vroom_examples("mtcars-[468]"))
mtcars_by_cyl

# Pass the filenames directly to vroom, they are efficiently combined
vroom(mtcars_by_cyl)

# If you need to extract data from the filenames, use `id` to request a
# column that reveals the underlying file path
dat <- vroom(mtcars_by_cyl, id = "source")
dat$source <- basename(dat$source)
dat
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generator.R
\name{generators}
\alias{generators}
\alias{gen_character}
\alias{gen_double}
\alias{gen_number}
\alias{gen_integer}
\alias{gen_factor}
\alias{gen_time}
\alias{gen_date}
\alias{gen_datetime}
\alias{gen_logical}
\alias{gen_name}
\title{Generate individual vectors of the types supported by vroom}
\usage{
gen_character(n, min = 5, max = 25, values = c(letters, LETTERS, 0:9), ...)

gen_double(n, f = stats::rnorm, ...)

gen_number(n, f = stats::rnorm, ...)

gen_integer(n, min = 1L, max = .Machine$integer.max, prob = NULL, ...)

gen_factor(
  n,
  levels = NULL,
  ordered = FALSE,
  num_levels = gen_integer(1L, 1L, 25L),
  ...
)

gen_time(n, min = 0, max = hms::hms(days = 1), fractional = FALSE, ...)

gen_date(n, min = as.Date("2001-01-01"), max = as.Date("2021-01-01"), ...)

gen_datetime(
  n,
  min = as.POSIXct("2001-01-01"),
  max = as.POSIXct("2021-01-01"),
  tz = "UTC",
  ...
)

gen_logical(n, ...)

gen_name(n)
}
\arguments{
\item{n}{The size of the vector to generate}

\item{min}{The minimum range for the vector}

\item{max}{The maximum range for the vector}

\item{values}{The explicit values to use.}

\item{...}{Additional arguments passed to internal generation functions}

\item{f}{The random function to use.}

\item{prob}{a vector of probability weights for obtaining the elements
    of the vector being sampled.}

\item{levels}{The explicit levels to use, if \code{NULL} random levels are generated using \code{\link[=gen_name]{gen_name()}}.}

\item{ordered}{Should the factors be ordered factors?}

\item{num_levels}{The number of factor levels to generate}

\item{fractional}{Whether to generate times with fractional seconds}

\item{tz}{The timezone to use for dates}
}
\description{
Generate individual vectors of the types supported by vroom
}
\examples{
# characters
gen_character(4)

# factors
gen_factor(4)

# logical
gen_logical(4)

# numbers
gen_double(4)
gen_integer(4)

# temporal data
gen_time(4)
gen_date(4)
gen_datetime(4)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example.R
\name{vroom_example}
\alias{vroom_example}
\alias{vroom_examples}
\title{Get path to vroom examples}
\usage{
vroom_example(path)

vroom_examples(pattern = NULL)
}
\arguments{
\item{path}{Name of file.}

\item{pattern}{A regular expression of filenames to match. If \code{NULL}, all
available files are returned.}
}
\description{
vroom comes bundled with a number of sample files in
its 'inst/extdata' directory. Use \code{vroom_examples()} to list all the
available examples and \code{vroom_example()} to retrieve the path to one
example.
}
\examples{
# List all available examples
vroom_examples()

# Get path to one example
vroom_example("mtcars.csv")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom_write.R
\name{vroom_write_lines}
\alias{vroom_write_lines}
\title{Write lines to a file}
\usage{
vroom_write_lines(
  x,
  file,
  eol = "\\n",
  na = "NA",
  append = FALSE,
  num_threads = vroom_threads()
)
}
\arguments{
\item{x}{A character vector.}

\item{file}{File or connection to write to.}

\item{eol}{The end of line character to use. Most commonly either \code{"\\n"} for
Unix style newlines, or \code{"\\r\\n"} for Windows style newlines.}

\item{na}{String used for missing values. Defaults to 'NA'.}

\item{append}{If \code{FALSE}, will overwrite existing file. If \code{TRUE},
will append to existing file. In both cases, if the file does not exist, a
new file is created.}

\item{num_threads}{Number of threads to use when reading and materializing
vectors. If your data contains newlines within fields the parser will
automatically be forced to use a single thread only.}
}
\description{
Write lines to a file
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vroom_lines.R
\name{vroom_lines}
\alias{vroom_lines}
\title{Read lines from a file}
\usage{
vroom_lines(
  file,
  n_max = Inf,
  skip = 0,
  na = character(),
  skip_empty_rows = FALSE,
  locale = default_locale(),
  altrep = TRUE,
  num_threads = vroom_threads(),
  progress = vroom_progress()
)
}
\arguments{
\item{file}{Either a path to a file, a connection, or literal data (either a
single string or a raw vector). \code{file} can also be a character vector
containing multiple filepaths or a list containing multiple connections.

Files ending in \code{.gz}, \code{.bz2}, \code{.xz}, or \code{.zip} will be automatically
decompressed. Files starting with \verb{http://}, \verb{https://}, \verb{ftp://}, or
\verb{ftps://} will be automatically downloaded. Remote compressed files
(\code{.gz}, \code{.bz2}, \code{.xz}, \code{.zip}) will be automatically downloaded and
decompressed.

Literal data is most useful for examples and tests. To be recognised as
literal data, wrap the input with \code{I()}.}

\item{n_max}{Maximum number of lines to read.}

\item{skip}{Number of lines to skip before reading data. If \code{comment} is
supplied any commented lines are ignored \emph{after} skipping.}

\item{na}{Character vector of strings to interpret as missing values. Set this
option to \code{character()} to indicate no missing values.}

\item{skip_empty_rows}{Should blank rows be ignored altogether? i.e. If this
option is \code{TRUE} then blank rows will not be represented at all.  If it is
\code{FALSE} then they will be represented by \code{NA} values in all the columns.}

\item{locale}{The locale controls defaults that vary from place to place.
The default locale is US-centric (like R), but you can use
\code{\link[=locale]{locale()}} to create your own locale that controls things like
the default time zone, encoding, decimal mark, big mark, and day/month
names.}

\item{altrep}{Control which column types use Altrep representations,
either a character vector of types, \code{TRUE} or \code{FALSE}. See
\code{\link[=vroom_altrep]{vroom_altrep()}} for for full details.}

\item{num_threads}{Number of threads to use when reading and materializing
vectors. If your data contains newlines within fields the parser will
automatically be forced to use a single thread only.}

\item{progress}{Display a progress bar? By default it will only display
in an interactive session and not while executing in an RStudio notebook
chunk. The display of the progress bar can be disabled by setting the
environment variable \code{VROOM_SHOW_PROGRESS} to \code{"false"}.}
}
\description{
\code{vroom_lines()} is similar to \code{readLines()}, however it reads the lines
lazily like \code{\link[=vroom]{vroom()}}, so operations like \code{length()}, \code{head()}, \code{tail()} and \code{sample()}
can be done much more efficiently without reading all the data into R.
}
\examples{
lines <- vroom_lines(vroom_example("mtcars.csv"))

length(lines)
head(lines, n = 2)
tail(lines, n = 2)
sample(lines, size = 2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/altrep.R
\name{vroom_str}
\alias{vroom_str}
\title{Structure of objects}
\usage{
vroom_str(x)
}
\arguments{
\item{x}{a vector}
}
\description{
Similar to \code{str()} but with more information for Altrep objects.
}
\examples{
# when used on non-altrep objects altrep will always be false
vroom_str(mtcars)

mt <- vroom(vroom_example("mtcars.csv"), ",", altrep = c("chr", "dbl"))
vroom_str(mt)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/col_types.R
\name{guess_type}
\alias{guess_type}
\title{Guess the type of a vector}
\usage{
guess_type(
  x,
  na = c("", "NA"),
  locale = default_locale(),
  guess_integer = FALSE
)
}
\arguments{
\item{x}{Character vector of values to parse.}

\item{na}{Character vector of strings to interpret as missing values. Set this
option to \code{character()} to indicate no missing values.}

\item{locale}{The locale controls defaults that vary from place to place.
The default locale is US-centric (like R), but you can use
\code{\link[=locale]{locale()}} to create your own locale that controls things like
the default time zone, encoding, decimal mark, big mark, and day/month
names.}

\item{guess_integer}{If \code{TRUE}, guess integer types for whole numbers, if
\code{FALSE} guess numeric type for all numbers.}
}
\description{
Guess the type of a vector
}
\examples{
 # Logical vectors
 guess_type(c("FALSE", "TRUE", "F", "T"))
 # Integers and doubles
 guess_type(c("1","2","3"))
 guess_type(c("1.6","2.6","3.4"))
 # Numbers containing grouping mark
 guess_type("1,234,566")
 # ISO 8601 date times
 guess_type(c("2010-10-10"))
 guess_type(c("2010-10-10 01:02:03"))
 guess_type(c("01:02:03 AM"))
}
